/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.48.0-dev-20240422(8503aef01e4f06dff414c15904a1d961e25eb8eb)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var X=["require","exports","vs/editor/common/core/range","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/errors","vs/base/common/strings","vs/base/common/arrays","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/arraysFind","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/nls","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/map","vs/base/common/stopwatch","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/base/common/cache","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cancellation","vs/base/common/hash","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/findSectionHeaders","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],Z=function(O){for(var n=[],r=0,x=O.length;r<x;r++)n[r]=X[O[r]];return n};const Re=this,Ae=typeof global=="object"?global:{};var ue;(function(O){O.global=Re;class n{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=n._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof O.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}O.Environment=n})(ue||(ue={}));var ue;(function(O){class n{constructor(g,m,v){this.type=g,this.detail=m,this.timestamp=v}}O.LoaderEvent=n;class r{constructor(g){this._events=[new n(1,"",g)]}record(g,m){this._events.push(new n(g,m,O.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}O.LoaderEventRecorder=r;class x{record(g,m){}getEvents(){return[]}}x.INSTANCE=new x,O.NullLoaderEventRecorder=x})(ue||(ue={}));var ue;(function(O){class n{static fileUriToFilePath(x,M){if(M=decodeURI(M).replace(/%23/g,"#"),x){if(/^file:\/\/\//.test(M))return M.substr(8);if(/^file:\/\//.test(M))return M.substr(5)}else if(/^file:\/\//.test(M))return M.substr(7);return M}static startsWith(x,M){return x.length>=M.length&&x.substr(0,M.length)===M}static endsWith(x,M){return x.length>=M.length&&x.substr(x.length-M.length)===M}static containsQueryString(x){return/^[^\#]*\?/gi.test(x)}static isAbsolutePath(x){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(x)}static forEachProperty(x,M){if(x){let g;for(g in x)x.hasOwnProperty(g)&&M(g,x[g])}}static isEmpty(x){let M=!0;return n.forEachProperty(x,()=>{M=!1}),M}static recursiveClone(x){if(!x||typeof x!="object"||x instanceof RegExp||!Array.isArray(x)&&Object.getPrototypeOf(x)!==Object.prototype)return x;let M=Array.isArray(x)?[]:{};return n.forEachProperty(x,(g,m)=>{m&&typeof m=="object"?M[g]=n.recursiveClone(m):M[g]=m}),M}static generateAnonymousModule(){return"===anonymous"+n.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(x){return n.startsWith(x,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=O.global.performance&&typeof O.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?O.global.performance.now():Date.now()}}n.NEXT_ANONYMOUS_ID=1,n.PERFORMANCE_NOW_PROBED=!1,n.HAS_PERFORMANCE_NOW=!1,O.Utilities=n})(ue||(ue={}));var ue;(function(O){function n(M){if(M instanceof Error)return M;const g=new Error(M.message||String(M)||"Unknown Error");return M.stack&&(g.stack=M.stack),g}O.ensureError=n;class r{static validateConfigurationOptions(g){function m(v){if(v.phase==="loading"){console.error('Loading "'+v.moduleId+'" failed'),console.error(v),console.error("Here are the modules that depend on it:"),console.error(v.neededBy);return}if(v.phase==="factory"){console.error('The factory function of "'+v.moduleId+'" has thrown an exception'),console.error(v),console.error("Here are the modules that depend on it:"),console.error(v.neededBy);return}}if(g=g||{},typeof g.baseUrl!="string"&&(g.baseUrl=""),typeof g.isBuild!="boolean"&&(g.isBuild=!1),typeof g.paths!="object"&&(g.paths={}),typeof g.config!="object"&&(g.config={}),typeof g.catchError>"u"&&(g.catchError=!1),typeof g.recordStats>"u"&&(g.recordStats=!1),typeof g.urlArgs!="string"&&(g.urlArgs=""),typeof g.onError!="function"&&(g.onError=m),Array.isArray(g.ignoreDuplicateModules)||(g.ignoreDuplicateModules=[]),g.baseUrl.length>0&&(O.Utilities.endsWith(g.baseUrl,"/")||(g.baseUrl+="/")),typeof g.cspNonce!="string"&&(g.cspNonce=""),typeof g.preferScriptTags>"u"&&(g.preferScriptTags=!1),g.nodeCachedData&&typeof g.nodeCachedData=="object"&&(typeof g.nodeCachedData.seed!="string"&&(g.nodeCachedData.seed="seed"),(typeof g.nodeCachedData.writeDelay!="number"||g.nodeCachedData.writeDelay<0)&&(g.nodeCachedData.writeDelay=1e3*7),!g.nodeCachedData.path||typeof g.nodeCachedData.path!="string")){const v=n(new Error("INVALID cached data configuration, 'path' MUST be set"));v.phase="configuration",g.onError(v),g.nodeCachedData=void 0}return g}static mergeConfigurationOptions(g=null,m=null){let v=O.Utilities.recursiveClone(m||{});return O.Utilities.forEachProperty(g,(o,a)=>{o==="ignoreDuplicateModules"&&typeof v.ignoreDuplicateModules<"u"?v.ignoreDuplicateModules=v.ignoreDuplicateModules.concat(a):o==="paths"&&typeof v.paths<"u"?O.Utilities.forEachProperty(a,(b,e)=>v.paths[b]=e):o==="config"&&typeof v.config<"u"?O.Utilities.forEachProperty(a,(b,e)=>v.config[b]=e):v[o]=O.Utilities.recursiveClone(a)}),r.validateConfigurationOptions(v)}}O.ConfigurationOptionsUtil=r;class x{constructor(g,m){if(this._env=g,this.options=r.mergeConfigurationOptions(m),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let v=this.options.nodeRequire.main.filename,o=Math.max(v.lastIndexOf("/"),v.lastIndexOf("\\"));this.options.baseUrl=v.substring(0,o+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let g=0;g<this.options.ignoreDuplicateModules.length;g++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[g]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],O.Utilities.forEachProperty(this.options.paths,(g,m)=>{Array.isArray(m)?this.sortedPathsRules.push({from:g,to:m}):this.sortedPathsRules.push({from:g,to:[m]})}),this.sortedPathsRules.sort((g,m)=>m.from.length-g.from.length)}cloneAndMerge(g){return new x(this._env,r.mergeConfigurationOptions(g,this.options))}getOptionsLiteral(){return this.options}_applyPaths(g){let m;for(let v=0,o=this.sortedPathsRules.length;v<o;v++)if(m=this.sortedPathsRules[v],O.Utilities.startsWith(g,m.from)){let a=[];for(let b=0,e=m.to.length;b<e;b++)a.push(m.to[b]+g.substr(m.from.length));return a}return[g]}_addUrlArgsToUrl(g){return O.Utilities.containsQueryString(g)?g+"&"+this.options.urlArgs:g+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(g){return this.options.urlArgs?this._addUrlArgsToUrl(g):g}_addUrlArgsIfNecessaryToUrls(g){if(this.options.urlArgs)for(let m=0,v=g.length;m<v;m++)g[m]=this._addUrlArgsToUrl(g[m]);return g}moduleIdToPaths(g){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(g))return this.isBuild()?["empty:"]:["node|"+g];let m=g,v;if(!O.Utilities.endsWith(m,".js")&&!O.Utilities.isAbsolutePath(m)){v=this._applyPaths(m);for(let o=0,a=v.length;o<a;o++)this.isBuild()&&v[o]==="empty:"||(O.Utilities.isAbsolutePath(v[o])||(v[o]=this.options.baseUrl+v[o]),!O.Utilities.endsWith(v[o],".js")&&!O.Utilities.containsQueryString(v[o])&&(v[o]=v[o]+".js"))}else!O.Utilities.endsWith(m,".js")&&!O.Utilities.containsQueryString(m)&&(m=m+".js"),v=[m];return this._addUrlArgsIfNecessaryToUrls(v)}requireToUrl(g){let m=g;return O.Utilities.isAbsolutePath(m)||(m=this._applyPaths(m)[0],O.Utilities.isAbsolutePath(m)||(m=this.options.baseUrl+m)),this._addUrlArgsIfNecessaryToUrl(m)}isBuild(){return this.options.isBuild}shouldInvokeFactory(g){return!!(!this.options.isBuild||O.Utilities.isAnonymousModule(g)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[g])}isDuplicateMessageIgnoredFor(g){return this.ignoreDuplicateModulesMap.hasOwnProperty(g)}getConfigForModule(g){if(this.options.config)return this.options.config[g]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(g){this.options.onError(g)}}O.Configuration=x})(ue||(ue={}));var ue;(function(O){class n{constructor(a){this._env=a,this._scriptLoader=null,this._callbackMap={}}load(a,b,e,f){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new M;else if(this._env.isElectronRenderer){const{preferScriptTags:u}=a.getConfig().getOptionsLiteral();u?this._scriptLoader=new r:this._scriptLoader=new g(this._env)}else this._env.isNode?this._scriptLoader=new g(this._env):this._scriptLoader=new r;let s={callback:e,errorback:f};if(this._callbackMap.hasOwnProperty(b)){this._callbackMap[b].push(s);return}this._callbackMap[b]=[s],this._scriptLoader.load(a,b,()=>this.triggerCallback(b),u=>this.triggerErrorback(b,u))}triggerCallback(a){let b=this._callbackMap[a];delete this._callbackMap[a];for(let e=0;e<b.length;e++)b[e].callback()}triggerErrorback(a,b){let e=this._callbackMap[a];delete this._callbackMap[a];for(let f=0;f<e.length;f++)e[f].errorback(b)}}class r{attachListeners(a,b,e){let f=()=>{a.removeEventListener("load",s),a.removeEventListener("error",u)},s=d=>{f(),b()},u=d=>{f(),e(d)};a.addEventListener("load",s),a.addEventListener("error",u)}load(a,b,e,f){if(/^node\|/.test(b)){let s=a.getConfig().getOptionsLiteral(),u=m(a.getRecorder(),s.nodeRequire||O.global.nodeRequire),d=b.split("|"),h=null;try{h=u(d[1])}catch(S){f(S);return}a.enqueueDefineAnonymousModule([],()=>h),e()}else{let s=document.createElement("script");s.setAttribute("async","async"),s.setAttribute("type","text/javascript"),this.attachListeners(s,e,f);const{trustedTypesPolicy:u}=a.getConfig().getOptionsLiteral();u&&(b=u.createScriptURL(b)),s.setAttribute("src",b);const{cspNonce:d}=a.getConfig().getOptionsLiteral();d&&s.setAttribute("nonce",d),document.getElementsByTagName("head")[0].appendChild(s)}}}function x(o){const{trustedTypesPolicy:a}=o.getConfig().getOptionsLiteral();try{return(a?self.eval(a.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class M{constructor(){this._cachedCanUseEval=null}_canUseEval(a){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=x(a)),this._cachedCanUseEval}load(a,b,e,f){if(/^node\|/.test(b)){const s=a.getConfig().getOptionsLiteral(),u=m(a.getRecorder(),s.nodeRequire||O.global.nodeRequire),d=b.split("|");let h=null;try{h=u(d[1])}catch(S){f(S);return}a.enqueueDefineAnonymousModule([],function(){return h}),e()}else{const{trustedTypesPolicy:s}=a.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(b)&&b.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(a)){fetch(b).then(d=>{if(d.status!==200)throw new Error(d.statusText);return d.text()}).then(d=>{d=`${d}
//# sourceURL=${b}`,(s?self.eval(s.createScript("",d)):new Function(d)).call(self),e()}).then(void 0,f);return}try{s&&(b=s.createScriptURL(b)),importScripts(b),e()}catch(d){f(d)}}}}class g{constructor(a){this._env=a,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(a){this._didInitialize||(this._didInitialize=!0,this._fs=a("fs"),this._vm=a("vm"),this._path=a("path"),this._crypto=a("crypto"))}_initNodeRequire(a,b){const{nodeCachedData:e}=b.getConfig().getOptionsLiteral();if(!e||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const f=this,s=a("module");function u(d){const h=d.constructor;let S=function(E){try{return d.require(E)}finally{}};return S.resolve=function(E,A){return h._resolveFilename(E,d,!1,A)},S.resolve.paths=function(E){return h._resolveLookupPaths(E,d)},S.main=process.mainModule,S.extensions=h._extensions,S.cache=h._cache,S}s.prototype._compile=function(d,h){const S=s.wrap(d.replace(/^#!.*/,"")),_=b.getRecorder(),E=f._getCachedDataPath(e,h),A={filename:h};let p;try{const N=f._fs.readFileSync(E);p=N.slice(0,16),A.cachedData=N.slice(16),_.record(60,E)}catch{_.record(61,E)}const i=new f._vm.Script(S,A),l=i.runInThisContext(A),c=f._path.dirname(h),L=u(this),w=[this.exports,L,this,h,c,process,Ae,Buffer],C=l.apply(this.exports,w);return f._handleCachedData(i,S,E,!A.cachedData,b),f._verifyCachedData(i,S,E,p,b),C}}load(a,b,e,f){const s=a.getConfig().getOptionsLiteral(),u=m(a.getRecorder(),s.nodeRequire||O.global.nodeRequire),d=s.nodeInstrumenter||function(S){return S};this._init(u),this._initNodeRequire(u,a);let h=a.getRecorder();if(/^node\|/.test(b)){let S=b.split("|"),_=null;try{_=u(S[1])}catch(E){f(E);return}a.enqueueDefineAnonymousModule([],()=>_),e()}else{b=O.Utilities.fileUriToFilePath(this._env.isWindows,b);const S=this._path.normalize(b),_=this._getElectronRendererScriptPathOrUri(S),E=!!s.nodeCachedData,A=E?this._getCachedDataPath(s.nodeCachedData,b):void 0;this._readSourceAndCachedData(S,A,h,(p,i,l,c)=>{if(p){f(p);return}let L;i.charCodeAt(0)===g._BOM?L=g._PREFIX+i.substring(1)+g._SUFFIX:L=g._PREFIX+i+g._SUFFIX,L=d(L,S);const w={filename:_,cachedData:l},C=this._createAndEvalScript(a,L,w,e,f);this._handleCachedData(C,L,A,E&&!l,a),this._verifyCachedData(C,L,A,c,a)})}}_createAndEvalScript(a,b,e,f,s){const u=a.getRecorder();u.record(31,e.filename);const d=new this._vm.Script(b,e),h=d.runInThisContext(e),S=a.getGlobalAMDDefineFunc();let _=!1;const E=function(){return _=!0,S.apply(null,arguments)};return E.amd=S.amd,h.call(O.global,a.getGlobalAMDRequireFunc(),E,e.filename,this._path.dirname(e.filename)),u.record(32,e.filename),_?f():s(new Error(`Didn't receive define call in ${e.filename}!`)),d}_getElectronRendererScriptPathOrUri(a){if(!this._env.isElectronRenderer)return a;let b=a.match(/^([a-z])\:(.*)/i);return b?`file:///${(b[1].toUpperCase()+":"+b[2]).replace(/\\/g,"/")}`:`file://${a}`}_getCachedDataPath(a,b){const e=this._crypto.createHash("md5").update(b,"utf8").update(a.seed,"utf8").update(process.arch,"").digest("hex"),f=this._path.basename(b).replace(/\.js$/,"");return this._path.join(a.path,`${f}-${e}.code`)}_handleCachedData(a,b,e,f,s){a.cachedDataRejected?this._fs.unlink(e,u=>{s.getRecorder().record(62,e),this._createAndWriteCachedData(a,b,e,s),u&&s.getConfig().onError(u)}):f&&this._createAndWriteCachedData(a,b,e,s)}_createAndWriteCachedData(a,b,e,f){let s=Math.ceil(f.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),u=-1,d=0,h;const S=()=>{setTimeout(()=>{h||(h=this._crypto.createHash("md5").update(b,"utf8").digest());const _=a.createCachedData();if(!(_.length===0||_.length===u||d>=5)){if(_.length<u){S();return}u=_.length,this._fs.writeFile(e,Buffer.concat([h,_]),E=>{E&&f.getConfig().onError(E),f.getRecorder().record(63,e),S()})}},s*Math.pow(4,d++))};S()}_readSourceAndCachedData(a,b,e,f){if(!b)this._fs.readFile(a,{encoding:"utf8"},f);else{let s,u,d,h=2;const S=_=>{_?f(_):--h===0&&f(void 0,s,u,d)};this._fs.readFile(a,{encoding:"utf8"},(_,E)=>{s=E,S(_)}),this._fs.readFile(b,(_,E)=>{!_&&E&&E.length>0?(d=E.slice(0,16),u=E.slice(16),e.record(60,b)):e.record(61,b),S()})}}_verifyCachedData(a,b,e,f,s){f&&(a.cachedDataRejected||setTimeout(()=>{const u=this._crypto.createHash("md5").update(b,"utf8").digest();f.equals(u)||(s.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${e}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(e,d=>{d&&s.getConfig().onError(d)}))},Math.ceil(5e3*(1+Math.random()))))}}g._BOM=65279,g._PREFIX="(function (require, define, __filename, __dirname) { ",g._SUFFIX=`
});`;function m(o,a){if(a.__$__isRecorded)return a;const b=function(f){o.record(33,f);try{return a(f)}finally{o.record(34,f)}};return b.__$__isRecorded=!0,b}O.ensureRecordedNodeRequire=m;function v(o){return new n(o)}O.createScriptLoader=v})(ue||(ue={}));var ue;(function(O){class n{constructor(o){let a=o.lastIndexOf("/");a!==-1?this.fromModulePath=o.substr(0,a+1):this.fromModulePath=""}static _normalizeModuleId(o){let a=o,b;for(b=/\/\.\//;b.test(a);)a=a.replace(b,"/");for(a=a.replace(/^\.\//g,""),b=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;b.test(a);)a=a.replace(b,"/");return a=a.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),a}resolveModule(o){let a=o;return O.Utilities.isAbsolutePath(a)||(O.Utilities.startsWith(a,"./")||O.Utilities.startsWith(a,"../"))&&(a=n._normalizeModuleId(this.fromModulePath+a)),a}}n.ROOT=new n(""),O.ModuleIdResolver=n;class r{constructor(o,a,b,e,f,s){this.id=o,this.strId=a,this.dependencies=b,this._callback=e,this._errorback=f,this.moduleIdResolver=s,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(o,a){try{return{returnedValue:o.apply(O.global,a),producedError:null}}catch(b){return{returnedValue:null,producedError:b}}}static _invokeFactory(o,a,b,e){return o.shouldInvokeFactory(a)?o.shouldCatchError()?this._safeInvokeFunction(b,e):{returnedValue:b.apply(O.global,e),producedError:null}:{returnedValue:null,producedError:null}}complete(o,a,b,e){this._isComplete=!0;let f=null;if(this._callback)if(typeof this._callback=="function"){o.record(21,this.strId);let s=r._invokeFactory(a,this.strId,this._callback,b);f=s.producedError,o.record(22,this.strId),!f&&typeof s.returnedValue<"u"&&(!this.exportsPassedIn||O.Utilities.isEmpty(this.exports))&&(this.exports=s.returnedValue)}else this.exports=this._callback;if(f){let s=O.ensureError(f);s.phase="factory",s.moduleId=this.strId,s.neededBy=e(this.id),this.error=s,a.onError(s)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(o){return this._isComplete=!0,this.error=o,this._errorback?(this._errorback(o),!0):!1}isComplete(){return this._isComplete}}O.Module=r;class x{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(o){let a=this._strModuleIdToIntModuleId.get(o);return typeof a>"u"&&(a=this._nextId++,this._strModuleIdToIntModuleId.set(o,a),this._intModuleIdToStrModuleId[a]=o),a}getStrModuleId(o){return this._intModuleIdToStrModuleId[o]}}class M{constructor(o){this.id=o}}M.EXPORTS=new M(0),M.MODULE=new M(1),M.REQUIRE=new M(2),O.RegularDependency=M;class g{constructor(o,a,b){this.id=o,this.pluginId=a,this.pluginParam=b}}O.PluginDependency=g;class m{constructor(o,a,b,e,f=0){this._env=o,this._scriptLoader=a,this._loaderAvailableTimestamp=f,this._defineFunc=b,this._requireFunc=e,this._moduleIdProvider=new x,this._config=new O.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new m(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(o,a){let b=s=>s.replace(/\\/g,"/"),e=b(o),f=a.split(/\n/);for(let s=0;s<f.length;s++){let u=f[s].match(/(.*):(\d+):(\d+)\)?$/);if(u){let d=u[1],h=u[2],S=u[3],_=Math.max(d.lastIndexOf(" ")+1,d.lastIndexOf("(")+1);if(d=d.substr(_),d=b(d),d===e){let E={line:parseInt(h,10),col:parseInt(S,10)};return E.line===1&&(E.col-=53),E}}}throw new Error("Could not correlate define call site for needle "+o)}getBuildInfo(){if(!this._config.isBuild())return null;let o=[],a=0;for(let b=0,e=this._modules2.length;b<e;b++){let f=this._modules2[b];if(!f)continue;let s=this._buildInfoPath[f.id]||null,u=this._buildInfoDefineStack[f.id]||null,d=this._buildInfoDependencies[f.id];o[a++]={id:f.strId,path:s,defineLocation:s&&u?m._findRelevantLocationInStack(s,u):null,dependencies:d,shim:null,exports:f.exports}}return o}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new O.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=O.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(o,a){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let b=null;this._config.isBuild()&&(b=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:b,dependencies:o,callback:a}}defineModule(o,a,b,e,f,s=new n(o)){let u=this._moduleIdProvider.getModuleId(o);if(this._modules2[u]){this._config.isDuplicateMessageIgnoredFor(o)||console.warn("Duplicate definition of module '"+o+"'");return}let d=new r(u,o,this._normalizeDependencies(a,s),b,e,s);this._modules2[u]=d,this._config.isBuild()&&(this._buildInfoDefineStack[u]=f,this._buildInfoDependencies[u]=(d.dependencies||[]).map(h=>this._moduleIdProvider.getStrModuleId(h.id))),this._resolve(d)}_normalizeDependency(o,a){if(o==="exports")return M.EXPORTS;if(o==="module")return M.MODULE;if(o==="require")return M.REQUIRE;let b=o.indexOf("!");if(b>=0){let e=a.resolveModule(o.substr(0,b)),f=a.resolveModule(o.substr(b+1)),s=this._moduleIdProvider.getModuleId(e+"!"+f),u=this._moduleIdProvider.getModuleId(e);return new g(s,u,f)}return new M(this._moduleIdProvider.getModuleId(a.resolveModule(o)))}_normalizeDependencies(o,a){let b=[],e=0;for(let f=0,s=o.length;f<s;f++)b[e++]=this._normalizeDependency(o[f],a);return b}_relativeRequire(o,a,b,e){if(typeof a=="string")return this.synchronousRequire(a,o);this.defineModule(O.Utilities.generateAnonymousModule(),a,b,e,null,o)}synchronousRequire(o,a=new n(o)){let b=this._normalizeDependency(o,a),e=this._modules2[b.id];if(!e)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This is the first mention of this module!");if(!e.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This module has not been resolved completely yet.");if(e.error)throw e.error;return e.exports}configure(o,a){let b=this._config.shouldRecordStats();a?this._config=new O.Configuration(this._env,o):this._config=this._config.cloneAndMerge(o),this._config.shouldRecordStats()&&!b&&(this._recorder=null)}getConfig(){return this._config}_onLoad(o){if(this._currentAnonymousDefineCall!==null){let a=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(o),a.dependencies,a.callback,null,a.stack)}}_createLoadError(o,a){let b=this._moduleIdProvider.getStrModuleId(o),e=(this._inverseDependencies2[o]||[]).map(s=>this._moduleIdProvider.getStrModuleId(s));const f=O.ensureError(a);return f.phase="loading",f.moduleId=b,f.neededBy=e,f}_onLoadError(o,a){const b=this._createLoadError(o,a);this._modules2[o]||(this._modules2[o]=new r(o,this._moduleIdProvider.getStrModuleId(o),[],()=>{},null,null));let e=[];for(let u=0,d=this._moduleIdProvider.getMaxModuleId();u<d;u++)e[u]=!1;let f=!1,s=[];for(s.push(o),e[o]=!0;s.length>0;){let u=s.shift(),d=this._modules2[u];d&&(f=d.onDependencyError(b)||f);let h=this._inverseDependencies2[u];if(h)for(let S=0,_=h.length;S<_;S++){let E=h[S];e[E]||(s.push(E),e[E]=!0)}}f||this._config.onError(b)}_hasDependencyPath(o,a){let b=this._modules2[o];if(!b)return!1;let e=[];for(let s=0,u=this._moduleIdProvider.getMaxModuleId();s<u;s++)e[s]=!1;let f=[];for(f.push(b),e[o]=!0;f.length>0;){let u=f.shift().dependencies;if(u)for(let d=0,h=u.length;d<h;d++){let S=u[d];if(S.id===a)return!0;let _=this._modules2[S.id];_&&!e[S.id]&&(e[S.id]=!0,f.push(_))}}return!1}_findCyclePath(o,a,b){if(o===a||b===50)return[o];let e=this._modules2[o];if(!e)return null;let f=e.dependencies;if(f)for(let s=0,u=f.length;s<u;s++){let d=this._findCyclePath(f[s].id,a,b+1);if(d!==null)return d.push(o),d}return null}_createRequire(o){let a=(b,e,f)=>this._relativeRequire(o,b,e,f);return a.toUrl=b=>this._config.requireToUrl(o.resolveModule(b)),a.getStats=()=>this.getLoaderEvents(),a.hasDependencyCycle=()=>this._hasDependencyCycle,a.config=(b,e=!1)=>{this.configure(b,e)},a.__$__nodeRequire=O.global.nodeRequire,a}_loadModule(o){if(this._modules2[o]||this._knownModules2[o])return;this._knownModules2[o]=!0;let a=this._moduleIdProvider.getStrModuleId(o),b=this._config.moduleIdToPaths(a),e=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(a.indexOf("/")===-1||e.test(a))&&b.push("node|"+a);let f=-1,s=u=>{if(f++,f>=b.length)this._onLoadError(o,u);else{let d=b[f],h=this.getRecorder();if(this._config.isBuild()&&d==="empty:"){this._buildInfoPath[o]=d,this.defineModule(this._moduleIdProvider.getStrModuleId(o),[],null,null,null),this._onLoad(o);return}h.record(10,d),this._scriptLoader.load(this,d,()=>{this._config.isBuild()&&(this._buildInfoPath[o]=d),h.record(11,d),this._onLoad(o)},S=>{h.record(12,d),s(S)})}};s(null)}_loadPluginDependency(o,a){if(this._modules2[a.id]||this._knownModules2[a.id])return;this._knownModules2[a.id]=!0;let b=e=>{this.defineModule(this._moduleIdProvider.getStrModuleId(a.id),[],e,null,null)};b.error=e=>{this._config.onError(this._createLoadError(a.id,e))},o.load(a.pluginParam,this._createRequire(n.ROOT),b,this._config.getOptionsLiteral())}_resolve(o){let a=o.dependencies;if(a)for(let b=0,e=a.length;b<e;b++){let f=a[b];if(f===M.EXPORTS){o.exportsPassedIn=!0,o.unresolvedDependenciesCount--;continue}if(f===M.MODULE){o.unresolvedDependenciesCount--;continue}if(f===M.REQUIRE){o.unresolvedDependenciesCount--;continue}let s=this._modules2[f.id];if(s&&s.isComplete()){if(s.error){o.onDependencyError(s.error);return}o.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(f.id,o.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(f.id)+"' and '"+this._moduleIdProvider.getStrModuleId(o.id)+"'. The cyclic path follows:");let u=this._findCyclePath(f.id,o.id,0)||[];u.reverse(),u.push(f.id),console.warn(u.map(d=>this._moduleIdProvider.getStrModuleId(d)).join(` => 
`)),o.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[f.id]=this._inverseDependencies2[f.id]||[],this._inverseDependencies2[f.id].push(o.id),f instanceof g){let u=this._modules2[f.pluginId];if(u&&u.isComplete()){this._loadPluginDependency(u.exports,f);continue}let d=this._inversePluginDependencies2.get(f.pluginId);d||(d=[],this._inversePluginDependencies2.set(f.pluginId,d)),d.push(f),this._loadModule(f.pluginId);continue}this._loadModule(f.id)}o.unresolvedDependenciesCount===0&&this._onModuleComplete(o)}_onModuleComplete(o){let a=this.getRecorder();if(o.isComplete())return;let b=o.dependencies,e=[];if(b)for(let d=0,h=b.length;d<h;d++){let S=b[d];if(S===M.EXPORTS){e[d]=o.exports;continue}if(S===M.MODULE){e[d]={id:o.strId,config:()=>this._config.getConfigForModule(o.strId)};continue}if(S===M.REQUIRE){e[d]=this._createRequire(o.moduleIdResolver);continue}let _=this._modules2[S.id];if(_){e[d]=_.exports;continue}e[d]=null}const f=d=>(this._inverseDependencies2[d]||[]).map(h=>this._moduleIdProvider.getStrModuleId(h));o.complete(a,this._config,e,f);let s=this._inverseDependencies2[o.id];if(this._inverseDependencies2[o.id]=null,s)for(let d=0,h=s.length;d<h;d++){let S=s[d],_=this._modules2[S];_.unresolvedDependenciesCount--,_.unresolvedDependenciesCount===0&&this._onModuleComplete(_)}let u=this._inversePluginDependencies2.get(o.id);if(u){this._inversePluginDependencies2.delete(o.id);for(let d=0,h=u.length;d<h;d++)this._loadPluginDependency(o.exports,u[d])}}}O.ModuleManager=m})(ue||(ue={}));var Y,ue;(function(O){const n=new O.Environment;let r=null;const x=function(v,o,a){typeof v!="string"&&(a=o,o=v,v=null),(typeof o!="object"||!Array.isArray(o))&&(a=o,o=null),o||(o=["require","exports","module"]),v?r.defineModule(v,o,a,null,null):r.enqueueDefineAnonymousModule(o,a)};x.amd={jQuery:!0};const M=function(v,o=!1){r.configure(v,o)},g=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){M(arguments[0]);return}if(typeof arguments[0]=="string")return r.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){r.defineModule(O.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};g.config=M,g.getConfig=function(){return r.getConfig().getOptionsLiteral()},g.reset=function(){r=r.reset()},g.getBuildInfo=function(){return r.getBuildInfo()},g.getStats=function(){return r.getLoaderEvents()},g.define=x;function m(){if(typeof O.global.require<"u"||typeof require<"u"){const v=O.global.require||require;if(typeof v=="function"&&typeof v.resolve=="function"){const o=O.ensureRecordedNodeRequire(r.getRecorder(),v);O.global.nodeRequire=o,g.nodeRequire=o,g.__$__nodeRequire=o}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?module.exports=g:(n.isElectronRenderer||(O.global.define=x),O.global.require=g)}O.init=m,(typeof O.global.define!="function"||!O.global.define.amd)&&(r=new O.ModuleManager(n,O.createScriptLoader(n),x,g,O.Utilities.getHighPerformanceTimestamp()),typeof O.global.require<"u"&&typeof O.global.require!="function"&&g.config(O.global.require),Y=function(){return x.apply(null,arguments)},Y.amd=x.amd,typeof doNotInitLoader>"u"&&m())})(ue||(ue={})),Y(X[19],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.localize=b,n.localize2=e,n.getConfiguredDefaultLocale=f,n.setPseudoTranslation=s,n.create=u,n.load=d;let r=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const x="i-default";function M(h,S){let _;return S.length===0?_=h:_=h.replace(/\{(\d+)\}/g,(E,A)=>{const p=A[0],i=S[p];let l=E;return typeof i=="string"?l=i:(typeof i=="number"||typeof i=="boolean"||i===void 0||i===null)&&(l=String(i)),l}),r&&(_="\uFF3B"+_.replace(/[aouei]/g,"$&$&")+"\uFF3D"),_}function g(h,S){let _=h[S];return _||(_=h["*"],_)?_:null}function m(h){return h.charAt(h.length-1)==="/"?h:h+"/"}async function v(h,S,_){const E=m(h)+m(S)+"vscode/"+m(_),A=await fetch(E);if(A.ok)return await A.json();throw new Error(`${A.status} - ${A.statusText}`)}function o(h){return function(S,_){const E=Array.prototype.slice.call(arguments,2);return M(h[S],E)}}function a(h){return(S,_,...E)=>({value:M(h[S],E),original:M(_,E)})}function b(h,S,..._){return M(S,_)}function e(h,S,..._){const E=M(S,_);return{value:E,original:E}}function f(h){}function s(h){r=h}function u(h,S){var _;return{localize:o(S[h]),localize2:a(S[h]),getConfiguredDefaultLocale:(_=S.getConfiguredDefaultLocale)!==null&&_!==void 0?_:E=>{}}}function d(h,S,_,E){var A;const p=(A=E["vs/nls"])!==null&&A!==void 0?A:{};if(!h||h.length===0)return _({localize:b,localize2:e,getConfiguredDefaultLocale:()=>{var w;return(w=p.availableLanguages)===null||w===void 0?void 0:w["*"]}});const i=p.availableLanguages?g(p.availableLanguages,h):null,l=i===null||i===x;let c=".nls";l||(c=c+"."+i);const L=w=>{Array.isArray(w)?(w.localize=o(w),w.localize2=a(w)):(w.localize=o(w[h]),w.localize2=a(w[h])),w.getConfiguredDefaultLocale=()=>{var C;return(C=p.availableLanguages)===null||C===void 0?void 0:C["*"]},_(w)};typeof p.loadBundle=="function"?p.loadBundle(h,i,(w,C)=>{w?S([h+".nls"],L):L(C)}):p.translationServiceUrl&&!l?(async()=>{var w;try{const C=await v(p.translationServiceUrl,i,h);return L(C)}catch(C){if(!i.includes("-"))return console.error(C),S([h+".nls"],L);try{const N=i.split("-")[0],y=await v(p.translationServiceUrl,N,h);return(w=p.availableLanguages)!==null&&w!==void 0||(p.availableLanguages={}),p.availableLanguages["*"]=N,L(y)}catch(N){return console.error(N),S([h+".nls"],L)}}})():S([h+c],L,w=>{if(c===".nls"){console.error("Failed trying to load default language strings",w);return}console.error(`Failed to load message bundle for language ${i}. Falling back to the default language:`,w),S([h+".nls"],L)})}}),function(){const O=globalThis.MonacoEnvironment,n=O&&O.baseUrl?O.baseUrl:"../../../";function r(b,e){var f;if(O?.createTrustedTypesPolicy)try{return O.createTrustedTypesPolicy(b,e)}catch(s){console.warn(s);return}try{return(f=self.trustedTypes)===null||f===void 0?void 0:f.createPolicy(b,e)}catch(s){console.warn(s);return}}const x=r("amdLoader",{createScriptURL:b=>b,createScript:(b,...e)=>{const f=e.slice(0,-1).join(","),s=e.pop().toString();return`(function anonymous(${f}) { ${s}
})`}});function M(){try{return(x?globalThis.eval(x.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function g(){return new Promise((b,e)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return b();const f=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(f)&&f.substring(0,globalThis.origin.length)!==globalThis.origin)&&M()){fetch(f).then(u=>{if(u.status!==200)throw new Error(u.statusText);return u.text()}).then(u=>{u=`${u}
//# sourceURL=${f}`,(x?globalThis.eval(x.createScript("",u)):new Function(u)).call(globalThis),b()}).then(void 0,e);return}x?importScripts(x.createScriptURL(f)):importScripts(f),b()})}function m(){require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:x,amdModulesPattern:/^vs\//})}function v(b){g().then(()=>{m(),require([b],function(e){setTimeout(function(){const f=e.create((s,u)=>{globalThis.postMessage(s,u)},null);for(globalThis.onmessage=s=>f.onmessage(s.data,s.ports);a.length>0;){const s=a.shift();f.onmessage(s.data,s.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&m();let o=!0;const a=[];globalThis.onmessage=b=>{if(!o){a.push(b);return}o=!1,v(b.data)}}(),Y(X[7],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Permutation=n.CallbackIterable=n.ArrayQueue=n.booleanComparator=n.numberComparator=n.CompareResult=void 0,n.tail=r,n.tail2=x,n.equals=M,n.removeFastWithoutKeepingOrder=g,n.binarySearch=m,n.binarySearch2=v,n.quickSelect=o,n.groupBy=a,n.groupAdjacentBy=b,n.forEachAdjacent=e,n.forEachWithNeighbors=f,n.coalesce=s,n.coalesceInPlace=u,n.isFalsyOrEmpty=d,n.isNonEmptyArray=h,n.distinct=S,n.firstOrDefault=_,n.range=E,n.arrayInsert=A,n.pushToStart=p,n.pushToEnd=i,n.pushMany=l,n.asArray=c,n.insertInto=L,n.splice=w,n.compareBy=y,n.tieBreakComparators=R,n.reverseOrder=k;function r(F,I=0){return F[F.length-(1+I)]}function x(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}function M(F,I,W=(V,z)=>V===z){if(F===I)return!0;if(!F||!I||F.length!==I.length)return!1;for(let V=0,z=F.length;V<z;V++)if(!W(F[V],I[V]))return!1;return!0}function g(F,I){const W=F.length-1;I<W&&(F[I]=F[W]),F.pop()}function m(F,I,W){return v(F.length,V=>W(F[V],I))}function v(F,I){let W=0,V=F-1;for(;W<=V;){const z=(W+V)/2|0,U=I(z);if(U<0)W=z+1;else if(U>0)V=z-1;else return z}return-(W+1)}function o(F,I,W){if(F=F|0,F>=I.length)throw new TypeError("invalid index");const V=I[Math.floor(I.length*Math.random())],z=[],U=[],se=[];for(const he of I){const de=W(he,V);de<0?z.push(he):de>0?U.push(he):se.push(he)}return F<z.length?o(F,z,W):F<z.length+se.length?se[0]:o(F-(z.length+se.length),U,W)}function a(F,I){const W=[];let V;for(const z of F.slice(0).sort(I))!V||I(V[0],z)!==0?(V=[z],W.push(V)):V.push(z);return W}function*b(F,I){let W,V;for(const z of F)V!==void 0&&I(V,z)?W.push(z):(W&&(yield W),W=[z]),V=z;W&&(yield W)}function e(F,I){for(let W=0;W<=F.length;W++)I(W===0?void 0:F[W-1],W===F.length?void 0:F[W])}function f(F,I){for(let W=0;W<F.length;W++)I(W===0?void 0:F[W-1],F[W],W+1===F.length?void 0:F[W+1])}function s(F){return F.filter(I=>!!I)}function u(F){let I=0;for(let W=0;W<F.length;W++)F[W]&&(F[I]=F[W],I+=1);F.length=I}function d(F){return!Array.isArray(F)||F.length===0}function h(F){return Array.isArray(F)&&F.length>0}function S(F,I=W=>W){const W=new Set;return F.filter(V=>{const z=I(V);return W.has(z)?!1:(W.add(z),!0)})}function _(F,I){return F.length>0?F[0]:I}function E(F,I){let W=typeof I=="number"?F:0;typeof I=="number"?W=F:(W=0,I=F);const V=[];if(W<=I)for(let z=W;z<I;z++)V.push(z);else for(let z=W;z>I;z--)V.push(z);return V}function A(F,I,W){const V=F.slice(0,I),z=F.slice(I);return V.concat(W,z)}function p(F,I){const W=F.indexOf(I);W>-1&&(F.splice(W,1),F.unshift(I))}function i(F,I){const W=F.indexOf(I);W>-1&&(F.splice(W,1),F.push(I))}function l(F,I){for(const W of I)F.push(W)}function c(F){return Array.isArray(F)?F:[F]}function L(F,I,W){const V=C(F,I),z=F.length,U=W.length;F.length=z+U;for(let se=z-1;se>=V;se--)F[se+U]=F[se];for(let se=0;se<U;se++)F[se+V]=W[se]}function w(F,I,W,V){const z=C(F,I);let U=F.splice(z,W);return U===void 0&&(U=[]),L(F,z,V),U}function C(F,I){return I<0?Math.max(I+F.length,0):Math.min(I,F.length)}var N;(function(F){function I(U){return U<0}F.isLessThan=I;function W(U){return U<=0}F.isLessThanOrEqual=W;function V(U){return U>0}F.isGreaterThan=V;function z(U){return U===0}F.isNeitherLessOrGreaterThan=z,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(N||(n.CompareResult=N={}));function y(F,I){return(W,V)=>I(F(W),F(V))}function R(...F){return(I,W)=>{for(const V of F){const z=V(I,W);if(!N.isNeitherLessOrGreaterThan(z))return z}return N.neitherLessOrGreaterThan}}const D=(F,I)=>F-I;n.numberComparator=D;const T=(F,I)=>(0,n.numberComparator)(F?1:0,I?1:0);n.booleanComparator=T;function k(F){return(I,W)=>-F(I,W)}class q{constructor(I){this.items=I,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(I){let W=this.firstIdx;for(;W<this.items.length&&I(this.items[W]);)W++;const V=W===this.firstIdx?null:this.items.slice(this.firstIdx,W);return this.firstIdx=W,V}takeFromEndWhile(I){let W=this.lastIdx;for(;W>=0&&I(this.items[W]);)W--;const V=W===this.lastIdx?null:this.items.slice(W+1,this.lastIdx+1);return this.lastIdx=W,V}peek(){if(this.length!==0)return this.items[this.firstIdx]}dequeue(){const I=this.items[this.firstIdx];return this.firstIdx++,I}takeCount(I){const W=this.items.slice(this.firstIdx,this.firstIdx+I);return this.firstIdx+=I,W}}n.ArrayQueue=q;class H{constructor(I){this.iterate=I}toArray(){const I=[];return this.iterate(W=>(I.push(W),!0)),I}filter(I){return new H(W=>this.iterate(V=>I(V)?W(V):!0))}map(I){return new H(W=>this.iterate(V=>W(I(V))))}findLast(I){let W;return this.iterate(V=>(I(V)&&(W=V),!0)),W}findLastMaxBy(I){let W,V=!0;return this.iterate(z=>((V||N.isGreaterThan(I(z,W)))&&(V=!1,W=z),!0)),W}}n.CallbackIterable=H,H.empty=new H(F=>{});class Q{constructor(I){this._indexMap=I}static createSortPermutation(I,W){const V=Array.from(I.keys()).sort((z,U)=>W(I[z],I[U]));return new Q(V)}apply(I){return I.map((W,V)=>I[this._indexMap[V]])}inverse(){const I=this._indexMap.slice();for(let W=0;W<this._indexMap.length;W++)I[this._indexMap[W]]=W;return new Q(I)}}n.Permutation=Q}),Y(X[11],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MonotonousArray=void 0,n.findLast=r,n.findLastIdx=x,n.findLastMonotonous=M,n.findLastIdxMonotonous=g,n.findFirstMonotonous=m,n.findFirstIdxMonotonousOrArrLen=v,n.findFirstMax=a,n.findLastMax=b,n.findFirstMin=e,n.findMaxIdx=f,n.mapFindFirst=s;function r(u,d){const h=x(u,d);if(h!==-1)return u[h]}function x(u,d,h=u.length-1){for(let S=h;S>=0;S--){const _=u[S];if(d(_))return S}return-1}function M(u,d){const h=g(u,d);return h===-1?void 0:u[h]}function g(u,d,h=0,S=u.length){let _=h,E=S;for(;_<E;){const A=Math.floor((_+E)/2);d(u[A])?_=A+1:E=A}return _-1}function m(u,d){const h=v(u,d);return h===u.length?void 0:u[h]}function v(u,d,h=0,S=u.length){let _=h,E=S;for(;_<E;){const A=Math.floor((_+E)/2);d(u[A])?E=A:_=A+1}return _}class o{constructor(d){this._array=d,this._findLastMonotonousLastIdx=0}findLastMonotonous(d){if(o.assertInvariants){if(this._prevFindLastPredicate){for(const S of this._array)if(this._prevFindLastPredicate(S)&&!d(S))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=d}const h=g(this._array,d,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=h+1,h===-1?void 0:this._array[h]}}n.MonotonousArray=o,o.assertInvariants=!1;function a(u,d){if(u.length===0)return;let h=u[0];for(let S=1;S<u.length;S++){const _=u[S];d(_,h)>0&&(h=_)}return h}function b(u,d){if(u.length===0)return;let h=u[0];for(let S=1;S<u.length;S++){const _=u[S];d(_,h)>=0&&(h=_)}return h}function e(u,d){return a(u,(h,S)=>-d(h,S))}function f(u,d){if(u.length===0)return-1;let h=0;for(let S=1;S<u.length;S++){const _=u[S];d(_,u[h])>0&&(h=S)}return h}function s(u,d){for(const h of u){const S=d(h);if(S!==void 0)return S}}}),Y(X[34],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=void 0,n.identity=r;function r(g){return g}class x{constructor(m,v){this.lastCache=void 0,this.lastArgKey=void 0,typeof m=="function"?(this._fn=m,this._computeKey=r):(this._fn=v,this._computeKey=m.getCacheKey)}get(m){const v=this._computeKey(m);return this.lastArgKey!==v&&(this.lastArgKey=v,this.lastCache=this._fn(m)),this.lastCache}}n.LRUCachedFunction=x;class M{get cachedValues(){return this._map}constructor(m,v){this._map=new Map,this._map2=new Map,typeof m=="function"?(this._fn=m,this._computeKey=r):(this._fn=v,this._computeKey=m.getCacheKey)}get(m){const v=this._computeKey(m);if(this._map2.has(v))return this._map2.get(v);const o=this._fn(m);return this._map.set(m,o),this._map2.set(v,o),o}}n.CachedFunction=M}),Y(X[35],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Color=n.HSVA=n.HSLA=n.RGBA=void 0;function r(v,o){const a=Math.pow(10,o);return Math.round(v*a)/a}class x{constructor(o,a,b,e=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,o))|0,this.g=Math.min(255,Math.max(0,a))|0,this.b=Math.min(255,Math.max(0,b))|0,this.a=r(Math.max(Math.min(1,e),0),3)}static equals(o,a){return o.r===a.r&&o.g===a.g&&o.b===a.b&&o.a===a.a}}n.RGBA=x;class M{constructor(o,a,b,e){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,o),0)|0,this.s=r(Math.max(Math.min(1,a),0),3),this.l=r(Math.max(Math.min(1,b),0),3),this.a=r(Math.max(Math.min(1,e),0),3)}static equals(o,a){return o.h===a.h&&o.s===a.s&&o.l===a.l&&o.a===a.a}static fromRGBA(o){const a=o.r/255,b=o.g/255,e=o.b/255,f=o.a,s=Math.max(a,b,e),u=Math.min(a,b,e);let d=0,h=0;const S=(u+s)/2,_=s-u;if(_>0){switch(h=Math.min(S<=.5?_/(2*S):_/(2-2*S),1),s){case a:d=(b-e)/_+(b<e?6:0);break;case b:d=(e-a)/_+2;break;case e:d=(a-b)/_+4;break}d*=60,d=Math.round(d)}return new M(d,h,S,f)}static _hue2rgb(o,a,b){return b<0&&(b+=1),b>1&&(b-=1),b<1/6?o+(a-o)*6*b:b<1/2?a:b<2/3?o+(a-o)*(2/3-b)*6:o}static toRGBA(o){const a=o.h/360,{s:b,l:e,a:f}=o;let s,u,d;if(b===0)s=u=d=e;else{const h=e<.5?e*(1+b):e+b-e*b,S=2*e-h;s=M._hue2rgb(S,h,a+1/3),u=M._hue2rgb(S,h,a),d=M._hue2rgb(S,h,a-1/3)}return new x(Math.round(s*255),Math.round(u*255),Math.round(d*255),f)}}n.HSLA=M;class g{constructor(o,a,b,e){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,o),0)|0,this.s=r(Math.max(Math.min(1,a),0),3),this.v=r(Math.max(Math.min(1,b),0),3),this.a=r(Math.max(Math.min(1,e),0),3)}static equals(o,a){return o.h===a.h&&o.s===a.s&&o.v===a.v&&o.a===a.a}static fromRGBA(o){const a=o.r/255,b=o.g/255,e=o.b/255,f=Math.max(a,b,e),s=Math.min(a,b,e),u=f-s,d=f===0?0:u/f;let h;return u===0?h=0:f===a?h=((b-e)/u%6+6)%6:f===b?h=(e-a)/u+2:h=(a-b)/u+4,new g(Math.round(h*60),d,f,o.a)}static toRGBA(o){const{h:a,s:b,v:e,a:f}=o,s=e*b,u=s*(1-Math.abs(a/60%2-1)),d=e-s;let[h,S,_]=[0,0,0];return a<60?(h=s,S=u):a<120?(h=u,S=s):a<180?(S=s,_=u):a<240?(S=u,_=s):a<300?(h=u,_=s):a<=360&&(h=s,_=u),h=Math.round((h+d)*255),S=Math.round((S+d)*255),_=Math.round((_+d)*255),new x(h,S,_,f)}}n.HSVA=g;class m{static fromHex(o){return m.Format.CSS.parseHex(o)||m.red}static equals(o,a){return!o&&!a?!0:!o||!a?!1:o.equals(a)}get hsla(){return this._hsla?this._hsla:M.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:g.fromRGBA(this.rgba)}constructor(o){if(o)if(o instanceof x)this.rgba=o;else if(o instanceof M)this._hsla=o,this.rgba=M.toRGBA(o);else if(o instanceof g)this._hsva=o,this.rgba=g.toRGBA(o);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(o){return!!o&&x.equals(this.rgba,o.rgba)&&M.equals(this.hsla,o.hsla)&&g.equals(this.hsva,o.hsva)}getRelativeLuminance(){const o=m._relativeLuminanceForComponent(this.rgba.r),a=m._relativeLuminanceForComponent(this.rgba.g),b=m._relativeLuminanceForComponent(this.rgba.b),e=.2126*o+.7152*a+.0722*b;return r(e,4)}static _relativeLuminanceForComponent(o){const a=o/255;return a<=.03928?a/12.92:Math.pow((a+.055)/1.055,2.4)}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(o){const a=this.getRelativeLuminance(),b=o.getRelativeLuminance();return a>b}isDarkerThan(o){const a=this.getRelativeLuminance(),b=o.getRelativeLuminance();return a<b}lighten(o){return new m(new M(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*o,this.hsla.a))}darken(o){return new m(new M(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*o,this.hsla.a))}transparent(o){const{r:a,g:b,b:e,a:f}=this.rgba;return new m(new x(a,b,e,f*o))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new m(new x(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}makeOpaque(o){if(this.isOpaque()||o.rgba.a!==1)return this;const{r:a,g:b,b:e,a:f}=this.rgba;return new m(new x(o.rgba.r-f*(o.rgba.r-a),o.rgba.g-f*(o.rgba.g-b),o.rgba.b-f*(o.rgba.b-e),1))}toString(){return this._toString||(this._toString=m.Format.CSS.format(this)),this._toString}static getLighterColor(o,a,b){if(o.isLighterThan(a))return o;b=b||.5;const e=o.getRelativeLuminance(),f=a.getRelativeLuminance();return b=b*(f-e)/f,o.lighten(b)}static getDarkerColor(o,a,b){if(o.isDarkerThan(a))return o;b=b||.5;const e=o.getRelativeLuminance(),f=a.getRelativeLuminance();return b=b*(e-f)/e,o.darken(b)}}n.Color=m,m.white=new m(new x(255,255,255,1)),m.black=new m(new x(0,0,0,1)),m.red=new m(new x(255,0,0,1)),m.blue=new m(new x(0,0,255,1)),m.green=new m(new x(0,255,0,1)),m.cyan=new m(new x(0,255,255,1)),m.lightgrey=new m(new x(211,211,211,1)),m.transparent=new m(new x(0,0,0,0)),function(v){let o;(function(a){let b;(function(e){function f(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:v.Format.CSS.formatRGBA(i)}e.formatRGB=f;function s(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}e.formatRGBA=s;function u(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:v.Format.CSS.formatHSLA(i)}e.formatHSL=u;function d(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}e.formatHSLA=d;function h(i){const l=i.toString(16);return l.length!==2?"0"+l:l}function S(i){return`#${h(i.rgba.r)}${h(i.rgba.g)}${h(i.rgba.b)}`}e.formatHex=S;function _(i,l=!1){return l&&i.rgba.a===1?v.Format.CSS.formatHex(i):`#${h(i.rgba.r)}${h(i.rgba.g)}${h(i.rgba.b)}${h(Math.round(i.rgba.a*255))}`}e.formatHexA=_;function E(i){return i.isOpaque()?v.Format.CSS.formatHex(i):v.Format.CSS.formatRGBA(i)}e.format=E;function A(i){const l=i.length;if(l===0||i.charCodeAt(0)!==35)return null;if(l===7){const c=16*p(i.charCodeAt(1))+p(i.charCodeAt(2)),L=16*p(i.charCodeAt(3))+p(i.charCodeAt(4)),w=16*p(i.charCodeAt(5))+p(i.charCodeAt(6));return new v(new x(c,L,w,1))}if(l===9){const c=16*p(i.charCodeAt(1))+p(i.charCodeAt(2)),L=16*p(i.charCodeAt(3))+p(i.charCodeAt(4)),w=16*p(i.charCodeAt(5))+p(i.charCodeAt(6)),C=16*p(i.charCodeAt(7))+p(i.charCodeAt(8));return new v(new x(c,L,w,C/255))}if(l===4){const c=p(i.charCodeAt(1)),L=p(i.charCodeAt(2)),w=p(i.charCodeAt(3));return new v(new x(16*c+c,16*L+L,16*w+w))}if(l===5){const c=p(i.charCodeAt(1)),L=p(i.charCodeAt(2)),w=p(i.charCodeAt(3)),C=p(i.charCodeAt(4));return new v(new x(16*c+c,16*L+L,16*w+w,(16*C+C)/255))}return null}e.parseHex=A;function p(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(b=a.CSS||(a.CSS={}))})(o=v.Format||(v.Format={}))}(m||(n.Color=m={}))}),Y(X[36],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class r{constructor(M,g,m,v){this.originalStart=M,this.originalLength=g,this.modifiedStart=m,this.modifiedLength=v}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=r}),Y(X[5],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.NotSupportedError=n.CancellationError=n.errorHandler=n.ErrorHandler=void 0,n.onUnexpectedError=x,n.onUnexpectedExternalError=M,n.transformErrorForSerialization=g,n.isCancellationError=v,n.canceled=a,n.illegalArgument=b,n.illegalState=e;class r{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(h){setTimeout(()=>{throw h.stack?s.isErrorNoTelemetry(h)?new s(h.message+`

`+h.stack):new Error(h.message+`

`+h.stack):h},0)}}emit(h){this.listeners.forEach(S=>{S(h)})}onUnexpectedError(h){this.unexpectedErrorHandler(h),this.emit(h)}onUnexpectedExternalError(h){this.unexpectedErrorHandler(h)}}n.ErrorHandler=r,n.errorHandler=new r;function x(d){v(d)||n.errorHandler.onUnexpectedError(d)}function M(d){v(d)||n.errorHandler.onUnexpectedExternalError(d)}function g(d){if(d instanceof Error){const{name:h,message:S}=d,_=d.stacktrace||d.stack;return{$isError:!0,name:h,message:S,stack:_,noTelemetry:s.isErrorNoTelemetry(d)}}return d}const m="Canceled";function v(d){return d instanceof o?!0:d instanceof Error&&d.name===m&&d.message===m}class o extends Error{constructor(){super(m),this.name=this.message}}n.CancellationError=o;function a(){const d=new Error(m);return d.name=d.message,d}function b(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}function e(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}class f extends Error{constructor(h){super("NotSupported"),h&&(this.message=h)}}n.NotSupportedError=f;class s extends Error{constructor(h){super(h),this.name="CodeExpectedError"}static fromError(h){if(h instanceof s)return h;const S=new s;return S.message=h.message,S.stack=h.stack,S}static isErrorNoTelemetry(h){return h.name==="CodeExpectedError"}}n.ErrorNoTelemetry=s;class u extends Error{constructor(h){super(h||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype)}}n.BugIndicatingError=u}),Y(X[12],Z([0,1,5]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ok=x,n.assertNever=M,n.softAssert=g,n.assertFn=m,n.checkAdjacentItems=v;function x(o,a){if(!o)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}function M(o,a="Unreachable"){throw new Error(a)}function g(o){o||(0,r.onUnexpectedError)(new r.BugIndicatingError("Soft Assertion Failed"))}function m(o){if(!o()){debugger;o(),(0,r.onUnexpectedError)(new r.BugIndicatingError("Assertion Failed"))}}function v(o,a){let b=0;for(;b<o.length-1;){const e=o[b],f=o[b+1];if(!a(e,f))return!1;b++}return!0}}),Y(X[20],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createSingleCallFunction=r;function r(x,M){const g=this;let m=!1,v;return function(){if(m)return v;if(m=!0,M)try{v=x.apply(g,arguments)}finally{M()}else v=x.apply(g,arguments);return v}}}),Y(X[21],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var r;(function(x){function M(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}x.is=M;const g=Object.freeze([]);function m(){return g}x.empty=m;function*v(i){yield i}x.single=v;function o(i){return M(i)?i:v(i)}x.wrap=o;function a(i){return i||g}x.from=a;function*b(i){for(let l=i.length-1;l>=0;l--)yield i[l]}x.reverse=b;function e(i){return!i||i[Symbol.iterator]().next().done===!0}x.isEmpty=e;function f(i){return i[Symbol.iterator]().next().value}x.first=f;function s(i,l){for(const c of i)if(l(c))return!0;return!1}x.some=s;function u(i,l){for(const c of i)if(l(c))return c}x.find=u;function*d(i,l){for(const c of i)l(c)&&(yield c)}x.filter=d;function*h(i,l){let c=0;for(const L of i)yield l(L,c++)}x.map=h;function*S(...i){for(const l of i)yield*l}x.concat=S;function _(i,l,c){let L=c;for(const w of i)L=l(L,w);return L}x.reduce=_;function*E(i,l,c=i.length){for(l<0&&(l+=i.length),c<0?c+=i.length:c>i.length&&(c=i.length);l<c;l++)yield i[l]}x.slice=E;function A(i,l=Number.POSITIVE_INFINITY){const c=[];if(l===0)return[c,i];const L=i[Symbol.iterator]();for(let w=0;w<l;w++){const C=L.next();if(C.done)return[c,x.empty()];c.push(C.value)}return[c,{[Symbol.iterator](){return L}}]}x.consume=A;async function p(i){const l=[];for await(const c of i)l.push(c);return Promise.resolve(l)}x.asyncToArray=p})(r||(n.Iterable=r={}))}),Y(X[37],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=void 0,n.KeyChord=b;class r{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(f,s){this._keyCodeToStr[f]=s,this._strToKeyCode[s.toLowerCase()]=f}keyCodeToStr(f){return this._keyCodeToStr[f]}strToKeyCode(f){return this._strToKeyCode[f.toLowerCase()]||0}}const x=new r,M=new r,g=new r;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const m=[],v=Object.create(null),o=Object.create(null);n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",f=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],s=[],u=[];for(const d of f){const[h,S,_,E,A,p,i,l,c]=d;if(u[S]||(u[S]=!0,m[S]=_,v[_]=S,o[_.toLowerCase()]=S,h&&(n.IMMUTABLE_CODE_TO_KEY_CODE[S]=E,E!==0&&E!==3&&E!==5&&E!==4&&E!==6&&E!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[E]=S))),!s[E]){if(s[E]=!0,!A)throw new Error(`String representation missing for key code ${E} around scan code ${_}`);x.define(E,A),M.define(E,l||A),g.define(E,c||l||A)}p&&(n.EVENT_KEY_CODE_MAP[p]=E),i&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[i]=E)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var a;(function(e){function f(_){return x.keyCodeToStr(_)}e.toString=f;function s(_){return x.strToKeyCode(_)}e.fromString=s;function u(_){return M.keyCodeToStr(_)}e.toUserSettingsUS=u;function d(_){return g.keyCodeToStr(_)}e.toUserSettingsGeneral=d;function h(_){return M.strToKeyCode(_)||g.strToKeyCode(_)}e.fromUserSettings=h;function S(_){if(_>=98&&_<=113)return null;switch(_){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return x.keyCodeToStr(_)}e.toElectronAccelerator=S})(a||(n.KeyCodeUtils=a={}));function b(e,f){const s=(f&65535)<<16>>>0;return(e|s)>>>0}}),Y(X[38],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class r{constructor(M){this.executor=M,this._didRun=!1}get value(){if(!this._didRun)try{this._value=this.executor()}catch(M){this._error=M}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}n.Lazy=r}),Y(X[13],Z([0,1,20,21]),function(O,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DisposableMap=n.ImmortalReference=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=void 0,n.setDisposableTracker=m,n.trackDisposable=v,n.markAsDisposed=o,n.markAsSingleton=e,n.isDisposable=f,n.dispose=s,n.combinedDisposable=u,n.toDisposable=d;const M=!1;let g=null;function m(i){g=i}if(M){const i="__is_disposable_tracked__";m(new class{trackDisposable(l){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[i]||console.log(c)},3e3)}setParent(l,c){if(l&&l!==S.None)try{l[i]=!0}catch{}}markAsDisposed(l){if(l&&l!==S.None)try{l[i]=!0}catch{}}markAsSingleton(l){}})}function v(i){return g?.trackDisposable(i),i}function o(i){g?.markAsDisposed(i)}function a(i,l){g?.setParent(i,l)}function b(i,l){if(g)for(const c of i)g.setParent(c,l)}function e(i){return g?.markAsSingleton(i),i}function f(i){return typeof i=="object"&&i!==null&&typeof i.dispose=="function"&&i.dispose.length===0}function s(i){if(x.Iterable.is(i)){const l=[];for(const c of i)if(c)try{c.dispose()}catch(L){l.push(L)}if(l.length===1)throw l[0];if(l.length>1)throw new AggregateError(l,"Encountered errors while disposing of store");return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}function u(...i){const l=d(()=>s(i));return b(i,l),l}function d(i){const l=v({dispose:(0,r.createSingleCallFunction)(()=>{o(l),i()})});return l}class h{constructor(){this._toDispose=new Set,this._isDisposed=!1,v(this)}dispose(){this._isDisposed||(o(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{s(this._toDispose)}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return a(l,this),this._isDisposed?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}deleteAndLeak(l){l&&this._toDispose.has(l)&&(this._toDispose.delete(l),a(l,null))}}n.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class S{constructor(){this._store=new h,v(this),a(this._store,this)}dispose(){o(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}n.Disposable=S,S.None=Object.freeze({dispose(){}});class _{constructor(){this._isDisposed=!1,v(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){var c;this._isDisposed||l===this._value||((c=this._value)===null||c===void 0||c.dispose(),l&&a(l,this),this._value=l)}clear(){this.value=void 0}dispose(){var l;this._isDisposed=!0,o(this),(l=this._value)===null||l===void 0||l.dispose(),this._value=void 0}}n.MutableDisposable=_;class E{constructor(l){this._disposable=l,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}n.RefCountedDisposable=E;class A{constructor(l){this.object=l}dispose(){}}n.ImmortalReference=A;class p{constructor(){this._store=new Map,this._isDisposed=!1,v(this)}dispose(){o(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{s(this._store.values())}finally{this._store.clear()}}get(l){return this._store.get(l)}set(l,c,L=!1){var w;this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),L||(w=this._store.get(l))===null||w===void 0||w.dispose(),this._store.set(l,c)}deleteAndDispose(l){var c;(c=this._store.get(l))===null||c===void 0||c.dispose(),this._store.delete(l)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}n.DisposableMap=p}),Y(X[22],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class r{constructor(g){this.element=g,this.next=r.Undefined,this.prev=r.Undefined}}r.Undefined=new r(void 0);class x{constructor(){this._first=r.Undefined,this._last=r.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===r.Undefined}clear(){let g=this._first;for(;g!==r.Undefined;){const m=g.next;g.prev=r.Undefined,g.next=r.Undefined,g=m}this._first=r.Undefined,this._last=r.Undefined,this._size=0}unshift(g){return this._insert(g,!1)}push(g){return this._insert(g,!0)}_insert(g,m){const v=new r(g);if(this._first===r.Undefined)this._first=v,this._last=v;else if(m){const a=this._last;this._last=v,v.prev=a,a.next=v}else{const a=this._first;this._first=v,v.next=a,a.prev=v}this._size+=1;let o=!1;return()=>{o||(o=!0,this._remove(v))}}shift(){if(this._first!==r.Undefined){const g=this._first.element;return this._remove(this._first),g}}pop(){if(this._last!==r.Undefined){const g=this._last.element;return this._remove(this._last),g}}_remove(g){if(g.prev!==r.Undefined&&g.next!==r.Undefined){const m=g.prev;m.next=g.next,g.next.prev=m}else g.prev===r.Undefined&&g.next===r.Undefined?(this._first=r.Undefined,this._last=r.Undefined):g.next===r.Undefined?(this._last=this._last.prev,this._last.next=r.Undefined):g.prev===r.Undefined&&(this._first=this._first.next,this._first.prev=r.Undefined);this._size-=1}*[Symbol.iterator](){let g=this._first;for(;g!==r.Undefined;)yield g.element,g=g.next}}n.LinkedList=x}),Y(X[23],Z([0,1]),function(O,n){"use strict";var r,x;Object.defineProperty(n,"__esModule",{value:!0}),n.SetMap=n.BidirectionalMap=n.LRUCache=n.LinkedMap=n.ResourceMap=void 0;class M{constructor(s,u){this.uri=s,this.value=u}}function g(f){return Array.isArray(f)}class m{constructor(s,u){if(this[r]="ResourceMap",s instanceof m)this.map=new Map(s.map),this.toKey=u??m.defaultToKey;else if(g(s)){this.map=new Map,this.toKey=u??m.defaultToKey;for(const[d,h]of s)this.set(d,h)}else this.map=new Map,this.toKey=s??m.defaultToKey}set(s,u){return this.map.set(this.toKey(s),new M(s,u)),this}get(s){var u;return(u=this.map.get(this.toKey(s)))===null||u===void 0?void 0:u.value}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,u){typeof u<"u"&&(s=s.bind(u));for(const[d,h]of this.map)s(h.value,h.uri,this)}*values(){for(const s of this.map.values())yield s.value}*keys(){for(const s of this.map.values())yield s.uri}*entries(){for(const s of this.map.values())yield[s.uri,s.value]}*[(r=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.map)yield[s.uri,s.value]}}n.ResourceMap=m,m.defaultToKey=f=>f.toString();class v{constructor(){this[x]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var s;return(s=this._head)===null||s===void 0?void 0:s.value}get last(){var s;return(s=this._tail)===null||s===void 0?void 0:s.value}has(s){return this._map.has(s)}get(s,u=0){const d=this._map.get(s);if(d)return u!==0&&this.touch(d,u),d.value}set(s,u,d=0){let h=this._map.get(s);if(h)h.value=u,d!==0&&this.touch(h,d);else{switch(h={key:s,value:u,next:void 0,previous:void 0},d){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(s,h),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const u=this._map.get(s);if(u)return this._map.delete(s),this.removeItem(u),this._size--,u.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,u){const d=this._state;let h=this._head;for(;h;){if(u?s.bind(u)(h.value,h.key,this):s(h.value,h.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const s=this,u=this._state;let d=this._head;const h={[Symbol.iterator](){return h},next(){if(s._state!==u)throw new Error("LinkedMap got modified during iteration.");if(d){const S={value:d.key,done:!1};return d=d.next,S}else return{value:void 0,done:!0}}};return h}values(){const s=this,u=this._state;let d=this._head;const h={[Symbol.iterator](){return h},next(){if(s._state!==u)throw new Error("LinkedMap got modified during iteration.");if(d){const S={value:d.value,done:!1};return d=d.next,S}else return{value:void 0,done:!0}}};return h}entries(){const s=this,u=this._state;let d=this._head;const h={[Symbol.iterator](){return h},next(){if(s._state!==u)throw new Error("LinkedMap got modified during iteration.");if(d){const S={value:[d.key,d.value],done:!1};return d=d.next,S}else return{value:void 0,done:!0}}};return h}[(x=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let u=this._head,d=this.size;for(;u&&d>s;)this._map.delete(u.key),u=u.next,d--;this._head=u,this._size=d,u&&(u.previous=void 0),this._state++}trimNew(s){if(s>=this.size)return;if(s===0){this.clear();return}let u=this._tail,d=this.size;for(;u&&d>s;)this._map.delete(u.key),u=u.previous,d--;this._tail=u,this._size=d,u&&(u.next=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const u=s.next,d=s.previous;if(!u||!d)throw new Error("Invalid list");u.previous=d,d.next=u}s.next=void 0,s.previous=void 0,this._state++}touch(s,u){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(s===this._head)return;const d=s.next,h=s.previous;s===this._tail?(h.next=void 0,this._tail=h):(d.previous=h,h.next=d),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(u===2){if(s===this._tail)return;const d=s.next,h=s.previous;s===this._head?(d.previous=void 0,this._head=d):(d.previous=h,h.next=d),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((u,d)=>{s.push([d,u])}),s}fromJSON(s){this.clear();for(const[u,d]of s)this.set(u,d)}}n.LinkedMap=v;class o extends v{constructor(s,u=1){super(),this._limit=s,this._ratio=Math.min(Math.max(0,u),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get(s,u=2){return super.get(s,u)}peek(s){return super.get(s,0)}set(s,u){return super.set(s,u,2),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class a extends o{constructor(s,u=1){super(s,u)}trim(s){this.trimOld(s)}set(s,u){return super.set(s,u),this.checkTrim(),this}}n.LRUCache=a;class b{constructor(s){if(this._m1=new Map,this._m2=new Map,s)for(const[u,d]of s)this.set(u,d)}clear(){this._m1.clear(),this._m2.clear()}set(s,u){this._m1.set(s,u),this._m2.set(u,s)}get(s){return this._m1.get(s)}getKey(s){return this._m2.get(s)}delete(s){const u=this._m1.get(s);return u===void 0?!1:(this._m1.delete(s),this._m2.delete(u),!0)}keys(){return this._m1.keys()}values(){return this._m1.values()}}n.BidirectionalMap=b;class e{constructor(){this.map=new Map}add(s,u){let d=this.map.get(s);d||(d=new Set,this.map.set(s,d)),d.add(u)}delete(s,u){const d=this.map.get(s);d&&(d.delete(u),d.size===0&&this.map.delete(s))}forEach(s,u){const d=this.map.get(s);d&&d.forEach(u)}get(s){const u=this.map.get(s);return u||new Set}}n.SetMap=e}),Y(X[24],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const r=globalThis.performance&&typeof globalThis.performance.now=="function";class x{static create(g){return new x(g)}constructor(g){this._now=r&&g===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}n.StopWatch=x}),Y(X[9],Z([0,1,5,20,13,22,24]),function(O,n,r,x,M,g,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.createEventDeliveryQueue=n.Emitter=n.EventProfiling=n.Event=void 0;const v=!1,o=!1,a=!1;var b;(function(N){N.None=()=>M.Disposable.None;function y(K){if(a){const{onDidAddListener:$}=K,ee=u.create();let J=0;K.onDidAddListener=()=>{++J===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ee.print()),$?.()}}}function R(K,$){return V(K,()=>{},0,void 0,!0,void 0,$)}N.defer=R;function D(K){return($,ee=null,J)=>{let re=!1,ne;return ne=K(ie=>{if(!re)return ne?ne.dispose():re=!0,$.call(ee,ie)},null,J),re&&ne.dispose(),ne}}N.once=D;function T(K,$,ee){return I((J,re=null,ne)=>K(ie=>J.call(re,$(ie)),null,ne),ee)}N.map=T;function k(K,$,ee){return I((J,re=null,ne)=>K(ie=>{$(ie),J.call(re,ie)},null,ne),ee)}N.forEach=k;function q(K,$,ee){return I((J,re=null,ne)=>K(ie=>$(ie)&&J.call(re,ie),null,ne),ee)}N.filter=q;function H(K){return K}N.signal=H;function Q(...K){return($,ee=null,J)=>{const re=(0,M.combinedDisposable)(...K.map(ne=>ne(ie=>$.call(ee,ie))));return W(re,J)}}N.any=Q;function F(K,$,ee,J){let re=ee;return T(K,ne=>(re=$(re,ne),re),J)}N.reduce=F;function I(K,$){let ee;const J={onWillAddFirstListener(){ee=K(re.fire,re)},onDidRemoveLastListener(){ee?.dispose()}};$||y(J);const re=new E(J);return $?.add(re),re.event}function W(K,$){return $ instanceof Array?$.push(K):$&&$.add(K),K}function V(K,$,ee=100,J=!1,re=!1,ne,ie){let P,B,j,G=0,te;const ae={leakWarningThreshold:ne,onWillAddFirstListener(){P=K(be=>{G++,B=$(B,be),J&&!j&&(oe.fire(B),B=void 0),te=()=>{const fe=B;B=void 0,j=void 0,(!J||G>1)&&oe.fire(fe),G=0},typeof ee=="number"?(clearTimeout(j),j=setTimeout(te,ee)):j===void 0&&(j=0,queueMicrotask(te))})},onWillRemoveListener(){re&&G>0&&te?.()},onDidRemoveLastListener(){te=void 0,P.dispose()}};ie||y(ae);const oe=new E(ae);return ie?.add(oe),oe.event}N.debounce=V;function z(K,$=0,ee){return N.debounce(K,(J,re)=>J?(J.push(re),J):[re],$,void 0,!0,void 0,ee)}N.accumulate=z;function U(K,$=(J,re)=>J===re,ee){let J=!0,re;return q(K,ne=>{const ie=J||!$(ne,re);return J=!1,re=ne,ie},ee)}N.latch=U;function se(K,$,ee){return[N.filter(K,$,ee),N.filter(K,J=>!$(J),ee)]}N.split=se;function he(K,$=!1,ee=[],J){let re=ee.slice(),ne=K(B=>{re?re.push(B):P.fire(B)});J&&J.add(ne);const ie=()=>{re?.forEach(B=>P.fire(B)),re=null},P=new E({onWillAddFirstListener(){ne||(ne=K(B=>P.fire(B)),J&&J.add(ne))},onDidAddFirstListener(){re&&($?setTimeout(ie):ie())},onDidRemoveLastListener(){ne&&ne.dispose(),ne=null}});return J&&J.add(P),P.event}N.buffer=he;function de(K,$){return(J,re,ne)=>{const ie=$(new t);return K(function(P){const B=ie.evaluate(P);B!==me&&J.call(re,B)},void 0,ne)}}N.chain=de;const me=Symbol("HaltChainable");class t{constructor(){this.steps=[]}map($){return this.steps.push($),this}forEach($){return this.steps.push(ee=>($(ee),ee)),this}filter($){return this.steps.push(ee=>$(ee)?ee:me),this}reduce($,ee){let J=ee;return this.steps.push(re=>(J=$(J,re),J)),this}latch($=(ee,J)=>ee===J){let ee=!0,J;return this.steps.push(re=>{const ne=ee||!$(re,J);return ee=!1,J=re,ne?re:me}),this}evaluate($){for(const ee of this.steps)if($=ee($),$===me)break;return $}}function we(K,$,ee=J=>J){const J=(...P)=>ie.fire(ee(...P)),re=()=>K.on($,J),ne=()=>K.removeListener($,J),ie=new E({onWillAddFirstListener:re,onDidRemoveLastListener:ne});return ie.event}N.fromNodeEventEmitter=we;function _e(K,$,ee=J=>J){const J=(...P)=>ie.fire(ee(...P)),re=()=>K.addEventListener($,J),ne=()=>K.removeEventListener($,J),ie=new E({onWillAddFirstListener:re,onDidRemoveLastListener:ne});return ie.event}N.fromDOMEventEmitter=_e;function Ce(K){return new Promise($=>D(K)($))}N.toPromise=Ce;function ve(K){const $=new E;return K.then(ee=>{$.fire(ee)},()=>{$.fire(void 0)}).finally(()=>{$.dispose()}),$.event}N.fromPromise=ve;function Se(K,$,ee){return $(ee),K(J=>$(J))}N.runAndSubscribe=Se;class ye{constructor($,ee){this._observable=$,this._counter=0,this._hasChanged=!1;const J={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};ee||y(J),this.emitter=new E(J),ee&&ee.add(this.emitter)}beginUpdate($){this._counter++}handlePossibleChange($){}handleChange($,ee){this._hasChanged=!0}endUpdate($){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function Ne(K,$){return new ye(K,$).emitter.event}N.fromObservable=Ne;function pe(K){return($,ee,J)=>{let re=0,ne=!1;const ie={beginUpdate(){re++},endUpdate(){re--,re===0&&(K.reportChanges(),ne&&(ne=!1,$.call(ee)))},handlePossibleChange(){},handleChange(){ne=!0}};K.addObserver(ie),K.reportChanges();const P={dispose(){K.removeObserver(ie)}};return J instanceof M.DisposableStore?J.add(P):Array.isArray(J)&&J.push(P),P}}N.fromObservableLight=pe})(b||(n.Event=b={}));class e{constructor(y){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${y}_${e._idPool++}`,e.all.add(this)}start(y){this._stopWatch=new m.StopWatch,this.listenerCount=y}stop(){if(this._stopWatch){const y=this._stopWatch.elapsed();this.durations.push(y),this.elapsedOverall+=y,this.invocationCount+=1,this._stopWatch=void 0}}}n.EventProfiling=e,e.all=new Set,e._idPool=0;let f=-1;class s{constructor(y,R=Math.random().toString(18).slice(2,5)){this.threshold=y,this.name=R,this._warnCountdown=0}dispose(){var y;(y=this._stacks)===null||y===void 0||y.clear()}check(y,R){const D=this.threshold;if(D<=0||R<D)return;this._stacks||(this._stacks=new Map);const T=this._stacks.get(y.value)||0;if(this._stacks.set(y.value,T+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=D*.5;let k,q=0;for(const[H,Q]of this._stacks)(!k||q<Q)&&(k=H,q=Q);console.warn(`[${this.name}] potential listener LEAK detected, having ${R} listeners already. MOST frequent listener (${q}):`),console.warn(k)}return()=>{const k=this._stacks.get(y.value)||0;this._stacks.set(y.value,k-1)}}}class u{static create(){var y;return new u((y=new Error().stack)!==null&&y!==void 0?y:"")}constructor(y){this.value=y}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d{constructor(y){this.value=y}}const h=2,S=(N,y)=>{if(N instanceof d)y(N);else for(let R=0;R<N.length;R++){const D=N[R];D&&y(D)}},_=v?new FinalizationRegistry(N=>{typeof N=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(N))}):void 0;class E{constructor(y){var R,D,T,k,q;this._size=0,this._options=y,this._leakageMon=f>0||!((R=this._options)===null||R===void 0)&&R.leakWarningThreshold?new s((T=(D=this._options)===null||D===void 0?void 0:D.leakWarningThreshold)!==null&&T!==void 0?T:f):void 0,this._perfMon=!((k=this._options)===null||k===void 0)&&k._profName?new e(this._options._profName):void 0,this._deliveryQueue=(q=this._options)===null||q===void 0?void 0:q.deliveryQueue}dispose(){var y,R,D,T;if(!this._disposed){if(this._disposed=!0,((y=this._deliveryQueue)===null||y===void 0?void 0:y.current)===this&&this._deliveryQueue.reset(),this._listeners){if(o){const k=this._listeners;queueMicrotask(()=>{S(k,q=>{var H;return(H=q.stack)===null||H===void 0?void 0:H.print()})})}this._listeners=void 0,this._size=0}(D=(R=this._options)===null||R===void 0?void 0:R.onDidRemoveLastListener)===null||D===void 0||D.call(R),(T=this._leakageMon)===null||T===void 0||T.dispose()}}get event(){var y;return(y=this._event)!==null&&y!==void 0||(this._event=(R,D,T)=>{var k,q,H,Q,F;if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),M.Disposable.None;if(this._disposed)return M.Disposable.None;D&&(R=R.bind(D));const I=new d(R);let W,V;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(I.stack=u.create(),W=this._leakageMon.check(I.stack,this._size+1)),o&&(I.stack=V??u.create()),this._listeners?this._listeners instanceof d?((F=this._deliveryQueue)!==null&&F!==void 0||(this._deliveryQueue=new p),this._listeners=[this._listeners,I]):this._listeners.push(I):((q=(k=this._options)===null||k===void 0?void 0:k.onWillAddFirstListener)===null||q===void 0||q.call(k,this),this._listeners=I,(Q=(H=this._options)===null||H===void 0?void 0:H.onDidAddFirstListener)===null||Q===void 0||Q.call(H,this)),this._size++;const z=(0,M.toDisposable)(()=>{_?.unregister(z),W?.(),this._removeListener(I)});if(T instanceof M.DisposableStore?T.add(z):Array.isArray(T)&&T.push(z),_){const U=new Error().stack.split(`
`).slice(2).join(`
`).trim();_.register(z,U,z)}return z}),this._event}_removeListener(y){var R,D,T,k;if((D=(R=this._options)===null||R===void 0?void 0:R.onWillRemoveListener)===null||D===void 0||D.call(R,this),!this._listeners)return;if(this._size===1){this._listeners=void 0,(k=(T=this._options)===null||T===void 0?void 0:T.onDidRemoveLastListener)===null||k===void 0||k.call(T,this),this._size=0;return}const q=this._listeners,H=q.indexOf(y);if(H===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,q[H]=void 0;const Q=this._deliveryQueue.current===this;if(this._size*h<=q.length){let F=0;for(let I=0;I<q.length;I++)q[I]?q[F++]=q[I]:Q&&(this._deliveryQueue.end--,F<this._deliveryQueue.i&&this._deliveryQueue.i--);q.length=F}}_deliver(y,R){var D;if(!y)return;const T=((D=this._options)===null||D===void 0?void 0:D.onListenerError)||r.onUnexpectedError;if(!T){y.value(R);return}try{y.value(R)}catch(k){T(k)}}_deliverQueue(y){const R=y.current._listeners;for(;y.i<y.end;)this._deliver(R[y.i++],y.value);y.reset()}fire(y){var R,D,T,k;if(!((R=this._deliveryQueue)===null||R===void 0)&&R.current&&(this._deliverQueue(this._deliveryQueue),(D=this._perfMon)===null||D===void 0||D.stop()),(T=this._perfMon)===null||T===void 0||T.start(this._size),this._listeners)if(this._listeners instanceof d)this._deliver(this._listeners,y);else{const q=this._deliveryQueue;q.enqueue(this,y,this._listeners.length),this._deliverQueue(q)}(k=this._perfMon)===null||k===void 0||k.stop()}hasListeners(){return this._size>0}}n.Emitter=E;const A=()=>new p;n.createEventDeliveryQueue=A;class p{constructor(){this.i=-1,this.end=0}enqueue(y,R,D){this.i=0,this.end=D,this.current=y,this.value=R}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends E{constructor(y){super(y),this._isPaused=0,this._eventQueue=new g.LinkedList,this._mergeFn=y?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const y=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(y))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(y){this._size&&(this._isPaused!==0?this._eventQueue.push(y):super.fire(y))}}n.PauseableEmitter=i;class l extends i{constructor(y){var R;super(y),this._delay=(R=y.delay)!==null&&R!==void 0?R:100}fire(y){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(y)}}n.DebounceEmitter=l;class c extends E{constructor(y){super(y),this._queuedEvents=[],this._mergeFn=y?.merge}fire(y){this.hasListeners()&&(this._queuedEvents.push(y),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(R=>super.fire(R)),this._queuedEvents=[]}))}}n.MicrotaskEmitter=c;class L{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new E({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(y){const R={event:y,listener:null};this.events.push(R),this.hasListeners&&this.hook(R);const D=()=>{this.hasListeners&&this.unhook(R);const T=this.events.indexOf(R);this.events.splice(T,1)};return(0,M.toDisposable)((0,x.createSingleCallFunction)(D))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(y=>this.hook(y))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(y=>this.unhook(y))}hook(y){y.listener=y.event(R=>this.emitter.fire(R))}unhook(y){var R;(R=y.listener)===null||R===void 0||R.dispose(),y.listener=null}dispose(){var y;this.emitter.dispose();for(const R of this.events)(y=R.listener)===null||y===void 0||y.dispose();this.events=[]}}n.EventMultiplexer=L;class w{constructor(){this.buffers=[]}wrapEvent(y){return(R,D,T)=>y(k=>{const q=this.buffers[this.buffers.length-1];q?q.push(()=>R.call(D,k)):R.call(D,k)},void 0,T)}bufferEvents(y){const R=[];this.buffers.push(R);const D=y();return this.buffers.pop(),R.forEach(T=>T()),D}}n.EventBufferer=w;class C{constructor(){this.listening=!1,this.inputEvent=b.None,this.inputEventListener=M.Disposable.None,this.emitter=new E({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(y){this.inputEvent=y,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=y(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=C}),Y(X[39],Z([0,1,9]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const x=Object.freeze(function(v,o){const a=setTimeout(v.bind(o),0);return{dispose(){clearTimeout(a)}}});var M;(function(v){function o(a){return a===v.None||a===v.Cancelled||a instanceof g?!0:!a||typeof a!="object"?!1:typeof a.isCancellationRequested=="boolean"&&typeof a.onCancellationRequested=="function"}v.isCancellationToken=o,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:r.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:x})})(M||(n.CancellationToken=M={}));class g{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?x:(this._emitter||(this._emitter=new r.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class m{constructor(o){this._token=void 0,this._parentListener=void 0,this._parentListener=o&&o.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new g),this._token}cancel(){this._token?this._token instanceof g&&this._token.cancel():this._token=M.Cancelled}dispose(o=!1){var a;o&&this.cancel(),(a=this._parentListener)===null||a===void 0||a.dispose(),this._token?this._token instanceof g&&this._token.dispose():this._token=M.None}}n.CancellationTokenSource=m}),Y(X[6],Z([0,1,34,38]),function(O,n,r,x){"use strict";var M;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.UTF8_BOM_CHARACTER=n.UNUSUAL_LINE_TERMINATORS=n.GraphemeIterator=n.CodePointIterator=void 0,n.isFalsyOrWhitespace=g,n.format=v,n.htmlAttributeEncodeValue=o,n.escape=a,n.escapeRegExpCharacters=b,n.trim=e,n.ltrim=f,n.rtrim=s,n.convertSimple2RegExpPattern=u,n.stripWildcards=d,n.createRegExp=h,n.regExpLeadsToEndlessLoop=S,n.splitLines=_,n.splitLinesIncludeSeparators=E,n.firstNonWhitespaceIndex=A,n.getLeadingWhitespace=p,n.lastNonWhitespaceIndex=i,n.compare=l,n.compareSubstring=c,n.compareIgnoreCase=L,n.compareSubstringIgnoreCase=w,n.isAsciiDigit=C,n.isLowerAsciiLetter=N,n.isUpperAsciiLetter=y,n.equalsIgnoreCase=R,n.startsWithIgnoreCase=D,n.commonPrefixLength=T,n.commonSuffixLength=k,n.isHighSurrogate=q,n.isLowSurrogate=H,n.computeCodePoint=Q,n.getNextCodePoint=F,n.nextCharLength=z,n.prevCharLength=U,n.getCharContainingOffset=se,n.containsRTL=me,n.isBasicASCII=we,n.containsUnusualLineTerminators=_e,n.isFullWidthCharacter=Ce,n.isEmojiImprecise=ve,n.startsWithUTF8BOM=Se,n.containsUppercaseCharacter=ye,n.singleLetterHash=Ne,n.getLeftDeleteOffset=ee;function g(P){return!P||typeof P!="string"?!0:P.trim().length===0}const m=/{(\d+)}/g;function v(P,...B){return B.length===0?P:P.replace(m,function(j,G){const te=parseInt(G,10);return isNaN(te)||te<0||te>=B.length?j:B[te]})}function o(P){return P.replace(/[<>"'&]/g,B=>{switch(B){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return B})}function a(P){return P.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}function b(P){return P.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function e(P,B=" "){const j=f(P,B);return s(j,B)}function f(P,B){if(!P||!B)return P;const j=B.length;if(j===0||P.length===0)return P;let G=0;for(;P.indexOf(B,G)===G;)G=G+j;return P.substring(G)}function s(P,B){if(!P||!B)return P;const j=B.length,G=P.length;if(j===0||G===0)return P;let te=G,ae=-1;for(;ae=P.lastIndexOf(B,te-1),!(ae===-1||ae+j!==te);){if(ae===0)return"";te=ae}return P.substring(0,te)}function u(P){return P.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function d(P){return P.replace(/\*/g,"")}function h(P,B,j={}){if(!P)throw new Error("Cannot create regex from empty string");B||(P=b(P)),j.wholeWord&&(/\B/.test(P.charAt(0))||(P="\\b"+P),/\B/.test(P.charAt(P.length-1))||(P=P+"\\b"));let G="";return j.global&&(G+="g"),j.matchCase||(G+="i"),j.multiline&&(G+="m"),j.unicode&&(G+="u"),new RegExp(P,G)}function S(P){return P.source==="^"||P.source==="^$"||P.source==="$"||P.source==="^\\s*$"?!1:!!(P.exec("")&&P.lastIndex===0)}function _(P){return P.split(/\r\n|\r|\n/)}function E(P){var B;const j=[],G=P.split(/(\r\n|\r|\n)/);for(let te=0;te<Math.ceil(G.length/2);te++)j.push(G[2*te]+((B=G[2*te+1])!==null&&B!==void 0?B:""));return j}function A(P){for(let B=0,j=P.length;B<j;B++){const G=P.charCodeAt(B);if(G!==32&&G!==9)return B}return-1}function p(P,B=0,j=P.length){for(let G=B;G<j;G++){const te=P.charCodeAt(G);if(te!==32&&te!==9)return P.substring(B,G)}return P.substring(B,j)}function i(P,B=P.length-1){for(let j=B;j>=0;j--){const G=P.charCodeAt(j);if(G!==32&&G!==9)return j}return-1}function l(P,B){return P<B?-1:P>B?1:0}function c(P,B,j=0,G=P.length,te=0,ae=B.length){for(;j<G&&te<ae;j++,te++){const fe=P.charCodeAt(j),le=B.charCodeAt(te);if(fe<le)return-1;if(fe>le)return 1}const oe=G-j,be=ae-te;return oe<be?-1:oe>be?1:0}function L(P,B){return w(P,B,0,P.length,0,B.length)}function w(P,B,j=0,G=P.length,te=0,ae=B.length){for(;j<G&&te<ae;j++,te++){let fe=P.charCodeAt(j),le=B.charCodeAt(te);if(fe===le)continue;if(fe>=128||le>=128)return c(P.toLowerCase(),B.toLowerCase(),j,G,te,ae);N(fe)&&(fe-=32),N(le)&&(le-=32);const ce=fe-le;if(ce!==0)return ce}const oe=G-j,be=ae-te;return oe<be?-1:oe>be?1:0}function C(P){return P>=48&&P<=57}function N(P){return P>=97&&P<=122}function y(P){return P>=65&&P<=90}function R(P,B){return P.length===B.length&&w(P,B)===0}function D(P,B){const j=B.length;return B.length>P.length?!1:w(P,B,0,j)===0}function T(P,B){const j=Math.min(P.length,B.length);let G;for(G=0;G<j;G++)if(P.charCodeAt(G)!==B.charCodeAt(G))return G;return j}function k(P,B){const j=Math.min(P.length,B.length);let G;const te=P.length-1,ae=B.length-1;for(G=0;G<j;G++)if(P.charCodeAt(te-G)!==B.charCodeAt(ae-G))return G;return j}function q(P){return 55296<=P&&P<=56319}function H(P){return 56320<=P&&P<=57343}function Q(P,B){return(P-55296<<10)+(B-56320)+65536}function F(P,B,j){const G=P.charCodeAt(j);if(q(G)&&j+1<B){const te=P.charCodeAt(j+1);if(H(te))return Q(G,te)}return G}function I(P,B){const j=P.charCodeAt(B-1);if(H(j)&&B>1){const G=P.charCodeAt(B-2);if(q(G))return Q(G,j)}return j}class W{get offset(){return this._offset}constructor(B,j=0){this._str=B,this._len=B.length,this._offset=j}setOffset(B){this._offset=B}prevCodePoint(){const B=I(this._str,this._offset);return this._offset-=B>=65536?2:1,B}nextCodePoint(){const B=F(this._str,this._len,this._offset);return this._offset+=B>=65536?2:1,B}eol(){return this._offset>=this._len}}n.CodePointIterator=W;class V{get offset(){return this._iterator.offset}constructor(B,j=0){this._iterator=new W(B,j)}nextGraphemeLength(){const B=K.getInstance(),j=this._iterator,G=j.offset;let te=B.getGraphemeBreakType(j.nextCodePoint());for(;!j.eol();){const ae=j.offset,oe=B.getGraphemeBreakType(j.nextCodePoint());if(pe(te,oe)){j.setOffset(ae);break}te=oe}return j.offset-G}prevGraphemeLength(){const B=K.getInstance(),j=this._iterator,G=j.offset;let te=B.getGraphemeBreakType(j.prevCodePoint());for(;j.offset>0;){const ae=j.offset,oe=B.getGraphemeBreakType(j.prevCodePoint());if(pe(oe,te)){j.setOffset(ae);break}te=oe}return G-j.offset}eol(){return this._iterator.eol()}}n.GraphemeIterator=V;function z(P,B){return new V(P,B).nextGraphemeLength()}function U(P,B){return new V(P,B).prevGraphemeLength()}function se(P,B){B>0&&H(P.charCodeAt(B))&&B--;const j=B+z(P,B);return[j-U(P,j),j]}let he;function de(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function me(P){return he||(he=de()),he.test(P)}const t=/^[\t\n\r\x20-\x7E]*$/;function we(P){return t.test(P)}n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function _e(P){return n.UNUSUAL_LINE_TERMINATORS.test(P)}function Ce(P){return P>=11904&&P<=55215||P>=63744&&P<=64255||P>=65281&&P<=65374}function ve(P){return P>=127462&&P<=127487||P===8986||P===8987||P===9200||P===9203||P>=9728&&P<=10175||P===11088||P===11093||P>=127744&&P<=128591||P>=128640&&P<=128764||P>=128992&&P<=129008||P>=129280&&P<=129535||P>=129648&&P<=129782}n.UTF8_BOM_CHARACTER="\uFEFF";function Se(P){return!!(P&&P.length>0&&P.charCodeAt(0)===65279)}function ye(P,B=!1){return P?(B&&(P=P.replace(/\\./g,"")),P.toLowerCase()!==P):!1}function Ne(P){return P=P%(2*26),P<26?String.fromCharCode(97+P):String.fromCharCode(65+P-26)}function pe(P,B){return P===0?B!==5&&B!==7:P===2&&B===3?!1:P===4||P===2||P===3||B===4||B===2||B===3?!0:!(P===8&&(B===8||B===9||B===11||B===12)||(P===11||P===9)&&(B===9||B===10)||(P===12||P===10)&&B===10||B===5||B===13||B===7||P===1||P===13&&B===14||P===6&&B===6)}class K{static getInstance(){return K._INSTANCE||(K._INSTANCE=new K),K._INSTANCE}constructor(){this._data=$()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const j=this._data,G=j.length/3;let te=1;for(;te<=G;)if(B<j[3*te])te=2*te;else if(B>j[3*te+1])te=2*te+1;else return j[3*te+2];return 0}}K._INSTANCE=null;function $(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ee(P,B){if(P===0)return 0;const j=J(P,B);if(j!==void 0)return j;const G=new W(B,P);return G.prevCodePoint(),G.offset}function J(P,B){const j=new W(B,P);let G=j.prevCodePoint();for(;re(G)||G===65039||G===8419;){if(j.offset===0)return;G=j.prevCodePoint()}if(!ve(G))return;let te=j.offset;return te>0&&j.prevCodePoint()===8205&&(te=j.offset),te}function re(P){return 127995<=P&&P<=127999}n.noBreakWhitespace="\xA0";class ne{static getInstance(B){return M.cache.get(Array.from(B))}static getLocales(){return M._locales.value}constructor(B){this.confusableDictionary=B}isAmbiguous(B){return this.confusableDictionary.has(B)}getPrimaryConfusable(B){return this.confusableDictionary.get(B)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}n.AmbiguousCharacters=ne,M=ne,ne.ambiguousCharacterData=new x.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ne.cache=new r.LRUCachedFunction({getCacheKey:JSON.stringify},P=>{function B(le){const ce=new Map;for(let ge=0;ge<le.length;ge+=2)ce.set(le[ge],le[ge+1]);return ce}function j(le,ce){const ge=new Map(le);for(const[Le,Ee]of ce)ge.set(Le,Ee);return ge}function G(le,ce){if(!le)return ce;const ge=new Map;for(const[Le,Ee]of le)ce.has(Le)&&ge.set(Le,Ee);return ge}const te=M.ambiguousCharacterData.value;let ae=P.filter(le=>!le.startsWith("_")&&le in te);ae.length===0&&(ae=["_default"]);let oe;for(const le of ae){const ce=B(te[le]);oe=G(oe,ce)}const be=B(te._common),fe=j(be,oe);return new M(fe)}),ne._locales=new x.Lazy(()=>Object.keys(M.ambiguousCharacterData.value).filter(P=>!P.startsWith("_")));class ie{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(ie.getRawData())),this._data}static isInvisibleCharacter(B){return ie.getData().has(B)}static get codePoints(){return ie.getData()}}n.InvisibleCharacters=ie,ie._data=void 0}),Y(X[40],Z([0,1,6]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=void 0,n.hash=x,n.doHash=M,n.numberHash=g,n.stringHash=v,n.toHexString=s;function x(d){return M(d,0)}function M(d,h){switch(typeof d){case"object":return d===null?g(349,h):Array.isArray(d)?o(d,h):a(d,h);case"string":return v(d,h);case"boolean":return m(d,h);case"number":return g(d,h);case"undefined":return g(937,h);default:return g(617,h)}}function g(d,h){return(h<<5)-h+d|0}function m(d,h){return g(d?433:863,h)}function v(d,h){h=g(149417,h);for(let S=0,_=d.length;S<_;S++)h=g(d.charCodeAt(S),h);return h}function o(d,h){return h=g(104579,h),d.reduce((S,_)=>M(_,S),h)}function a(d,h){return h=g(181387,h),Object.keys(d).sort().reduce((S,_)=>(S=v(_,S),M(d[_],S)),h)}function b(d,h,S=32){const _=S-h,E=~((1<<_)-1);return(d<<h|(E&d)>>>_)>>>0}function e(d,h=0,S=d.byteLength,_=0){for(let E=0;E<S;E++)d[h+E]=_}function f(d,h,S="0"){for(;d.length<h;)d=S+d;return d}function s(d,h=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(S=>S.toString(16).padStart(2,"0")).join(""):f((d>>>0).toString(16),h/4)}class u{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(h){const S=h.length;if(S===0)return;const _=this._buff;let E=this._buffLen,A=this._leftoverHighSurrogate,p,i;for(A!==0?(p=A,i=-1,A=0):(p=h.charCodeAt(0),i=0);;){let l=p;if(r.isHighSurrogate(p))if(i+1<S){const c=h.charCodeAt(i+1);r.isLowSurrogate(c)?(i++,l=r.computeCodePoint(p,c)):l=65533}else{A=p;break}else r.isLowSurrogate(p)&&(l=65533);if(E=this._push(_,E,l),i++,i<S)p=h.charCodeAt(i);else break}this._buffLen=E,this._leftoverHighSurrogate=A}_push(h,S,_){return _<128?h[S++]=_:_<2048?(h[S++]=192|(_&1984)>>>6,h[S++]=128|(_&63)>>>0):_<65536?(h[S++]=224|(_&61440)>>>12,h[S++]=128|(_&4032)>>>6,h[S++]=128|(_&63)>>>0):(h[S++]=240|(_&1835008)>>>18,h[S++]=128|(_&258048)>>>12,h[S++]=128|(_&4032)>>>6,h[S++]=128|(_&63)>>>0),S>=64&&(this._step(),S-=64,this._totalLen+=64,h[0]=h[64],h[1]=h[65],h[2]=h[66]),S}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),s(this._h0)+s(this._h1)+s(this._h2)+s(this._h3)+s(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,e(this._buff,this._buffLen),this._buffLen>56&&(this._step(),e(this._buff));const h=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(h/4294967296),!1),this._buffDV.setUint32(60,h%4294967296,!1),this._step()}_step(){const h=u._bigBlock32,S=this._buffDV;for(let w=0;w<64;w+=4)h.setUint32(w,S.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)h.setUint32(w,b(h.getUint32(w-12,!1)^h.getUint32(w-32,!1)^h.getUint32(w-56,!1)^h.getUint32(w-64,!1),1),!1);let _=this._h0,E=this._h1,A=this._h2,p=this._h3,i=this._h4,l,c,L;for(let w=0;w<80;w++)w<20?(l=E&A|~E&p,c=1518500249):w<40?(l=E^A^p,c=1859775393):w<60?(l=E&A|E&p|A&p,c=2400959708):(l=E^A^p,c=3395469782),L=b(_,5)+l+i+c+h.getUint32(w*4,!1)&4294967295,i=p,p=A,A=b(E,30),E=_,_=L;this._h0=this._h0+_&4294967295,this._h1=this._h1+E&4294967295,this._h2=this._h2+A&4294967295,this._h3=this._h3+p&4294967295,this._h4=this._h4+i&4294967295}}n.StringSHA1=u,u._bigBlock32=new DataView(new ArrayBuffer(320))}),Y(X[25],Z([0,1,36,40]),function(O,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.StringDiffSequence=void 0,n.stringDiff=g;class M{constructor(e){this.source=e}getElements(){const e=this.source,f=new Int32Array(e.length);for(let s=0,u=e.length;s<u;s++)f[s]=e.charCodeAt(s);return f}}n.StringDiffSequence=M;function g(b,e,f){return new a(new M(b),new M(e)).ComputeDiff(f).changes}class m{static Assert(e,f){if(!e)throw new Error(f)}}class v{static Copy(e,f,s,u,d){for(let h=0;h<d;h++)s[u+h]=e[f+h]}static Copy2(e,f,s,u,d){for(let h=0;h<d;h++)s[u+h]=e[f+h]}}class o{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new r.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(e,f){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,f),this.m_originalCount++}AddModifiedElement(e,f){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,f),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class a{constructor(e,f,s=null){this.ContinueProcessingPredicate=s,this._originalSequence=e,this._modifiedSequence=f;const[u,d,h]=a._getElements(e),[S,_,E]=a._getElements(f);this._hasStrings=h&&E,this._originalStringElements=u,this._originalElementsOrHash=d,this._modifiedStringElements=S,this._modifiedElementsOrHash=_,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(e){return e.length>0&&typeof e[0]=="string"}static _getElements(e){const f=e.getElements();if(a._isStringArray(f)){const s=new Int32Array(f.length);for(let u=0,d=f.length;u<d;u++)s[u]=(0,x.stringHash)(f[u],0);return[f,s,!0]}return f instanceof Int32Array?[[],f,!1]:[[],new Int32Array(f),!1]}ElementsAreEqual(e,f){return this._originalElementsOrHash[e]!==this._modifiedElementsOrHash[f]?!1:this._hasStrings?this._originalStringElements[e]===this._modifiedStringElements[f]:!0}ElementsAreStrictEqual(e,f){if(!this.ElementsAreEqual(e,f))return!1;const s=a._getStrictElement(this._originalSequence,e),u=a._getStrictElement(this._modifiedSequence,f);return s===u}static _getStrictElement(e,f){return typeof e.getStrictElement=="function"?e.getStrictElement(f):null}OriginalElementsAreEqual(e,f){return this._originalElementsOrHash[e]!==this._originalElementsOrHash[f]?!1:this._hasStrings?this._originalStringElements[e]===this._originalStringElements[f]:!0}ModifiedElementsAreEqual(e,f){return this._modifiedElementsOrHash[e]!==this._modifiedElementsOrHash[f]?!1:this._hasStrings?this._modifiedStringElements[e]===this._modifiedStringElements[f]:!0}ComputeDiff(e){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,e)}_ComputeDiff(e,f,s,u,d){const h=[!1];let S=this.ComputeDiffRecursive(e,f,s,u,h);return d&&(S=this.PrettifyChanges(S)),{quitEarly:h[0],changes:S}}ComputeDiffRecursive(e,f,s,u,d){for(d[0]=!1;e<=f&&s<=u&&this.ElementsAreEqual(e,s);)e++,s++;for(;f>=e&&u>=s&&this.ElementsAreEqual(f,u);)f--,u--;if(e>f||s>u){let p;return s<=u?(m.Assert(e===f+1,"originalStart should only be one more than originalEnd"),p=[new r.DiffChange(e,0,s,u-s+1)]):e<=f?(m.Assert(s===u+1,"modifiedStart should only be one more than modifiedEnd"),p=[new r.DiffChange(e,f-e+1,s,0)]):(m.Assert(e===f+1,"originalStart should only be one more than originalEnd"),m.Assert(s===u+1,"modifiedStart should only be one more than modifiedEnd"),p=[]),p}const h=[0],S=[0],_=this.ComputeRecursionPoint(e,f,s,u,h,S,d),E=h[0],A=S[0];if(_!==null)return _;if(!d[0]){const p=this.ComputeDiffRecursive(e,E,s,A,d);let i=[];return d[0]?i=[new r.DiffChange(E+1,f-(E+1)+1,A+1,u-(A+1)+1)]:i=this.ComputeDiffRecursive(E+1,f,A+1,u,d),this.ConcatenateChanges(p,i)}return[new r.DiffChange(e,f-e+1,s,u-s+1)]}WALKTRACE(e,f,s,u,d,h,S,_,E,A,p,i,l,c,L,w,C,N){let y=null,R=null,D=new o,T=f,k=s,q=l[0]-w[0]-u,H=-1073741824,Q=this.m_forwardHistory.length-1;do{const F=q+e;F===T||F<k&&E[F-1]<E[F+1]?(p=E[F+1],c=p-q-u,p<H&&D.MarkNextChange(),H=p,D.AddModifiedElement(p+1,c),q=F+1-e):(p=E[F-1]+1,c=p-q-u,p<H&&D.MarkNextChange(),H=p-1,D.AddOriginalElement(p,c+1),q=F-1-e),Q>=0&&(E=this.m_forwardHistory[Q],e=E[0],T=1,k=E.length-1)}while(--Q>=-1);if(y=D.getReverseChanges(),N[0]){let F=l[0]+1,I=w[0]+1;if(y!==null&&y.length>0){const W=y[y.length-1];F=Math.max(F,W.getOriginalEnd()),I=Math.max(I,W.getModifiedEnd())}R=[new r.DiffChange(F,i-F+1,I,L-I+1)]}else{D=new o,T=h,k=S,q=l[0]-w[0]-_,H=1073741824,Q=C?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const F=q+d;F===T||F<k&&A[F-1]>=A[F+1]?(p=A[F+1]-1,c=p-q-_,p>H&&D.MarkNextChange(),H=p+1,D.AddOriginalElement(p+1,c+1),q=F+1-d):(p=A[F-1],c=p-q-_,p>H&&D.MarkNextChange(),H=p,D.AddModifiedElement(p+1,c+1),q=F-1-d),Q>=0&&(A=this.m_reverseHistory[Q],d=A[0],T=1,k=A.length-1)}while(--Q>=-1);R=D.getChanges()}return this.ConcatenateChanges(y,R)}ComputeRecursionPoint(e,f,s,u,d,h,S){let _=0,E=0,A=0,p=0,i=0,l=0;e--,s--,d[0]=0,h[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const c=f-e+(u-s),L=c+1,w=new Int32Array(L),C=new Int32Array(L),N=u-s,y=f-e,R=e-s,D=f-u,k=(y-N)%2===0;w[N]=e,C[y]=f,S[0]=!1;for(let q=1;q<=c/2+1;q++){let H=0,Q=0;A=this.ClipDiagonalBound(N-q,q,N,L),p=this.ClipDiagonalBound(N+q,q,N,L);for(let I=A;I<=p;I+=2){I===A||I<p&&w[I-1]<w[I+1]?_=w[I+1]:_=w[I-1]+1,E=_-(I-N)-R;const W=_;for(;_<f&&E<u&&this.ElementsAreEqual(_+1,E+1);)_++,E++;if(w[I]=_,_+E>H+Q&&(H=_,Q=E),!k&&Math.abs(I-y)<=q-1&&_>=C[I])return d[0]=_,h[0]=E,W<=C[I]&&1447>0&&q<=1448?this.WALKTRACE(N,A,p,R,y,i,l,D,w,C,_,f,d,E,u,h,k,S):null}const F=(H-e+(Q-s)-q)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(H,F))return S[0]=!0,d[0]=H,h[0]=Q,F>0&&1447>0&&q<=1448?this.WALKTRACE(N,A,p,R,y,i,l,D,w,C,_,f,d,E,u,h,k,S):(e++,s++,[new r.DiffChange(e,f-e+1,s,u-s+1)]);i=this.ClipDiagonalBound(y-q,q,y,L),l=this.ClipDiagonalBound(y+q,q,y,L);for(let I=i;I<=l;I+=2){I===i||I<l&&C[I-1]>=C[I+1]?_=C[I+1]-1:_=C[I-1],E=_-(I-y)-D;const W=_;for(;_>e&&E>s&&this.ElementsAreEqual(_,E);)_--,E--;if(C[I]=_,k&&Math.abs(I-N)<=q&&_<=w[I])return d[0]=_,h[0]=E,W>=w[I]&&1447>0&&q<=1448?this.WALKTRACE(N,A,p,R,y,i,l,D,w,C,_,f,d,E,u,h,k,S):null}if(q<=1447){let I=new Int32Array(p-A+2);I[0]=N-A+1,v.Copy2(w,A,I,1,p-A+1),this.m_forwardHistory.push(I),I=new Int32Array(l-i+2),I[0]=y-i+1,v.Copy2(C,i,I,1,l-i+1),this.m_reverseHistory.push(I)}}return this.WALKTRACE(N,A,p,R,y,i,l,D,w,C,_,f,d,E,u,h,k,S)}PrettifyChanges(e){for(let f=0;f<e.length;f++){const s=e[f],u=f<e.length-1?e[f+1].originalStart:this._originalElementsOrHash.length,d=f<e.length-1?e[f+1].modifiedStart:this._modifiedElementsOrHash.length,h=s.originalLength>0,S=s.modifiedLength>0;for(;s.originalStart+s.originalLength<u&&s.modifiedStart+s.modifiedLength<d&&(!h||this.OriginalElementsAreEqual(s.originalStart,s.originalStart+s.originalLength))&&(!S||this.ModifiedElementsAreEqual(s.modifiedStart,s.modifiedStart+s.modifiedLength));){const E=this.ElementsAreStrictEqual(s.originalStart,s.modifiedStart);if(this.ElementsAreStrictEqual(s.originalStart+s.originalLength,s.modifiedStart+s.modifiedLength)&&!E)break;s.originalStart++,s.modifiedStart++}const _=[null];if(f<e.length-1&&this.ChangesOverlap(e[f],e[f+1],_)){e[f]=_[0],e.splice(f+1,1),f--;continue}}for(let f=e.length-1;f>=0;f--){const s=e[f];let u=0,d=0;if(f>0){const p=e[f-1];u=p.originalStart+p.originalLength,d=p.modifiedStart+p.modifiedLength}const h=s.originalLength>0,S=s.modifiedLength>0;let _=0,E=this._boundaryScore(s.originalStart,s.originalLength,s.modifiedStart,s.modifiedLength);for(let p=1;;p++){const i=s.originalStart-p,l=s.modifiedStart-p;if(i<u||l<d||h&&!this.OriginalElementsAreEqual(i,i+s.originalLength)||S&&!this.ModifiedElementsAreEqual(l,l+s.modifiedLength))break;const L=(i===u&&l===d?5:0)+this._boundaryScore(i,s.originalLength,l,s.modifiedLength);L>E&&(E=L,_=p)}s.originalStart-=_,s.modifiedStart-=_;const A=[null];if(f>0&&this.ChangesOverlap(e[f-1],e[f],A)){e[f-1]=A[0],e.splice(f,1),f++;continue}}if(this._hasStrings)for(let f=1,s=e.length;f<s;f++){const u=e[f-1],d=e[f],h=d.originalStart-u.originalStart-u.originalLength,S=u.originalStart,_=d.originalStart+d.originalLength,E=_-S,A=u.modifiedStart,p=d.modifiedStart+d.modifiedLength,i=p-A;if(h<5&&E<20&&i<20){const l=this._findBetterContiguousSequence(S,E,A,i,h);if(l){const[c,L]=l;(c!==u.originalStart+u.originalLength||L!==u.modifiedStart+u.modifiedLength)&&(u.originalLength=c-u.originalStart,u.modifiedLength=L-u.modifiedStart,d.originalStart=c+h,d.modifiedStart=L+h,d.originalLength=_-d.originalStart,d.modifiedLength=p-d.modifiedStart)}}}return e}_findBetterContiguousSequence(e,f,s,u,d){if(f<d||u<d)return null;const h=e+f-d+1,S=s+u-d+1;let _=0,E=0,A=0;for(let p=e;p<h;p++)for(let i=s;i<S;i++){const l=this._contiguousSequenceScore(p,i,d);l>0&&l>_&&(_=l,E=p,A=i)}return _>0?[E,A]:null}_contiguousSequenceScore(e,f,s){let u=0;for(let d=0;d<s;d++){if(!this.ElementsAreEqual(e+d,f+d))return 0;u+=this._originalStringElements[e+d].length}return u}_OriginalIsBoundary(e){return e<=0||e>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[e])}_OriginalRegionIsBoundary(e,f){if(this._OriginalIsBoundary(e)||this._OriginalIsBoundary(e-1))return!0;if(f>0){const s=e+f;if(this._OriginalIsBoundary(s-1)||this._OriginalIsBoundary(s))return!0}return!1}_ModifiedIsBoundary(e){return e<=0||e>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[e])}_ModifiedRegionIsBoundary(e,f){if(this._ModifiedIsBoundary(e)||this._ModifiedIsBoundary(e-1))return!0;if(f>0){const s=e+f;if(this._ModifiedIsBoundary(s-1)||this._ModifiedIsBoundary(s))return!0}return!1}_boundaryScore(e,f,s,u){const d=this._OriginalRegionIsBoundary(e,f)?1:0,h=this._ModifiedRegionIsBoundary(s,u)?1:0;return d+h}ConcatenateChanges(e,f){const s=[];if(e.length===0||f.length===0)return f.length>0?f:e;if(this.ChangesOverlap(e[e.length-1],f[0],s)){const u=new Array(e.length+f.length-1);return v.Copy(e,0,u,0,e.length-1),u[e.length-1]=s[0],v.Copy(f,1,u,e.length,f.length-1),u}else{const u=new Array(e.length+f.length);return v.Copy(e,0,u,0,e.length),v.Copy(f,0,u,e.length,f.length),u}}ChangesOverlap(e,f,s){if(m.Assert(e.originalStart<=f.originalStart,"Left change is not less than or equal to right change"),m.Assert(e.modifiedStart<=f.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=f.originalStart||e.modifiedStart+e.modifiedLength>=f.modifiedStart){const u=e.originalStart;let d=e.originalLength;const h=e.modifiedStart;let S=e.modifiedLength;return e.originalStart+e.originalLength>=f.originalStart&&(d=f.originalStart+f.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=f.modifiedStart&&(S=f.modifiedStart+f.modifiedLength-e.modifiedStart),s[0]=new r.DiffChange(u,d,h,S),!0}else return s[0]=null,!1}ClipDiagonalBound(e,f,s,u){if(e>=0&&e<u)return e;const d=s,h=u-s-1,S=f%2===0;if(e<0){const _=d%2===0;return S===_?0:1}else{const _=h%2===0;return S===_?u-1:u-2}}}n.LcsDiff=a}),Y(X[26],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.isString=r,n.isObject=x,n.isTypedArray=M,n.isNumber=g,n.isIterable=m,n.isBoolean=v,n.isUndefined=o,n.isDefined=a,n.isUndefinedOrNull=b,n.assertType=e,n.assertIsDefined=f,n.isFunction=s,n.validateConstraints=u,n.validateConstraint=d;function r(h){return typeof h=="string"}function x(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}function M(h){const S=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof S}function g(h){return typeof h=="number"&&!isNaN(h)}function m(h){return!!h&&typeof h[Symbol.iterator]=="function"}function v(h){return h===!0||h===!1}function o(h){return typeof h>"u"}function a(h){return!b(h)}function b(h){return o(h)||h===null}function e(h,S){if(!h)throw new Error(S?`Unexpected type, expected '${S}'`:"Unexpected type")}function f(h){if(b(h))throw new Error("Assertion Failed: argument is undefined or null");return h}function s(h){return typeof h=="function"}function u(h,S){const _=Math.min(h.length,S.length);for(let E=0;E<_;E++)d(h[E],S[E])}function d(h,S){if(r(S)){if(typeof h!==S)throw new Error(`argument does not match constraint: typeof ${S}`)}else if(s(S)){try{if(h instanceof S)return}catch{}if(!b(h)&&h.constructor===S||S.length===1&&S.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),Y(X[27],Z([0,1,26]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.register=M,n.getCodiconFontCharacters=g;const x=Object.create(null);function M(m,v){if((0,r.isString)(v)){const o=x[v];if(o===void 0)throw new Error(`${m} references an unknown codicon: ${v}`);v=o}return x[m]=v,{id:m}}function g(){return x}}),Y(X[41],Z([0,1,27]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.codiconsLibrary=void 0,n.codiconsLibrary={add:(0,r.register)("add",6e4),plus:(0,r.register)("plus",6e4),gistNew:(0,r.register)("gist-new",6e4),repoCreate:(0,r.register)("repo-create",6e4),lightbulb:(0,r.register)("lightbulb",60001),lightBulb:(0,r.register)("light-bulb",60001),repo:(0,r.register)("repo",60002),repoDelete:(0,r.register)("repo-delete",60002),gistFork:(0,r.register)("gist-fork",60003),repoForked:(0,r.register)("repo-forked",60003),gitPullRequest:(0,r.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,r.register)("git-pull-request-abandoned",60004),recordKeys:(0,r.register)("record-keys",60005),keyboard:(0,r.register)("keyboard",60005),tag:(0,r.register)("tag",60006),gitPullRequestLabel:(0,r.register)("git-pull-request-label",60006),tagAdd:(0,r.register)("tag-add",60006),tagRemove:(0,r.register)("tag-remove",60006),person:(0,r.register)("person",60007),personFollow:(0,r.register)("person-follow",60007),personOutline:(0,r.register)("person-outline",60007),personFilled:(0,r.register)("person-filled",60007),gitBranch:(0,r.register)("git-branch",60008),gitBranchCreate:(0,r.register)("git-branch-create",60008),gitBranchDelete:(0,r.register)("git-branch-delete",60008),sourceControl:(0,r.register)("source-control",60008),mirror:(0,r.register)("mirror",60009),mirrorPublic:(0,r.register)("mirror-public",60009),star:(0,r.register)("star",60010),starAdd:(0,r.register)("star-add",60010),starDelete:(0,r.register)("star-delete",60010),starEmpty:(0,r.register)("star-empty",60010),comment:(0,r.register)("comment",60011),commentAdd:(0,r.register)("comment-add",60011),alert:(0,r.register)("alert",60012),warning:(0,r.register)("warning",60012),search:(0,r.register)("search",60013),searchSave:(0,r.register)("search-save",60013),logOut:(0,r.register)("log-out",60014),signOut:(0,r.register)("sign-out",60014),logIn:(0,r.register)("log-in",60015),signIn:(0,r.register)("sign-in",60015),eye:(0,r.register)("eye",60016),eyeUnwatch:(0,r.register)("eye-unwatch",60016),eyeWatch:(0,r.register)("eye-watch",60016),circleFilled:(0,r.register)("circle-filled",60017),primitiveDot:(0,r.register)("primitive-dot",60017),closeDirty:(0,r.register)("close-dirty",60017),debugBreakpoint:(0,r.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,r.register)("debug-breakpoint-disabled",60017),debugHint:(0,r.register)("debug-hint",60017),terminalDecorationSuccess:(0,r.register)("terminal-decoration-success",60017),primitiveSquare:(0,r.register)("primitive-square",60018),edit:(0,r.register)("edit",60019),pencil:(0,r.register)("pencil",60019),info:(0,r.register)("info",60020),issueOpened:(0,r.register)("issue-opened",60020),gistPrivate:(0,r.register)("gist-private",60021),gitForkPrivate:(0,r.register)("git-fork-private",60021),lock:(0,r.register)("lock",60021),mirrorPrivate:(0,r.register)("mirror-private",60021),close:(0,r.register)("close",60022),removeClose:(0,r.register)("remove-close",60022),x:(0,r.register)("x",60022),repoSync:(0,r.register)("repo-sync",60023),sync:(0,r.register)("sync",60023),clone:(0,r.register)("clone",60024),desktopDownload:(0,r.register)("desktop-download",60024),beaker:(0,r.register)("beaker",60025),microscope:(0,r.register)("microscope",60025),vm:(0,r.register)("vm",60026),deviceDesktop:(0,r.register)("device-desktop",60026),file:(0,r.register)("file",60027),fileText:(0,r.register)("file-text",60027),more:(0,r.register)("more",60028),ellipsis:(0,r.register)("ellipsis",60028),kebabHorizontal:(0,r.register)("kebab-horizontal",60028),mailReply:(0,r.register)("mail-reply",60029),reply:(0,r.register)("reply",60029),organization:(0,r.register)("organization",60030),organizationFilled:(0,r.register)("organization-filled",60030),organizationOutline:(0,r.register)("organization-outline",60030),newFile:(0,r.register)("new-file",60031),fileAdd:(0,r.register)("file-add",60031),newFolder:(0,r.register)("new-folder",60032),fileDirectoryCreate:(0,r.register)("file-directory-create",60032),trash:(0,r.register)("trash",60033),trashcan:(0,r.register)("trashcan",60033),history:(0,r.register)("history",60034),clock:(0,r.register)("clock",60034),folder:(0,r.register)("folder",60035),fileDirectory:(0,r.register)("file-directory",60035),symbolFolder:(0,r.register)("symbol-folder",60035),logoGithub:(0,r.register)("logo-github",60036),markGithub:(0,r.register)("mark-github",60036),github:(0,r.register)("github",60036),terminal:(0,r.register)("terminal",60037),console:(0,r.register)("console",60037),repl:(0,r.register)("repl",60037),zap:(0,r.register)("zap",60038),symbolEvent:(0,r.register)("symbol-event",60038),error:(0,r.register)("error",60039),stop:(0,r.register)("stop",60039),variable:(0,r.register)("variable",60040),symbolVariable:(0,r.register)("symbol-variable",60040),array:(0,r.register)("array",60042),symbolArray:(0,r.register)("symbol-array",60042),symbolModule:(0,r.register)("symbol-module",60043),symbolPackage:(0,r.register)("symbol-package",60043),symbolNamespace:(0,r.register)("symbol-namespace",60043),symbolObject:(0,r.register)("symbol-object",60043),symbolMethod:(0,r.register)("symbol-method",60044),symbolFunction:(0,r.register)("symbol-function",60044),symbolConstructor:(0,r.register)("symbol-constructor",60044),symbolBoolean:(0,r.register)("symbol-boolean",60047),symbolNull:(0,r.register)("symbol-null",60047),symbolNumeric:(0,r.register)("symbol-numeric",60048),symbolNumber:(0,r.register)("symbol-number",60048),symbolStructure:(0,r.register)("symbol-structure",60049),symbolStruct:(0,r.register)("symbol-struct",60049),symbolParameter:(0,r.register)("symbol-parameter",60050),symbolTypeParameter:(0,r.register)("symbol-type-parameter",60050),symbolKey:(0,r.register)("symbol-key",60051),symbolText:(0,r.register)("symbol-text",60051),symbolReference:(0,r.register)("symbol-reference",60052),goToFile:(0,r.register)("go-to-file",60052),symbolEnum:(0,r.register)("symbol-enum",60053),symbolValue:(0,r.register)("symbol-value",60053),symbolRuler:(0,r.register)("symbol-ruler",60054),symbolUnit:(0,r.register)("symbol-unit",60054),activateBreakpoints:(0,r.register)("activate-breakpoints",60055),archive:(0,r.register)("archive",60056),arrowBoth:(0,r.register)("arrow-both",60057),arrowDown:(0,r.register)("arrow-down",60058),arrowLeft:(0,r.register)("arrow-left",60059),arrowRight:(0,r.register)("arrow-right",60060),arrowSmallDown:(0,r.register)("arrow-small-down",60061),arrowSmallLeft:(0,r.register)("arrow-small-left",60062),arrowSmallRight:(0,r.register)("arrow-small-right",60063),arrowSmallUp:(0,r.register)("arrow-small-up",60064),arrowUp:(0,r.register)("arrow-up",60065),bell:(0,r.register)("bell",60066),bold:(0,r.register)("bold",60067),book:(0,r.register)("book",60068),bookmark:(0,r.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,r.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,r.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,r.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,r.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,r.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,r.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,r.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,r.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,r.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,r.register)("briefcase",60076),broadcast:(0,r.register)("broadcast",60077),browser:(0,r.register)("browser",60078),bug:(0,r.register)("bug",60079),calendar:(0,r.register)("calendar",60080),caseSensitive:(0,r.register)("case-sensitive",60081),check:(0,r.register)("check",60082),checklist:(0,r.register)("checklist",60083),chevronDown:(0,r.register)("chevron-down",60084),chevronLeft:(0,r.register)("chevron-left",60085),chevronRight:(0,r.register)("chevron-right",60086),chevronUp:(0,r.register)("chevron-up",60087),chromeClose:(0,r.register)("chrome-close",60088),chromeMaximize:(0,r.register)("chrome-maximize",60089),chromeMinimize:(0,r.register)("chrome-minimize",60090),chromeRestore:(0,r.register)("chrome-restore",60091),circleOutline:(0,r.register)("circle-outline",60092),circle:(0,r.register)("circle",60092),debugBreakpointUnverified:(0,r.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,r.register)("terminal-decoration-incomplete",60092),circleSlash:(0,r.register)("circle-slash",60093),circuitBoard:(0,r.register)("circuit-board",60094),clearAll:(0,r.register)("clear-all",60095),clippy:(0,r.register)("clippy",60096),closeAll:(0,r.register)("close-all",60097),cloudDownload:(0,r.register)("cloud-download",60098),cloudUpload:(0,r.register)("cloud-upload",60099),code:(0,r.register)("code",60100),collapseAll:(0,r.register)("collapse-all",60101),colorMode:(0,r.register)("color-mode",60102),commentDiscussion:(0,r.register)("comment-discussion",60103),creditCard:(0,r.register)("credit-card",60105),dash:(0,r.register)("dash",60108),dashboard:(0,r.register)("dashboard",60109),database:(0,r.register)("database",60110),debugContinue:(0,r.register)("debug-continue",60111),debugDisconnect:(0,r.register)("debug-disconnect",60112),debugPause:(0,r.register)("debug-pause",60113),debugRestart:(0,r.register)("debug-restart",60114),debugStart:(0,r.register)("debug-start",60115),debugStepInto:(0,r.register)("debug-step-into",60116),debugStepOut:(0,r.register)("debug-step-out",60117),debugStepOver:(0,r.register)("debug-step-over",60118),debugStop:(0,r.register)("debug-stop",60119),debug:(0,r.register)("debug",60120),deviceCameraVideo:(0,r.register)("device-camera-video",60121),deviceCamera:(0,r.register)("device-camera",60122),deviceMobile:(0,r.register)("device-mobile",60123),diffAdded:(0,r.register)("diff-added",60124),diffIgnored:(0,r.register)("diff-ignored",60125),diffModified:(0,r.register)("diff-modified",60126),diffRemoved:(0,r.register)("diff-removed",60127),diffRenamed:(0,r.register)("diff-renamed",60128),diff:(0,r.register)("diff",60129),diffSidebyside:(0,r.register)("diff-sidebyside",60129),discard:(0,r.register)("discard",60130),editorLayout:(0,r.register)("editor-layout",60131),emptyWindow:(0,r.register)("empty-window",60132),exclude:(0,r.register)("exclude",60133),extensions:(0,r.register)("extensions",60134),eyeClosed:(0,r.register)("eye-closed",60135),fileBinary:(0,r.register)("file-binary",60136),fileCode:(0,r.register)("file-code",60137),fileMedia:(0,r.register)("file-media",60138),filePdf:(0,r.register)("file-pdf",60139),fileSubmodule:(0,r.register)("file-submodule",60140),fileSymlinkDirectory:(0,r.register)("file-symlink-directory",60141),fileSymlinkFile:(0,r.register)("file-symlink-file",60142),fileZip:(0,r.register)("file-zip",60143),files:(0,r.register)("files",60144),filter:(0,r.register)("filter",60145),flame:(0,r.register)("flame",60146),foldDown:(0,r.register)("fold-down",60147),foldUp:(0,r.register)("fold-up",60148),fold:(0,r.register)("fold",60149),folderActive:(0,r.register)("folder-active",60150),folderOpened:(0,r.register)("folder-opened",60151),gear:(0,r.register)("gear",60152),gift:(0,r.register)("gift",60153),gistSecret:(0,r.register)("gist-secret",60154),gist:(0,r.register)("gist",60155),gitCommit:(0,r.register)("git-commit",60156),gitCompare:(0,r.register)("git-compare",60157),compareChanges:(0,r.register)("compare-changes",60157),gitMerge:(0,r.register)("git-merge",60158),githubAction:(0,r.register)("github-action",60159),githubAlt:(0,r.register)("github-alt",60160),globe:(0,r.register)("globe",60161),grabber:(0,r.register)("grabber",60162),graph:(0,r.register)("graph",60163),gripper:(0,r.register)("gripper",60164),heart:(0,r.register)("heart",60165),home:(0,r.register)("home",60166),horizontalRule:(0,r.register)("horizontal-rule",60167),hubot:(0,r.register)("hubot",60168),inbox:(0,r.register)("inbox",60169),issueReopened:(0,r.register)("issue-reopened",60171),issues:(0,r.register)("issues",60172),italic:(0,r.register)("italic",60173),jersey:(0,r.register)("jersey",60174),json:(0,r.register)("json",60175),kebabVertical:(0,r.register)("kebab-vertical",60176),key:(0,r.register)("key",60177),law:(0,r.register)("law",60178),lightbulbAutofix:(0,r.register)("lightbulb-autofix",60179),linkExternal:(0,r.register)("link-external",60180),link:(0,r.register)("link",60181),listOrdered:(0,r.register)("list-ordered",60182),listUnordered:(0,r.register)("list-unordered",60183),liveShare:(0,r.register)("live-share",60184),loading:(0,r.register)("loading",60185),location:(0,r.register)("location",60186),mailRead:(0,r.register)("mail-read",60187),mail:(0,r.register)("mail",60188),markdown:(0,r.register)("markdown",60189),megaphone:(0,r.register)("megaphone",60190),mention:(0,r.register)("mention",60191),milestone:(0,r.register)("milestone",60192),gitPullRequestMilestone:(0,r.register)("git-pull-request-milestone",60192),mortarBoard:(0,r.register)("mortar-board",60193),move:(0,r.register)("move",60194),multipleWindows:(0,r.register)("multiple-windows",60195),mute:(0,r.register)("mute",60196),noNewline:(0,r.register)("no-newline",60197),note:(0,r.register)("note",60198),octoface:(0,r.register)("octoface",60199),openPreview:(0,r.register)("open-preview",60200),package:(0,r.register)("package",60201),paintcan:(0,r.register)("paintcan",60202),pin:(0,r.register)("pin",60203),play:(0,r.register)("play",60204),run:(0,r.register)("run",60204),plug:(0,r.register)("plug",60205),preserveCase:(0,r.register)("preserve-case",60206),preview:(0,r.register)("preview",60207),project:(0,r.register)("project",60208),pulse:(0,r.register)("pulse",60209),question:(0,r.register)("question",60210),quote:(0,r.register)("quote",60211),radioTower:(0,r.register)("radio-tower",60212),reactions:(0,r.register)("reactions",60213),references:(0,r.register)("references",60214),refresh:(0,r.register)("refresh",60215),regex:(0,r.register)("regex",60216),remoteExplorer:(0,r.register)("remote-explorer",60217),remote:(0,r.register)("remote",60218),remove:(0,r.register)("remove",60219),replaceAll:(0,r.register)("replace-all",60220),replace:(0,r.register)("replace",60221),repoClone:(0,r.register)("repo-clone",60222),repoForcePush:(0,r.register)("repo-force-push",60223),repoPull:(0,r.register)("repo-pull",60224),repoPush:(0,r.register)("repo-push",60225),report:(0,r.register)("report",60226),requestChanges:(0,r.register)("request-changes",60227),rocket:(0,r.register)("rocket",60228),rootFolderOpened:(0,r.register)("root-folder-opened",60229),rootFolder:(0,r.register)("root-folder",60230),rss:(0,r.register)("rss",60231),ruby:(0,r.register)("ruby",60232),saveAll:(0,r.register)("save-all",60233),saveAs:(0,r.register)("save-as",60234),save:(0,r.register)("save",60235),screenFull:(0,r.register)("screen-full",60236),screenNormal:(0,r.register)("screen-normal",60237),searchStop:(0,r.register)("search-stop",60238),server:(0,r.register)("server",60240),settingsGear:(0,r.register)("settings-gear",60241),settings:(0,r.register)("settings",60242),shield:(0,r.register)("shield",60243),smiley:(0,r.register)("smiley",60244),sortPrecedence:(0,r.register)("sort-precedence",60245),splitHorizontal:(0,r.register)("split-horizontal",60246),splitVertical:(0,r.register)("split-vertical",60247),squirrel:(0,r.register)("squirrel",60248),starFull:(0,r.register)("star-full",60249),starHalf:(0,r.register)("star-half",60250),symbolClass:(0,r.register)("symbol-class",60251),symbolColor:(0,r.register)("symbol-color",60252),symbolConstant:(0,r.register)("symbol-constant",60253),symbolEnumMember:(0,r.register)("symbol-enum-member",60254),symbolField:(0,r.register)("symbol-field",60255),symbolFile:(0,r.register)("symbol-file",60256),symbolInterface:(0,r.register)("symbol-interface",60257),symbolKeyword:(0,r.register)("symbol-keyword",60258),symbolMisc:(0,r.register)("symbol-misc",60259),symbolOperator:(0,r.register)("symbol-operator",60260),symbolProperty:(0,r.register)("symbol-property",60261),wrench:(0,r.register)("wrench",60261),wrenchSubaction:(0,r.register)("wrench-subaction",60261),symbolSnippet:(0,r.register)("symbol-snippet",60262),tasklist:(0,r.register)("tasklist",60263),telescope:(0,r.register)("telescope",60264),textSize:(0,r.register)("text-size",60265),threeBars:(0,r.register)("three-bars",60266),thumbsdown:(0,r.register)("thumbsdown",60267),thumbsup:(0,r.register)("thumbsup",60268),tools:(0,r.register)("tools",60269),triangleDown:(0,r.register)("triangle-down",60270),triangleLeft:(0,r.register)("triangle-left",60271),triangleRight:(0,r.register)("triangle-right",60272),triangleUp:(0,r.register)("triangle-up",60273),twitter:(0,r.register)("twitter",60274),unfold:(0,r.register)("unfold",60275),unlock:(0,r.register)("unlock",60276),unmute:(0,r.register)("unmute",60277),unverified:(0,r.register)("unverified",60278),verified:(0,r.register)("verified",60279),versions:(0,r.register)("versions",60280),vmActive:(0,r.register)("vm-active",60281),vmOutline:(0,r.register)("vm-outline",60282),vmRunning:(0,r.register)("vm-running",60283),watch:(0,r.register)("watch",60284),whitespace:(0,r.register)("whitespace",60285),wholeWord:(0,r.register)("whole-word",60286),window:(0,r.register)("window",60287),wordWrap:(0,r.register)("word-wrap",60288),zoomIn:(0,r.register)("zoom-in",60289),zoomOut:(0,r.register)("zoom-out",60290),listFilter:(0,r.register)("list-filter",60291),listFlat:(0,r.register)("list-flat",60292),listSelection:(0,r.register)("list-selection",60293),selection:(0,r.register)("selection",60293),listTree:(0,r.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,r.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,r.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,r.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,r.register)("debug-stackframe-active",60297),circleSmallFilled:(0,r.register)("circle-small-filled",60298),debugStackframeDot:(0,r.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,r.register)("terminal-decoration-mark",60298),debugStackframe:(0,r.register)("debug-stackframe",60299),debugStackframeFocused:(0,r.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,r.register)("debug-breakpoint-unsupported",60300),symbolString:(0,r.register)("symbol-string",60301),debugReverseContinue:(0,r.register)("debug-reverse-continue",60302),debugStepBack:(0,r.register)("debug-step-back",60303),debugRestartFrame:(0,r.register)("debug-restart-frame",60304),debugAlt:(0,r.register)("debug-alt",60305),callIncoming:(0,r.register)("call-incoming",60306),callOutgoing:(0,r.register)("call-outgoing",60307),menu:(0,r.register)("menu",60308),expandAll:(0,r.register)("expand-all",60309),feedback:(0,r.register)("feedback",60310),gitPullRequestReviewer:(0,r.register)("git-pull-request-reviewer",60310),groupByRefType:(0,r.register)("group-by-ref-type",60311),ungroupByRefType:(0,r.register)("ungroup-by-ref-type",60312),account:(0,r.register)("account",60313),gitPullRequestAssignee:(0,r.register)("git-pull-request-assignee",60313),bellDot:(0,r.register)("bell-dot",60314),debugConsole:(0,r.register)("debug-console",60315),library:(0,r.register)("library",60316),output:(0,r.register)("output",60317),runAll:(0,r.register)("run-all",60318),syncIgnored:(0,r.register)("sync-ignored",60319),pinned:(0,r.register)("pinned",60320),githubInverted:(0,r.register)("github-inverted",60321),serverProcess:(0,r.register)("server-process",60322),serverEnvironment:(0,r.register)("server-environment",60323),pass:(0,r.register)("pass",60324),issueClosed:(0,r.register)("issue-closed",60324),stopCircle:(0,r.register)("stop-circle",60325),playCircle:(0,r.register)("play-circle",60326),record:(0,r.register)("record",60327),debugAltSmall:(0,r.register)("debug-alt-small",60328),vmConnect:(0,r.register)("vm-connect",60329),cloud:(0,r.register)("cloud",60330),merge:(0,r.register)("merge",60331),export:(0,r.register)("export",60332),graphLeft:(0,r.register)("graph-left",60333),magnet:(0,r.register)("magnet",60334),notebook:(0,r.register)("notebook",60335),redo:(0,r.register)("redo",60336),checkAll:(0,r.register)("check-all",60337),pinnedDirty:(0,r.register)("pinned-dirty",60338),passFilled:(0,r.register)("pass-filled",60339),circleLargeFilled:(0,r.register)("circle-large-filled",60340),circleLarge:(0,r.register)("circle-large",60341),circleLargeOutline:(0,r.register)("circle-large-outline",60341),combine:(0,r.register)("combine",60342),gather:(0,r.register)("gather",60342),table:(0,r.register)("table",60343),variableGroup:(0,r.register)("variable-group",60344),typeHierarchy:(0,r.register)("type-hierarchy",60345),typeHierarchySub:(0,r.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,r.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,r.register)("git-pull-request-create",60348),runAbove:(0,r.register)("run-above",60349),runBelow:(0,r.register)("run-below",60350),notebookTemplate:(0,r.register)("notebook-template",60351),debugRerun:(0,r.register)("debug-rerun",60352),workspaceTrusted:(0,r.register)("workspace-trusted",60353),workspaceUntrusted:(0,r.register)("workspace-untrusted",60354),workspaceUnknown:(0,r.register)("workspace-unknown",60355),terminalCmd:(0,r.register)("terminal-cmd",60356),terminalDebian:(0,r.register)("terminal-debian",60357),terminalLinux:(0,r.register)("terminal-linux",60358),terminalPowershell:(0,r.register)("terminal-powershell",60359),terminalTmux:(0,r.register)("terminal-tmux",60360),terminalUbuntu:(0,r.register)("terminal-ubuntu",60361),terminalBash:(0,r.register)("terminal-bash",60362),arrowSwap:(0,r.register)("arrow-swap",60363),copy:(0,r.register)("copy",60364),personAdd:(0,r.register)("person-add",60365),filterFilled:(0,r.register)("filter-filled",60366),wand:(0,r.register)("wand",60367),debugLineByLine:(0,r.register)("debug-line-by-line",60368),inspect:(0,r.register)("inspect",60369),layers:(0,r.register)("layers",60370),layersDot:(0,r.register)("layers-dot",60371),layersActive:(0,r.register)("layers-active",60372),compass:(0,r.register)("compass",60373),compassDot:(0,r.register)("compass-dot",60374),compassActive:(0,r.register)("compass-active",60375),azure:(0,r.register)("azure",60376),issueDraft:(0,r.register)("issue-draft",60377),gitPullRequestClosed:(0,r.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,r.register)("git-pull-request-draft",60379),debugAll:(0,r.register)("debug-all",60380),debugCoverage:(0,r.register)("debug-coverage",60381),runErrors:(0,r.register)("run-errors",60382),folderLibrary:(0,r.register)("folder-library",60383),debugContinueSmall:(0,r.register)("debug-continue-small",60384),beakerStop:(0,r.register)("beaker-stop",60385),graphLine:(0,r.register)("graph-line",60386),graphScatter:(0,r.register)("graph-scatter",60387),pieChart:(0,r.register)("pie-chart",60388),bracket:(0,r.register)("bracket",60175),bracketDot:(0,r.register)("bracket-dot",60389),bracketError:(0,r.register)("bracket-error",60390),lockSmall:(0,r.register)("lock-small",60391),azureDevops:(0,r.register)("azure-devops",60392),verifiedFilled:(0,r.register)("verified-filled",60393),newline:(0,r.register)("newline",60394),layout:(0,r.register)("layout",60395),layoutActivitybarLeft:(0,r.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,r.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,r.register)("layout-panel-left",60398),layoutPanelCenter:(0,r.register)("layout-panel-center",60399),layoutPanelJustify:(0,r.register)("layout-panel-justify",60400),layoutPanelRight:(0,r.register)("layout-panel-right",60401),layoutPanel:(0,r.register)("layout-panel",60402),layoutSidebarLeft:(0,r.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,r.register)("layout-sidebar-right",60404),layoutStatusbar:(0,r.register)("layout-statusbar",60405),layoutMenubar:(0,r.register)("layout-menubar",60406),layoutCentered:(0,r.register)("layout-centered",60407),target:(0,r.register)("target",60408),indent:(0,r.register)("indent",60409),recordSmall:(0,r.register)("record-small",60410),errorSmall:(0,r.register)("error-small",60411),terminalDecorationError:(0,r.register)("terminal-decoration-error",60411),arrowCircleDown:(0,r.register)("arrow-circle-down",60412),arrowCircleLeft:(0,r.register)("arrow-circle-left",60413),arrowCircleRight:(0,r.register)("arrow-circle-right",60414),arrowCircleUp:(0,r.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,r.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,r.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,r.register)("layout-sidebar-left-off",60418),blank:(0,r.register)("blank",60419),heartFilled:(0,r.register)("heart-filled",60420),map:(0,r.register)("map",60421),mapHorizontal:(0,r.register)("map-horizontal",60421),foldHorizontal:(0,r.register)("fold-horizontal",60421),mapFilled:(0,r.register)("map-filled",60422),mapHorizontalFilled:(0,r.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,r.register)("fold-horizontal-filled",60422),circleSmall:(0,r.register)("circle-small",60423),bellSlash:(0,r.register)("bell-slash",60424),bellSlashDot:(0,r.register)("bell-slash-dot",60425),commentUnresolved:(0,r.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,r.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,r.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,r.register)("search-fuzzy",60429),commentDraft:(0,r.register)("comment-draft",60430),send:(0,r.register)("send",60431),sparkle:(0,r.register)("sparkle",60432),insert:(0,r.register)("insert",60433),mic:(0,r.register)("mic",60434),thumbsdownFilled:(0,r.register)("thumbsdown-filled",60435),thumbsupFilled:(0,r.register)("thumbsup-filled",60436),coffee:(0,r.register)("coffee",60437),snake:(0,r.register)("snake",60438),game:(0,r.register)("game",60439),vr:(0,r.register)("vr",60440),chip:(0,r.register)("chip",60441),piano:(0,r.register)("piano",60442),music:(0,r.register)("music",60443),micFilled:(0,r.register)("mic-filled",60444),repoFetch:(0,r.register)("repo-fetch",60445),copilot:(0,r.register)("copilot",60446),lightbulbSparkle:(0,r.register)("lightbulb-sparkle",60447),robot:(0,r.register)("robot",60448),sparkleFilled:(0,r.register)("sparkle-filled",60449),diffSingle:(0,r.register)("diff-single",60450),diffMultiple:(0,r.register)("diff-multiple",60451),surroundWith:(0,r.register)("surround-with",60452),share:(0,r.register)("share",60453),gitStash:(0,r.register)("git-stash",60454),gitStashApply:(0,r.register)("git-stash-apply",60455),gitStashPop:(0,r.register)("git-stash-pop",60456),vscode:(0,r.register)("vscode",60457),vscodeInsiders:(0,r.register)("vscode-insiders",60458),codeOss:(0,r.register)("code-oss",60459),runCoverage:(0,r.register)("run-coverage",60460),runAllCoverage:(0,r.register)("run-all-coverage",60461),coverage:(0,r.register)("coverage",60462),githubProject:(0,r.register)("github-project",60463),mapVertical:(0,r.register)("map-vertical",60464),foldVertical:(0,r.register)("fold-vertical",60464),mapVerticalFilled:(0,r.register)("map-vertical-filled",60465),foldVerticalFilled:(0,r.register)("fold-vertical-filled",60465),goToSearch:(0,r.register)("go-to-search",60466),percentage:(0,r.register)("percentage",60467),sortPercentage:(0,r.register)("sort-percentage",60467)}}),Y(X[42],Z([0,1,27,41]),function(O,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Codicon=n.codiconsDerived=void 0,n.codiconsDerived={dialogError:(0,r.register)("dialog-error","error"),dialogWarning:(0,r.register)("dialog-warning","warning"),dialogInfo:(0,r.register)("dialog-info","info"),dialogClose:(0,r.register)("dialog-close","close"),treeItemExpanded:(0,r.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,r.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,r.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,r.register)("tree-filter-clear","close"),treeItemLoading:(0,r.register)("tree-item-loading","loading"),menuSelection:(0,r.register)("menu-selection","check"),menuSubmenu:(0,r.register)("menu-submenu","chevron-right"),menuBarMore:(0,r.register)("menubar-more","more"),scrollbarButtonLeft:(0,r.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,r.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,r.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,r.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,r.register)("toolbar-more","more"),quickInputBack:(0,r.register)("quick-input-back","arrow-left"),dropDownButton:(0,r.register)("drop-down-button",60084),symbolCustomColor:(0,r.register)("symbol-customcolor",60252),exportIcon:(0,r.register)("export",60332),workspaceUnspecified:(0,r.register)("workspace-unspecified",60355),newLine:(0,r.register)("newline",60394),thumbsDownFilled:(0,r.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,r.register)("thumbsup-filled",60436),gitFetch:(0,r.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,r.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,r.register)("debug-breakpoint-pending",60377)},n.Codicon={...x.codiconsLibrary,...n.codiconsDerived}}),Y(X[14],Z([0,1,26]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.deepClone=x,n.deepFreeze=M,n.cloneAndChange=m,n.mixin=o,n.equals=a,n.getAllPropertyNames=b,n.getAllMethodNames=e,n.createProxyObject=f;function x(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const u=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([d,h])=>{u[d]=h&&typeof h=="object"?x(h):h}),u}function M(s){if(!s||typeof s!="object")return s;const u=[s];for(;u.length>0;){const d=u.shift();Object.freeze(d);for(const h in d)if(g.call(d,h)){const S=d[h];typeof S=="object"&&!Object.isFrozen(S)&&!(0,r.isTypedArray)(S)&&u.push(S)}}return s}const g=Object.prototype.hasOwnProperty;function m(s,u){return v(s,u,new Set)}function v(s,u,d){if((0,r.isUndefinedOrNull)(s))return s;const h=u(s);if(typeof h<"u")return h;if(Array.isArray(s)){const S=[];for(const _ of s)S.push(v(_,u,d));return S}if((0,r.isObject)(s)){if(d.has(s))throw new Error("Cannot clone recursive data-structure");d.add(s);const S={};for(const _ in s)g.call(s,_)&&(S[_]=v(s[_],u,d));return d.delete(s),S}return s}function o(s,u,d=!0){return(0,r.isObject)(s)?((0,r.isObject)(u)&&Object.keys(u).forEach(h=>{h in s?d&&((0,r.isObject)(s[h])&&(0,r.isObject)(u[h])?o(s[h],u[h],d):s[h]=u[h]):s[h]=u[h]}),s):u}function a(s,u){if(s===u)return!0;if(s==null||u===null||u===void 0||typeof s!=typeof u||typeof s!="object"||Array.isArray(s)!==Array.isArray(u))return!1;let d,h;if(Array.isArray(s)){if(s.length!==u.length)return!1;for(d=0;d<s.length;d++)if(!a(s[d],u[d]))return!1}else{const S=[];for(h in s)S.push(h);S.sort();const _=[];for(h in u)_.push(h);if(_.sort(),!a(S,_))return!1;for(d=0;d<S.length;d++)if(!a(s[S[d]],u[S[d]]))return!1}return!0}function b(s){let u=[];for(;Object.prototype!==s;)u=u.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return u}function e(s){const u=[];for(const d of b(s))typeof s[d]=="function"&&u.push(d);return u}function f(s,u){const d=S=>function(){const _=Array.prototype.slice.call(arguments,0);return u(S,_)},h={};for(const S of s)h[S]=d(S);return h}}),Y(X[28],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint8=r,n.toUint32=x;function r(M){return M<0?0:M>255?255:M|0}function x(M){return M<0?0:M>4294967295?4294967295:M|0}}),Y(X[29],Z([0,1,28]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class x{constructor(m){const v=(0,r.toUint8)(m);this._defaultValue=v,this._asciiMap=x._createAsciiMap(v),this._map=new Map}static _createAsciiMap(m){const v=new Uint8Array(256);return v.fill(m),v}set(m,v){const o=(0,r.toUint8)(v);m>=0&&m<256?this._asciiMap[m]=o:this._map.set(m,o)}get(m){return m>=0&&m<256?this._asciiMap[m]:this._map.get(m)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}n.CharacterClassifier=x;class M{constructor(){this._actual=new x(0)}add(m){this._actual.set(m,1)}has(m){return this._actual.get(m)===1}clear(){return this._actual.clear()}}n.CharacterSet=M}),Y(X[3],Z([0,1,5]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.OffsetRangeSet=n.OffsetRange=void 0;class x{static addRange(m,v){let o=0;for(;o<v.length&&v[o].endExclusive<m.start;)o++;let a=o;for(;a<v.length&&v[a].start<=m.endExclusive;)a++;if(o===a)v.splice(o,0,m);else{const b=Math.min(m.start,v[o].start),e=Math.max(m.endExclusive,v[a-1].endExclusive);v.splice(o,a-o,new x(b,e))}}static tryCreate(m,v){if(!(m>v))return new x(m,v)}static ofLength(m){return new x(0,m)}static ofStartAndLength(m,v){return new x(m,m+v)}constructor(m,v){if(this.start=m,this.endExclusive=v,m>v)throw new r.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(m){return new x(this.start+m,this.endExclusive+m)}deltaStart(m){return new x(this.start+m,this.endExclusive)}deltaEnd(m){return new x(this.start,this.endExclusive+m)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}contains(m){return this.start<=m&&m<this.endExclusive}join(m){return new x(Math.min(this.start,m.start),Math.max(this.endExclusive,m.endExclusive))}intersect(m){const v=Math.max(this.start,m.start),o=Math.min(this.endExclusive,m.endExclusive);if(v<=o)return new x(v,o)}intersects(m){const v=Math.max(this.start,m.start),o=Math.min(this.endExclusive,m.endExclusive);return v<o}isBefore(m){return this.endExclusive<=m.start}isAfter(m){return this.start>=m.endExclusive}slice(m){return m.slice(this.start,this.endExclusive)}substring(m){return m.substring(this.start,this.endExclusive)}clip(m){if(this.isEmpty)throw new r.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,m))}clipCyclic(m){if(this.isEmpty)throw new r.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return m<this.start?this.endExclusive-(this.start-m)%this.length:m>=this.endExclusive?this.start+(m-this.start)%this.length:m}forEach(m){for(let v=this.start;v<this.endExclusive;v++)m(v)}}n.OffsetRange=x;class M{constructor(){this._sortedRanges=[]}addRange(m){let v=0;for(;v<this._sortedRanges.length&&this._sortedRanges[v].endExclusive<m.start;)v++;let o=v;for(;o<this._sortedRanges.length&&this._sortedRanges[o].start<=m.endExclusive;)o++;if(v===o)this._sortedRanges.splice(v,0,m);else{const a=Math.min(m.start,this._sortedRanges[v].start),b=Math.max(m.endExclusive,this._sortedRanges[o-1].endExclusive);this._sortedRanges.splice(v,o-v,new x(a,b))}}toString(){return this._sortedRanges.map(m=>m.toString()).join(", ")}intersectsStrict(m){let v=0;for(;v<this._sortedRanges.length&&this._sortedRanges[v].endExclusive<=m.start;)v++;return v<this._sortedRanges.length&&this._sortedRanges[v].start<m.endExclusive}intersectWithRange(m){const v=new M;for(const o of this._sortedRanges){const a=o.intersect(m);a&&v.addRange(a)}return v}intersectWithRangeLength(m){return this.intersectWithRange(m).length}get length(){return this._sortedRanges.reduce((m,v)=>m+v.length,0)}}n.OffsetRangeSet=M}),Y(X[4],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class r{constructor(M,g){this.lineNumber=M,this.column=g}with(M=this.lineNumber,g=this.column){return M===this.lineNumber&&g===this.column?this:new r(M,g)}delta(M=0,g=0){return this.with(this.lineNumber+M,this.column+g)}equals(M){return r.equals(this,M)}static equals(M,g){return!M&&!g?!0:!!M&&!!g&&M.lineNumber===g.lineNumber&&M.column===g.column}isBefore(M){return r.isBefore(this,M)}static isBefore(M,g){return M.lineNumber<g.lineNumber?!0:g.lineNumber<M.lineNumber?!1:M.column<g.column}isBeforeOrEqual(M){return r.isBeforeOrEqual(this,M)}static isBeforeOrEqual(M,g){return M.lineNumber<g.lineNumber?!0:g.lineNumber<M.lineNumber?!1:M.column<=g.column}static compare(M,g){const m=M.lineNumber|0,v=g.lineNumber|0;if(m===v){const o=M.column|0,a=g.column|0;return o-a}return m-v}clone(){return new r(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(M){return new r(M.lineNumber,M.column)}static isIPosition(M){return M&&typeof M.lineNumber=="number"&&typeof M.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}n.Position=r}),Y(X[2],Z([0,1,4]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class x{constructor(g,m,v,o){g>v||g===v&&m>o?(this.startLineNumber=v,this.startColumn=o,this.endLineNumber=g,this.endColumn=m):(this.startLineNumber=g,this.startColumn=m,this.endLineNumber=v,this.endColumn=o)}isEmpty(){return x.isEmpty(this)}static isEmpty(g){return g.startLineNumber===g.endLineNumber&&g.startColumn===g.endColumn}containsPosition(g){return x.containsPosition(this,g)}static containsPosition(g,m){return!(m.lineNumber<g.startLineNumber||m.lineNumber>g.endLineNumber||m.lineNumber===g.startLineNumber&&m.column<g.startColumn||m.lineNumber===g.endLineNumber&&m.column>g.endColumn)}static strictContainsPosition(g,m){return!(m.lineNumber<g.startLineNumber||m.lineNumber>g.endLineNumber||m.lineNumber===g.startLineNumber&&m.column<=g.startColumn||m.lineNumber===g.endLineNumber&&m.column>=g.endColumn)}containsRange(g){return x.containsRange(this,g)}static containsRange(g,m){return!(m.startLineNumber<g.startLineNumber||m.endLineNumber<g.startLineNumber||m.startLineNumber>g.endLineNumber||m.endLineNumber>g.endLineNumber||m.startLineNumber===g.startLineNumber&&m.startColumn<g.startColumn||m.endLineNumber===g.endLineNumber&&m.endColumn>g.endColumn)}strictContainsRange(g){return x.strictContainsRange(this,g)}static strictContainsRange(g,m){return!(m.startLineNumber<g.startLineNumber||m.endLineNumber<g.startLineNumber||m.startLineNumber>g.endLineNumber||m.endLineNumber>g.endLineNumber||m.startLineNumber===g.startLineNumber&&m.startColumn<=g.startColumn||m.endLineNumber===g.endLineNumber&&m.endColumn>=g.endColumn)}plusRange(g){return x.plusRange(this,g)}static plusRange(g,m){let v,o,a,b;return m.startLineNumber<g.startLineNumber?(v=m.startLineNumber,o=m.startColumn):m.startLineNumber===g.startLineNumber?(v=m.startLineNumber,o=Math.min(m.startColumn,g.startColumn)):(v=g.startLineNumber,o=g.startColumn),m.endLineNumber>g.endLineNumber?(a=m.endLineNumber,b=m.endColumn):m.endLineNumber===g.endLineNumber?(a=m.endLineNumber,b=Math.max(m.endColumn,g.endColumn)):(a=g.endLineNumber,b=g.endColumn),new x(v,o,a,b)}intersectRanges(g){return x.intersectRanges(this,g)}static intersectRanges(g,m){let v=g.startLineNumber,o=g.startColumn,a=g.endLineNumber,b=g.endColumn;const e=m.startLineNumber,f=m.startColumn,s=m.endLineNumber,u=m.endColumn;return v<e?(v=e,o=f):v===e&&(o=Math.max(o,f)),a>s?(a=s,b=u):a===s&&(b=Math.min(b,u)),v>a||v===a&&o>b?null:new x(v,o,a,b)}equalsRange(g){return x.equalsRange(this,g)}static equalsRange(g,m){return!g&&!m?!0:!!g&&!!m&&g.startLineNumber===m.startLineNumber&&g.startColumn===m.startColumn&&g.endLineNumber===m.endLineNumber&&g.endColumn===m.endColumn}getEndPosition(){return x.getEndPosition(this)}static getEndPosition(g){return new r.Position(g.endLineNumber,g.endColumn)}getStartPosition(){return x.getStartPosition(this)}static getStartPosition(g){return new r.Position(g.startLineNumber,g.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(g,m){return new x(this.startLineNumber,this.startColumn,g,m)}setStartPosition(g,m){return new x(g,m,this.endLineNumber,this.endColumn)}collapseToStart(){return x.collapseToStart(this)}static collapseToStart(g){return new x(g.startLineNumber,g.startColumn,g.startLineNumber,g.startColumn)}collapseToEnd(){return x.collapseToEnd(this)}static collapseToEnd(g){return new x(g.endLineNumber,g.endColumn,g.endLineNumber,g.endColumn)}delta(g){return new x(this.startLineNumber+g,this.startColumn,this.endLineNumber+g,this.endColumn)}static fromPositions(g,m=g){return new x(g.lineNumber,g.column,m.lineNumber,m.column)}static lift(g){return g?new x(g.startLineNumber,g.startColumn,g.endLineNumber,g.endColumn):null}static isIRange(g){return g&&typeof g.startLineNumber=="number"&&typeof g.startColumn=="number"&&typeof g.endLineNumber=="number"&&typeof g.endColumn=="number"}static areIntersectingOrTouching(g,m){return!(g.endLineNumber<m.startLineNumber||g.endLineNumber===m.startLineNumber&&g.endColumn<m.startColumn||m.endLineNumber<g.startLineNumber||m.endLineNumber===g.startLineNumber&&m.endColumn<g.startColumn)}static areIntersecting(g,m){return!(g.endLineNumber<m.startLineNumber||g.endLineNumber===m.startLineNumber&&g.endColumn<=m.startColumn||m.endLineNumber<g.startLineNumber||m.endLineNumber===g.startLineNumber&&m.endColumn<=g.startColumn)}static compareRangesUsingStarts(g,m){if(g&&m){const a=g.startLineNumber|0,b=m.startLineNumber|0;if(a===b){const e=g.startColumn|0,f=m.startColumn|0;if(e===f){const s=g.endLineNumber|0,u=m.endLineNumber|0;if(s===u){const d=g.endColumn|0,h=m.endColumn|0;return d-h}return s-u}return e-f}return a-b}return(g?1:0)-(m?1:0)}static compareRangesUsingEnds(g,m){return g.endLineNumber===m.endLineNumber?g.endColumn===m.endColumn?g.startLineNumber===m.startLineNumber?g.startColumn-m.startColumn:g.startLineNumber-m.startLineNumber:g.endColumn-m.endColumn:g.endLineNumber-m.endLineNumber}static spansMultipleLines(g){return g.endLineNumber>g.startLineNumber}toJSON(){return this}}n.Range=x}),Y(X[10],Z([0,1,5,3,2,11]),function(O,n,r,x,M,g){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRangeSet=n.LineRange=void 0;class m{static fromRangeInclusive(a){return new m(a.startLineNumber,a.endLineNumber+1)}static joinMany(a){if(a.length===0)return[];let b=new v(a[0].slice());for(let e=1;e<a.length;e++)b=b.getUnion(new v(a[e].slice()));return b.ranges}static join(a){if(a.length===0)throw new r.BugIndicatingError("lineRanges cannot be empty");let b=a[0].startLineNumber,e=a[0].endLineNumberExclusive;for(let f=1;f<a.length;f++)b=Math.min(b,a[f].startLineNumber),e=Math.max(e,a[f].endLineNumberExclusive);return new m(b,e)}static ofLength(a,b){return new m(a,a+b)}static deserialize(a){return new m(a[0],a[1])}constructor(a,b){if(a>b)throw new r.BugIndicatingError(`startLineNumber ${a} cannot be after endLineNumberExclusive ${b}`);this.startLineNumber=a,this.endLineNumberExclusive=b}contains(a){return this.startLineNumber<=a&&a<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(a){return new m(this.startLineNumber+a,this.endLineNumberExclusive+a)}deltaLength(a){return new m(this.startLineNumber,this.endLineNumberExclusive+a)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(a){return new m(Math.min(this.startLineNumber,a.startLineNumber),Math.max(this.endLineNumberExclusive,a.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(a){const b=Math.max(this.startLineNumber,a.startLineNumber),e=Math.min(this.endLineNumberExclusive,a.endLineNumberExclusive);if(b<=e)return new m(b,e)}intersectsStrict(a){return this.startLineNumber<a.endLineNumberExclusive&&a.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(a){return this.startLineNumber<=a.endLineNumberExclusive&&a.startLineNumber<=this.endLineNumberExclusive}equals(a){return this.startLineNumber===a.startLineNumber&&this.endLineNumberExclusive===a.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new M.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new M.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(a){const b=[];for(let e=this.startLineNumber;e<this.endLineNumberExclusive;e++)b.push(a(e));return b}forEach(a){for(let b=this.startLineNumber;b<this.endLineNumberExclusive;b++)a(b)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(a){return this.startLineNumber<=a&&a<this.endLineNumberExclusive}toOffsetRange(){return new x.OffsetRange(this.startLineNumber-1,this.endLineNumberExclusive-1)}}n.LineRange=m;class v{constructor(a=[]){this._normalizedRanges=a}get ranges(){return this._normalizedRanges}addRange(a){if(a.length===0)return;const b=(0,g.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,f=>f.endLineNumberExclusive>=a.startLineNumber),e=(0,g.findLastIdxMonotonous)(this._normalizedRanges,f=>f.startLineNumber<=a.endLineNumberExclusive)+1;if(b===e)this._normalizedRanges.splice(b,0,a);else if(b===e-1){const f=this._normalizedRanges[b];this._normalizedRanges[b]=f.join(a)}else{const f=this._normalizedRanges[b].join(this._normalizedRanges[e-1]).join(a);this._normalizedRanges.splice(b,e-b,f)}}contains(a){const b=(0,g.findLastMonotonous)(this._normalizedRanges,e=>e.startLineNumber<=a);return!!b&&b.endLineNumberExclusive>a}intersects(a){const b=(0,g.findLastMonotonous)(this._normalizedRanges,e=>e.startLineNumber<a.endLineNumberExclusive);return!!b&&b.endLineNumberExclusive>a.startLineNumber}getUnion(a){if(this._normalizedRanges.length===0)return a;if(a._normalizedRanges.length===0)return this;const b=[];let e=0,f=0,s=null;for(;e<this._normalizedRanges.length||f<a._normalizedRanges.length;){let u=null;if(e<this._normalizedRanges.length&&f<a._normalizedRanges.length){const d=this._normalizedRanges[e],h=a._normalizedRanges[f];d.startLineNumber<h.startLineNumber?(u=d,e++):(u=h,f++)}else e<this._normalizedRanges.length?(u=this._normalizedRanges[e],e++):(u=a._normalizedRanges[f],f++);s===null?s=u:s.endLineNumberExclusive>=u.startLineNumber?s=new m(s.startLineNumber,Math.max(s.endLineNumberExclusive,u.endLineNumberExclusive)):(b.push(s),s=u)}return s!==null&&b.push(s),new v(b)}subtractFrom(a){const b=(0,g.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,u=>u.endLineNumberExclusive>=a.startLineNumber),e=(0,g.findLastIdxMonotonous)(this._normalizedRanges,u=>u.startLineNumber<=a.endLineNumberExclusive)+1;if(b===e)return new v([a]);const f=[];let s=a.startLineNumber;for(let u=b;u<e;u++){const d=this._normalizedRanges[u];d.startLineNumber>s&&f.push(new m(s,d.startLineNumber)),s=d.endLineNumberExclusive}return s<a.endLineNumberExclusive&&f.push(new m(s,a.endLineNumberExclusive)),new v(f)}toString(){return this._normalizedRanges.map(a=>a.toString()).join(", ")}getIntersection(a){const b=[];let e=0,f=0;for(;e<this._normalizedRanges.length&&f<a._normalizedRanges.length;){const s=this._normalizedRanges[e],u=a._normalizedRanges[f],d=s.intersect(u);d&&!d.isEmpty&&b.push(d),s.endLineNumberExclusive<u.endLineNumberExclusive?e++:f++}return new v(b)}getWithDelta(a){return new v(this._normalizedRanges.map(b=>b.delta(a)))}}n.LineRangeSet=v}),Y(X[43],Z([0,1,4,2]),function(O,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=void 0;class M extends x.Range{constructor(m,v,o,a){super(m,v,o,a),this.selectionStartLineNumber=m,this.selectionStartColumn=v,this.positionLineNumber=o,this.positionColumn=a}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(m){return M.selectionsEqual(this,m)}static selectionsEqual(m,v){return m.selectionStartLineNumber===v.selectionStartLineNumber&&m.selectionStartColumn===v.selectionStartColumn&&m.positionLineNumber===v.positionLineNumber&&m.positionColumn===v.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(m,v){return this.getDirection()===0?new M(this.startLineNumber,this.startColumn,m,v):new M(m,v,this.startLineNumber,this.startColumn)}getPosition(){return new r.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new r.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(m,v){return this.getDirection()===0?new M(m,v,this.endLineNumber,this.endColumn):new M(this.endLineNumber,this.endColumn,m,v)}static fromPositions(m,v=m){return new M(m.lineNumber,m.column,v.lineNumber,v.column)}static fromRange(m,v){return v===0?new M(m.startLineNumber,m.startColumn,m.endLineNumber,m.endColumn):new M(m.endLineNumber,m.endColumn,m.startLineNumber,m.startColumn)}static liftSelection(m){return new M(m.selectionStartLineNumber,m.selectionStartColumn,m.positionLineNumber,m.positionColumn)}static selectionsArrEqual(m,v){if(m&&!v||!m&&v)return!1;if(!m&&!v)return!0;if(m.length!==v.length)return!1;for(let o=0,a=m.length;o<a;o++)if(!this.selectionsEqual(m[o],v[o]))return!1;return!0}static isISelection(m){return m&&typeof m.selectionStartLineNumber=="number"&&typeof m.selectionStartColumn=="number"&&typeof m.positionLineNumber=="number"&&typeof m.positionColumn=="number"}static createWithDirection(m,v,o,a,b){return b===0?new M(m,v,o,a):new M(o,a,m,v)}}n.Selection=M}),Y(X[44],Z([0,1,23,29]),function(O,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WordCharacterClassifier=void 0,n.getMapForWordSeparators=m;class M extends x.CharacterClassifier{constructor(o,a){super(0),this._segmenter=null,this._cachedLine=null,this._cachedSegments=[],this.intlSegmenterLocales=a,this.intlSegmenterLocales.length>0?this._segmenter=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this._segmenter=null;for(let b=0,e=o.length;b<e;b++)this.set(o.charCodeAt(b),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(o,a){let b=null;for(const e of this._getIntlSegmenterWordsOnLine(o)){if(e.index>a)break;b=e}return b}findNextIntlWordAtOrAfterOffset(o,a){for(const b of this._getIntlSegmenterWordsOnLine(o))if(!(b.index<a))return b;return null}_getIntlSegmenterWordsOnLine(o){return this._segmenter?this._cachedLine===o?this._cachedSegments:(this._cachedLine=o,this._cachedSegments=this._filterWordSegments(this._segmenter.segment(o)),this._cachedSegments):[]}_filterWordSegments(o){const a=[];for(const b of o)this._isWordLike(b)&&a.push(b);return a}_isWordLike(o){return!!o.isWordLike}}n.WordCharacterClassifier=M;const g=new r.LRUCache(10);function m(v,o){const a=`${v}/${o.join(",")}`;let b=g.get(a);return b||(b=new M(v,o),g.set(a,b)),b}}),Y(X[30],Z([0,1,21,22]),function(O,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.ensureValidWordDefinition=g,n.getWordAtText=v,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function M(a=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const e of n.USUAL_WORD_SEPARATORS)a.indexOf(e)>=0||(b+="\\"+e);return b+="\\s]+)",new RegExp(b,"g")}n.DEFAULT_WORD_REGEXP=M();function g(a){let b=n.DEFAULT_WORD_REGEXP;if(a&&a instanceof RegExp)if(a.global)b=a;else{let e="g";a.ignoreCase&&(e+="i"),a.multiline&&(e+="m"),a.unicode&&(e+="u"),b=new RegExp(a.source,e)}return b.lastIndex=0,b}const m=new x.LinkedList;m.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function v(a,b,e,f,s){if(b=g(b),s||(s=r.Iterable.first(m)),e.length>s.maxLen){let _=a-s.maxLen/2;return _<0?_=0:f+=_,e=e.substring(_,a+s.maxLen/2),v(a,b,e,f,s)}const u=Date.now(),d=a-1-f;let h=-1,S=null;for(let _=1;!(Date.now()-u>=s.timeBudget);_++){const E=d-s.windowSize*_;b.lastIndex=Math.max(0,E);const A=o(b,e,d,h);if(!A&&S||(S=A,E<=0))break;h=E}if(S){const _={word:S[0],startColumn:f+1+S.index,endColumn:f+1+S.index+S[0].length};return b.lastIndex=0,_}return null}function o(a,b,e,f){let s;for(;s=a.exec(b);){const u=s.index||0;if(u<=e&&a.lastIndex>=e)return s;if(f>0&&u>f)return null}return null}}),Y(X[8],Z([0,1,7,5,3]),function(O,n,r,x,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DateTimeout=n.InfiniteTimeout=n.OffsetPair=n.SequenceDiff=n.DiffAlgorithmResult=void 0;class g{static trivial(e,f){return new g([new m(M.OffsetRange.ofLength(e.length),M.OffsetRange.ofLength(f.length))],!1)}static trivialTimedOut(e,f){return new g([new m(M.OffsetRange.ofLength(e.length),M.OffsetRange.ofLength(f.length))],!0)}constructor(e,f){this.diffs=e,this.hitTimeout=f}}n.DiffAlgorithmResult=g;class m{static invert(e,f){const s=[];return(0,r.forEachAdjacent)(e,(u,d)=>{s.push(m.fromOffsetPairs(u?u.getEndExclusives():v.zero,d?d.getStarts():new v(f,(u?u.seq2Range.endExclusive-u.seq1Range.endExclusive:0)+f)))}),s}static fromOffsetPairs(e,f){return new m(new M.OffsetRange(e.offset1,f.offset1),new M.OffsetRange(e.offset2,f.offset2))}constructor(e,f){this.seq1Range=e,this.seq2Range=f}swap(){return new m(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(e){return new m(this.seq1Range.join(e.seq1Range),this.seq2Range.join(e.seq2Range))}delta(e){return e===0?this:new m(this.seq1Range.delta(e),this.seq2Range.delta(e))}deltaStart(e){return e===0?this:new m(this.seq1Range.deltaStart(e),this.seq2Range.deltaStart(e))}deltaEnd(e){return e===0?this:new m(this.seq1Range.deltaEnd(e),this.seq2Range.deltaEnd(e))}intersect(e){const f=this.seq1Range.intersect(e.seq1Range),s=this.seq2Range.intersect(e.seq2Range);if(!(!f||!s))return new m(f,s)}getStarts(){return new v(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new v(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}n.SequenceDiff=m;class v{constructor(e,f){this.offset1=e,this.offset2=f}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(e){return e===0?this:new v(this.offset1+e,this.offset2+e)}equals(e){return this.offset1===e.offset1&&this.offset2===e.offset2}}n.OffsetPair=v,v.zero=new v(0,0),v.max=new v(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER);class o{isValid(){return!0}}n.InfiniteTimeout=o,o.instance=new o;class a{constructor(e){if(this.timeout=e,this.startTime=Date.now(),this.valid=!0,e<=0)throw new x.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}}n.DateTimeout=a}),Y(X[31],Z([0,1,3,8]),function(O,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MyersDiffAlgorithm=void 0;class M{compute(a,b,e=x.InfiniteTimeout.instance){if(a.length===0||b.length===0)return x.DiffAlgorithmResult.trivial(a,b);const f=a,s=b;function u(l,c){for(;l<f.length&&c<s.length&&f.getElement(l)===s.getElement(c);)l++,c++;return l}let d=0;const h=new m;h.set(0,u(0,0));const S=new v;S.set(0,h.get(0)===0?null:new g(null,0,0,h.get(0)));let _=0;e:for(;;){if(d++,!e.isValid())return x.DiffAlgorithmResult.trivialTimedOut(f,s);const l=-Math.min(d,s.length+d%2),c=Math.min(d,f.length+d%2);for(_=l;_<=c;_+=2){let L=0;const w=_===c?-1:h.get(_+1),C=_===l?-1:h.get(_-1)+1;L++;const N=Math.min(Math.max(w,C),f.length),y=N-_;if(L++,N>f.length||y>s.length)continue;const R=u(N,y);h.set(_,R);const D=N===w?S.get(_+1):S.get(_-1);if(S.set(_,R!==N?new g(D,N,y,R-N):D),h.get(_)===f.length&&h.get(_)-_===s.length)break e}}let E=S.get(_);const A=[];let p=f.length,i=s.length;for(;;){const l=E?E.x+E.length:0,c=E?E.y+E.length:0;if((l!==p||c!==i)&&A.push(new x.SequenceDiff(new r.OffsetRange(l,p),new r.OffsetRange(c,i))),!E)break;p=E.x,i=E.y,E=E.prev}return A.reverse(),new x.DiffAlgorithmResult(A,!1)}}n.MyersDiffAlgorithm=M;class g{constructor(a,b,e,f){this.prev=a,this.x=b,this.y=e,this.length=f}}class m{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(a){return a<0?(a=-a-1,this.negativeArr[a]):this.positiveArr[a]}set(a,b){if(a<0){if(a=-a-1,a>=this.negativeArr.length){const e=this.negativeArr;this.negativeArr=new Int32Array(e.length*2),this.negativeArr.set(e)}this.negativeArr[a]=b}else{if(a>=this.positiveArr.length){const e=this.positiveArr;this.positiveArr=new Int32Array(e.length*2),this.positiveArr.set(e)}this.positiveArr[a]=b}}}class v{constructor(){this.positiveArr=[],this.negativeArr=[]}get(a){return a<0?(a=-a-1,this.negativeArr[a]):this.positiveArr[a]}set(a,b){a<0?(a=-a-1,this.negativeArr[a]=b):this.positiveArr[a]=b}}}),Y(X[45],Z([0,1,7,3,8]),function(O,n,r,x,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.optimizeSequenceDiffs=g,n.removeShortMatches=a,n.extendDiffsToEntireWordIfAppropriate=b,n.removeVeryShortMatchingLinesBetweenDiffs=f,n.removeVeryShortMatchingTextBetweenLongDiffs=s;function g(u,d,h){let S=h;return S=m(u,d,S),S=m(u,d,S),S=v(u,d,S),S}function m(u,d,h){if(h.length===0)return h;const S=[];S.push(h[0]);for(let E=1;E<h.length;E++){const A=S[S.length-1];let p=h[E];if(p.seq1Range.isEmpty||p.seq2Range.isEmpty){const i=p.seq1Range.start-A.seq1Range.endExclusive;let l;for(l=1;l<=i&&!(u.getElement(p.seq1Range.start-l)!==u.getElement(p.seq1Range.endExclusive-l)||d.getElement(p.seq2Range.start-l)!==d.getElement(p.seq2Range.endExclusive-l));l++);if(l--,l===i){S[S.length-1]=new M.SequenceDiff(new x.OffsetRange(A.seq1Range.start,p.seq1Range.endExclusive-i),new x.OffsetRange(A.seq2Range.start,p.seq2Range.endExclusive-i));continue}p=p.delta(-l)}S.push(p)}const _=[];for(let E=0;E<S.length-1;E++){const A=S[E+1];let p=S[E];if(p.seq1Range.isEmpty||p.seq2Range.isEmpty){const i=A.seq1Range.start-p.seq1Range.endExclusive;let l;for(l=0;l<i&&!(!u.isStronglyEqual(p.seq1Range.start+l,p.seq1Range.endExclusive+l)||!d.isStronglyEqual(p.seq2Range.start+l,p.seq2Range.endExclusive+l));l++);if(l===i){S[E+1]=new M.SequenceDiff(new x.OffsetRange(p.seq1Range.start+i,A.seq1Range.endExclusive),new x.OffsetRange(p.seq2Range.start+i,A.seq2Range.endExclusive));continue}l>0&&(p=p.delta(l))}_.push(p)}return S.length>0&&_.push(S[S.length-1]),_}function v(u,d,h){if(!u.getBoundaryScore||!d.getBoundaryScore)return h;for(let S=0;S<h.length;S++){const _=S>0?h[S-1]:void 0,E=h[S],A=S+1<h.length?h[S+1]:void 0,p=new x.OffsetRange(_?_.seq1Range.endExclusive+1:0,A?A.seq1Range.start-1:u.length),i=new x.OffsetRange(_?_.seq2Range.endExclusive+1:0,A?A.seq2Range.start-1:d.length);E.seq1Range.isEmpty?h[S]=o(E,u,d,p,i):E.seq2Range.isEmpty&&(h[S]=o(E.swap(),d,u,i,p).swap())}return h}function o(u,d,h,S,_){let A=1;for(;u.seq1Range.start-A>=S.start&&u.seq2Range.start-A>=_.start&&h.isStronglyEqual(u.seq2Range.start-A,u.seq2Range.endExclusive-A)&&A<100;)A++;A--;let p=0;for(;u.seq1Range.start+p<S.endExclusive&&u.seq2Range.endExclusive+p<_.endExclusive&&h.isStronglyEqual(u.seq2Range.start+p,u.seq2Range.endExclusive+p)&&p<100;)p++;if(A===0&&p===0)return u;let i=0,l=-1;for(let c=-A;c<=p;c++){const L=u.seq2Range.start+c,w=u.seq2Range.endExclusive+c,C=u.seq1Range.start+c,N=d.getBoundaryScore(C)+h.getBoundaryScore(L)+h.getBoundaryScore(w);N>l&&(l=N,i=c)}return u.delta(i)}function a(u,d,h){const S=[];for(const _ of h){const E=S[S.length-1];if(!E){S.push(_);continue}_.seq1Range.start-E.seq1Range.endExclusive<=2||_.seq2Range.start-E.seq2Range.endExclusive<=2?S[S.length-1]=new M.SequenceDiff(E.seq1Range.join(_.seq1Range),E.seq2Range.join(_.seq2Range)):S.push(_)}return S}function b(u,d,h){const S=M.SequenceDiff.invert(h,u.length),_=[];let E=new M.OffsetPair(0,0);function A(i,l){if(i.offset1<E.offset1||i.offset2<E.offset2)return;const c=u.findWordContaining(i.offset1),L=d.findWordContaining(i.offset2);if(!c||!L)return;let w=new M.SequenceDiff(c,L);const C=w.intersect(l);let N=C.seq1Range.length,y=C.seq2Range.length;for(;S.length>0;){const R=S[0];if(!(R.seq1Range.intersects(w.seq1Range)||R.seq2Range.intersects(w.seq2Range)))break;const T=u.findWordContaining(R.seq1Range.start),k=d.findWordContaining(R.seq2Range.start),q=new M.SequenceDiff(T,k),H=q.intersect(R);if(N+=H.seq1Range.length,y+=H.seq2Range.length,w=w.join(q),w.seq1Range.endExclusive>=R.seq1Range.endExclusive)S.shift();else break}N+y<(w.seq1Range.length+w.seq2Range.length)*2/3&&_.push(w),E=w.getEndExclusives()}for(;S.length>0;){const i=S.shift();i.seq1Range.isEmpty||(A(i.getStarts(),i),A(i.getEndExclusives().delta(-1),i))}return e(h,_)}function e(u,d){const h=[];for(;u.length>0||d.length>0;){const S=u[0],_=d[0];let E;S&&(!_||S.seq1Range.start<_.seq1Range.start)?E=u.shift():E=d.shift(),h.length>0&&h[h.length-1].seq1Range.endExclusive>=E.seq1Range.start?h[h.length-1]=h[h.length-1].join(E):h.push(E)}return h}function f(u,d,h){let S=h;if(S.length===0)return S;let _=0,E;do{E=!1;const A=[S[0]];for(let p=1;p<S.length;p++){let c=function(w,C){const N=new x.OffsetRange(l.seq1Range.endExclusive,i.seq1Range.start);return u.getText(N).replace(/\s/g,"").length<=4&&(w.seq1Range.length+w.seq2Range.length>5||C.seq1Range.length+C.seq2Range.length>5)};const i=S[p],l=A[A.length-1];c(l,i)?(E=!0,A[A.length-1]=A[A.length-1].join(i)):A.push(i)}S=A}while(_++<10&&E);return S}function s(u,d,h){let S=h;if(S.length===0)return S;let _=0,E;do{E=!1;const p=[S[0]];for(let i=1;i<S.length;i++){let L=function(C,N){const y=new x.OffsetRange(c.seq1Range.endExclusive,l.seq1Range.start);if(u.countLinesIn(y)>5||y.length>500)return!1;const D=u.getText(y).trim();if(D.length>20||D.split(/\r\n|\r|\n/).length>1)return!1;const T=u.countLinesIn(C.seq1Range),k=C.seq1Range.length,q=d.countLinesIn(C.seq2Range),H=C.seq2Range.length,Q=u.countLinesIn(N.seq1Range),F=N.seq1Range.length,I=d.countLinesIn(N.seq2Range),W=N.seq2Range.length,V=2*40+50;function z(U){return Math.min(U,V)}return Math.pow(Math.pow(z(T*40+k),1.5)+Math.pow(z(q*40+H),1.5),1.5)+Math.pow(Math.pow(z(Q*40+F),1.5)+Math.pow(z(I*40+W),1.5),1.5)>(V**1.5)**1.5*1.3};const l=S[i],c=p[p.length-1];L(c,l)?(E=!0,p[p.length-1]=p[p.length-1].join(l)):p.push(l)}S=p}while(_++<10&&E);const A=[];return(0,r.forEachWithNeighbors)(S,(p,i,l)=>{let c=i;function L(D){return D.length>0&&D.trim().length<=3&&i.seq1Range.length+i.seq2Range.length>100}const w=u.extendToFullLines(i.seq1Range),C=u.getText(new x.OffsetRange(w.start,i.seq1Range.start));L(C)&&(c=c.deltaStart(-C.length));const N=u.getText(new x.OffsetRange(i.seq1Range.endExclusive,w.endExclusive));L(N)&&(c=c.deltaEnd(N.length));const y=M.SequenceDiff.fromOffsetPairs(p?p.getEndExclusives():M.OffsetPair.zero,l?l.getStarts():M.OffsetPair.max),R=c.intersect(y);A.length>0&&R.getStarts().equals(A[A.length-1].getEndExclusives())?A[A.length-1]=A[A.length-1].join(R):A.push(R)}),A}}),Y(X[46],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineSequence=void 0;class r{constructor(g,m){this.trimmedHash=g,this.lines=m}getElement(g){return this.trimmedHash[g]}get length(){return this.trimmedHash.length}getBoundaryScore(g){const m=g===0?0:x(this.lines[g-1]),v=g===this.lines.length?0:x(this.lines[g]);return 1e3-(m+v)}getText(g){return this.lines.slice(g.start,g.endExclusive).join(`
`)}isStronglyEqual(g,m){return this.lines[g]===this.lines[m]}}n.LineSequence=r;function x(M){let g=0;for(;g<M.length&&(M.charCodeAt(g)===32||M.charCodeAt(g)===9);)g++;return g}}),Y(X[15],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRangeFragment=n.Array2D=void 0,n.isSpace=x;class r{constructor(m,v){this.width=m,this.height=v,this.array=[],this.array=new Array(m*v)}get(m,v){return this.array[m+v*this.width]}set(m,v,o){this.array[m+v*this.width]=o}}n.Array2D=r;function x(g){return g===32||g===9}class M{static getKey(m){let v=this.chrKeys.get(m);return v===void 0&&(v=this.chrKeys.size,this.chrKeys.set(m,v)),v}constructor(m,v,o){this.range=m,this.lines=v,this.source=o,this.histogram=[];let a=0;for(let b=m.startLineNumber-1;b<m.endLineNumberExclusive-1;b++){const e=v[b];for(let s=0;s<e.length;s++){a++;const u=e[s],d=M.getKey(u);this.histogram[d]=(this.histogram[d]||0)+1}a++;const f=M.getKey(`
`);this.histogram[f]=(this.histogram[f]||0)+1}this.totalCount=a}computeSimilarity(m){var v,o;let a=0;const b=Math.max(this.histogram.length,m.histogram.length);for(let e=0;e<b;e++)a+=Math.abs(((v=this.histogram[e])!==null&&v!==void 0?v:0)-((o=m.histogram[e])!==null&&o!==void 0?o:0));return 1-a/(this.totalCount+m.totalCount)}}n.LineRangeFragment=M,M.chrKeys=new Map}),Y(X[47],Z([0,1,3,8,15]),function(O,n,r,x,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DynamicProgrammingDiffing=void 0;class g{compute(v,o,a=x.InfiniteTimeout.instance,b){if(v.length===0||o.length===0)return x.DiffAlgorithmResult.trivial(v,o);const e=new M.Array2D(v.length,o.length),f=new M.Array2D(v.length,o.length),s=new M.Array2D(v.length,o.length);for(let A=0;A<v.length;A++)for(let p=0;p<o.length;p++){if(!a.isValid())return x.DiffAlgorithmResult.trivialTimedOut(v,o);const i=A===0?0:e.get(A-1,p),l=p===0?0:e.get(A,p-1);let c;v.getElement(A)===o.getElement(p)?(A===0||p===0?c=0:c=e.get(A-1,p-1),A>0&&p>0&&f.get(A-1,p-1)===3&&(c+=s.get(A-1,p-1)),c+=b?b(A,p):1):c=-1;const L=Math.max(i,l,c);if(L===c){const w=A>0&&p>0?s.get(A-1,p-1):0;s.set(A,p,w+1),f.set(A,p,3)}else L===i?(s.set(A,p,0),f.set(A,p,1)):L===l&&(s.set(A,p,0),f.set(A,p,2));e.set(A,p,L)}const u=[];let d=v.length,h=o.length;function S(A,p){(A+1!==d||p+1!==h)&&u.push(new x.SequenceDiff(new r.OffsetRange(A+1,d),new r.OffsetRange(p+1,h))),d=A,h=p}let _=v.length-1,E=o.length-1;for(;_>=0&&E>=0;)f.get(_,E)===3?(S(_,E),_--,E--):f.get(_,E)===1?_--:E--;return S(-1,-1),u.reverse(),new x.DiffAlgorithmResult(u,!1)}}n.DynamicProgrammingDiffing=g}),Y(X[32],Z([0,1,11,3,4,2,15]),function(O,n,r,x,M,g,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinesSliceCharSequence=void 0;class v{constructor(s,u,d){this.lines=s,this.considerWhitespaceChanges=d,this.elements=[],this.firstCharOffsetByLine=[],this.additionalOffsetByLine=[];let h=!1;u.start>0&&u.endExclusive>=s.length&&(u=new x.OffsetRange(u.start-1,u.endExclusive),h=!0),this.lineRange=u,this.firstCharOffsetByLine[0]=0;for(let S=this.lineRange.start;S<this.lineRange.endExclusive;S++){let _=s[S],E=0;if(h)E=_.length,_="",h=!1;else if(!d){const A=_.trimStart();E=_.length-A.length,_=A.trimEnd()}this.additionalOffsetByLine.push(E);for(let A=0;A<_.length;A++)this.elements.push(_.charCodeAt(A));S<s.length-1&&(this.elements.push(10),this.firstCharOffsetByLine[S-this.lineRange.start+1]=this.elements.length)}this.additionalOffsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new x.OffsetRange(0,this.length))}getText(s){return this.elements.slice(s.start,s.endExclusive).map(u=>String.fromCharCode(u)).join("")}getElement(s){return this.elements[s]}get length(){return this.elements.length}getBoundaryScore(s){const u=e(s>0?this.elements[s-1]:-1),d=e(s<this.elements.length?this.elements[s]:-1);if(u===7&&d===8)return 0;if(u===8)return 150;let h=0;return u!==d&&(h+=10,u===0&&d===1&&(h+=1)),h+=b(u),h+=b(d),h}translateOffset(s){if(this.lineRange.isEmpty)return new M.Position(this.lineRange.start+1,1);const u=(0,r.findLastIdxMonotonous)(this.firstCharOffsetByLine,d=>d<=s);return new M.Position(this.lineRange.start+u+1,s-this.firstCharOffsetByLine[u]+this.additionalOffsetByLine[u]+1)}translateRange(s){return g.Range.fromPositions(this.translateOffset(s.start),this.translateOffset(s.endExclusive))}findWordContaining(s){if(s<0||s>=this.elements.length||!o(this.elements[s]))return;let u=s;for(;u>0&&o(this.elements[u-1]);)u--;let d=s;for(;d<this.elements.length&&o(this.elements[d]);)d++;return new x.OffsetRange(u,d)}countLinesIn(s){return this.translateOffset(s.endExclusive).lineNumber-this.translateOffset(s.start).lineNumber}isStronglyEqual(s,u){return this.elements[s]===this.elements[u]}extendToFullLines(s){var u,d;const h=(u=(0,r.findLastMonotonous)(this.firstCharOffsetByLine,_=>_<=s.start))!==null&&u!==void 0?u:0,S=(d=(0,r.findFirstMonotonous)(this.firstCharOffsetByLine,_=>s.endExclusive<=_))!==null&&d!==void 0?d:this.elements.length;return new x.OffsetRange(h,S)}}n.LinesSliceCharSequence=v;function o(f){return f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57}const a={0:0,1:0,2:0,3:10,4:2,5:30,6:3,7:10,8:10};function b(f){return a[f]}function e(f){return f===10?8:f===13?7:(0,m.isSpace)(f)?6:f>=97&&f<=122?0:f>=65&&f<=90?1:f>=48&&f<=57?2:f===-1?3:f===44||f===59?5:4}}),Y(X[33],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MovedText=n.LinesDiff=void 0;class r{constructor(g,m,v){this.changes=g,this.moves=m,this.hitTimeout=v}}n.LinesDiff=r;class x{constructor(g,m){this.lineRangeMapping=g,this.changes=m}}n.MovedText=x}),Y(X[16],Z([0,1,10]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.RangeMapping=n.DetailedLineRangeMapping=n.LineRangeMapping=void 0;class x{static inverse(v,o,a){const b=[];let e=1,f=1;for(const u of v){const d=new x(new r.LineRange(e,u.original.startLineNumber),new r.LineRange(f,u.modified.startLineNumber));d.modified.isEmpty||b.push(d),e=u.original.endLineNumberExclusive,f=u.modified.endLineNumberExclusive}const s=new x(new r.LineRange(e,o+1),new r.LineRange(f,a+1));return s.modified.isEmpty||b.push(s),b}static clip(v,o,a){const b=[];for(const e of v){const f=e.original.intersect(o),s=e.modified.intersect(a);f&&!f.isEmpty&&s&&!s.isEmpty&&b.push(new x(f,s))}return b}constructor(v,o){this.original=v,this.modified=o}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new x(this.modified,this.original)}join(v){return new x(this.original.join(v.original),this.modified.join(v.modified))}}n.LineRangeMapping=x;class M extends x{static fromRangeMappings(v){const o=r.LineRange.join(v.map(b=>r.LineRange.fromRangeInclusive(b.originalRange))),a=r.LineRange.join(v.map(b=>r.LineRange.fromRangeInclusive(b.modifiedRange)));return new M(o,a,v)}constructor(v,o,a){super(v,o),this.innerChanges=a}flip(){var v;return new M(this.modified,this.original,(v=this.innerChanges)===null||v===void 0?void 0:v.map(o=>o.flip()))}withInnerChangesFromLineRanges(){return new M(this.original,this.modified,[new g(this.original.toExclusiveRange(),this.modified.toExclusiveRange())])}}n.DetailedLineRangeMapping=M;class g{constructor(v,o){this.originalRange=v,this.modifiedRange=o}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new g(this.modifiedRange,this.originalRange)}}n.RangeMapping=g}),Y(X[48],Z([0,1,8,16,7,11,23,10,3,32,15,31]),function(O,n,r,x,M,g,m,v,o,a,b,e){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeMovedLines=f;function f(E,A,p,i,l,c){let{moves:L,excludedChanges:w}=u(E,A,p,c);if(!c.isValid())return[];const C=E.filter(y=>!w.has(y)),N=d(C,i,l,A,p,c);return(0,M.pushMany)(L,N),L=S(L),L=L.filter(y=>{const R=y.original.toOffsetRange().slice(A).map(T=>T.trim());return R.join(`
`).length>=15&&s(R,T=>T.length>=2)>=2}),L=_(E,L),L}function s(E,A){let p=0;for(const i of E)A(i)&&p++;return p}function u(E,A,p,i){const l=[],c=E.filter(C=>C.modified.isEmpty&&C.original.length>=3).map(C=>new b.LineRangeFragment(C.original,A,C)),L=new Set(E.filter(C=>C.original.isEmpty&&C.modified.length>=3).map(C=>new b.LineRangeFragment(C.modified,p,C))),w=new Set;for(const C of c){let N=-1,y;for(const R of L){const D=C.computeSimilarity(R);D>N&&(N=D,y=R)}if(N>.9&&y&&(L.delete(y),l.push(new x.LineRangeMapping(C.range,y.range)),w.add(C.source),w.add(y.source)),!i.isValid())return{moves:l,excludedChanges:w}}return{moves:l,excludedChanges:w}}function d(E,A,p,i,l,c){const L=[],w=new m.SetMap;for(const D of E)for(let T=D.original.startLineNumber;T<D.original.endLineNumberExclusive-2;T++){const k=`${A[T-1]}:${A[T+1-1]}:${A[T+2-1]}`;w.add(k,{range:new v.LineRange(T,T+3)})}const C=[];E.sort((0,M.compareBy)(D=>D.modified.startLineNumber,M.numberComparator));for(const D of E){let T=[];for(let k=D.modified.startLineNumber;k<D.modified.endLineNumberExclusive-2;k++){const q=`${p[k-1]}:${p[k+1-1]}:${p[k+2-1]}`,H=new v.LineRange(k,k+3),Q=[];w.forEach(q,({range:F})=>{for(const W of T)if(W.originalLineRange.endLineNumberExclusive+1===F.endLineNumberExclusive&&W.modifiedLineRange.endLineNumberExclusive+1===H.endLineNumberExclusive){W.originalLineRange=new v.LineRange(W.originalLineRange.startLineNumber,F.endLineNumberExclusive),W.modifiedLineRange=new v.LineRange(W.modifiedLineRange.startLineNumber,H.endLineNumberExclusive),Q.push(W);return}const I={modifiedLineRange:H,originalLineRange:F};C.push(I),Q.push(I)}),T=Q}if(!c.isValid())return[]}C.sort((0,M.reverseOrder)((0,M.compareBy)(D=>D.modifiedLineRange.length,M.numberComparator)));const N=new v.LineRangeSet,y=new v.LineRangeSet;for(const D of C){const T=D.modifiedLineRange.startLineNumber-D.originalLineRange.startLineNumber,k=N.subtractFrom(D.modifiedLineRange),q=y.subtractFrom(D.originalLineRange).getWithDelta(T),H=k.getIntersection(q);for(const Q of H.ranges){if(Q.length<3)continue;const F=Q,I=Q.delta(-T);L.push(new x.LineRangeMapping(I,F)),N.addRange(F),y.addRange(I)}}L.sort((0,M.compareBy)(D=>D.original.startLineNumber,M.numberComparator));const R=new g.MonotonousArray(E);for(let D=0;D<L.length;D++){const T=L[D],k=R.findLastMonotonous(z=>z.original.startLineNumber<=T.original.startLineNumber),q=(0,g.findLastMonotonous)(E,z=>z.modified.startLineNumber<=T.modified.startLineNumber),H=Math.max(T.original.startLineNumber-k.original.startLineNumber,T.modified.startLineNumber-q.modified.startLineNumber),Q=R.findLastMonotonous(z=>z.original.startLineNumber<T.original.endLineNumberExclusive),F=(0,g.findLastMonotonous)(E,z=>z.modified.startLineNumber<T.modified.endLineNumberExclusive),I=Math.max(Q.original.endLineNumberExclusive-T.original.endLineNumberExclusive,F.modified.endLineNumberExclusive-T.modified.endLineNumberExclusive);let W;for(W=0;W<H;W++){const z=T.original.startLineNumber-W-1,U=T.modified.startLineNumber-W-1;if(z>i.length||U>l.length||N.contains(U)||y.contains(z)||!h(i[z-1],l[U-1],c))break}W>0&&(y.addRange(new v.LineRange(T.original.startLineNumber-W,T.original.startLineNumber)),N.addRange(new v.LineRange(T.modified.startLineNumber-W,T.modified.startLineNumber)));let V;for(V=0;V<I;V++){const z=T.original.endLineNumberExclusive+V,U=T.modified.endLineNumberExclusive+V;if(z>i.length||U>l.length||N.contains(U)||y.contains(z)||!h(i[z-1],l[U-1],c))break}V>0&&(y.addRange(new v.LineRange(T.original.endLineNumberExclusive,T.original.endLineNumberExclusive+V)),N.addRange(new v.LineRange(T.modified.endLineNumberExclusive,T.modified.endLineNumberExclusive+V))),(W>0||V>0)&&(L[D]=new x.LineRangeMapping(new v.LineRange(T.original.startLineNumber-W,T.original.endLineNumberExclusive+V),new v.LineRange(T.modified.startLineNumber-W,T.modified.endLineNumberExclusive+V)))}return L}function h(E,A,p){if(E.trim()===A.trim())return!0;if(E.length>300&&A.length>300)return!1;const l=new e.MyersDiffAlgorithm().compute(new a.LinesSliceCharSequence([E],new o.OffsetRange(0,1),!1),new a.LinesSliceCharSequence([A],new o.OffsetRange(0,1),!1),p);let c=0;const L=r.SequenceDiff.invert(l.diffs,E.length);for(const y of L)y.seq1Range.forEach(R=>{(0,b.isSpace)(E.charCodeAt(R))||c++});function w(y){let R=0;for(let D=0;D<E.length;D++)(0,b.isSpace)(y.charCodeAt(D))||R++;return R}const C=w(E.length>A.length?E:A);return c/C>.6&&C>10}function S(E){if(E.length===0)return E;E.sort((0,M.compareBy)(p=>p.original.startLineNumber,M.numberComparator));const A=[E[0]];for(let p=1;p<E.length;p++){const i=A[A.length-1],l=E[p],c=l.original.startLineNumber-i.original.endLineNumberExclusive,L=l.modified.startLineNumber-i.modified.endLineNumberExclusive;if(c>=0&&L>=0&&c+L<=2){A[A.length-1]=i.join(l);continue}A.push(l)}return A}function _(E,A){const p=new g.MonotonousArray(E);return A=A.filter(i=>{const l=p.findLastMonotonous(w=>w.original.startLineNumber<i.original.endLineNumberExclusive)||new x.LineRangeMapping(new v.LineRange(1,1),new v.LineRange(1,1)),c=(0,g.findLastMonotonous)(E,w=>w.modified.startLineNumber<i.modified.endLineNumberExclusive);return l!==c}),A}}),Y(X[49],Z([0,1,7,12,10,3,2,8,47,31,48,45,46,32,33,16]),function(O,n,r,x,M,g,m,v,o,a,b,e,f,s,u,d){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DefaultLinesDiffComputer=void 0,n.lineRangeMappingFromRangeMappings=S,n.getLineRangeMapping=_;class h{constructor(){this.dynamicProgrammingDiffing=new o.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new a.MyersDiffAlgorithm}computeDiff(A,p,i){if(A.length<=1&&(0,r.equals)(A,p,(V,z)=>V===z))return new u.LinesDiff([],[],!1);if(A.length===1&&A[0].length===0||p.length===1&&p[0].length===0)return new u.LinesDiff([new d.DetailedLineRangeMapping(new M.LineRange(1,A.length+1),new M.LineRange(1,p.length+1),[new d.RangeMapping(new m.Range(1,1,A.length,A[0].length+1),new m.Range(1,1,p.length,p[0].length+1))])],[],!1);const l=i.maxComputationTimeMs===0?v.InfiniteTimeout.instance:new v.DateTimeout(i.maxComputationTimeMs),c=!i.ignoreTrimWhitespace,L=new Map;function w(V){let z=L.get(V);return z===void 0&&(z=L.size,L.set(V,z)),z}const C=A.map(V=>w(V.trim())),N=p.map(V=>w(V.trim())),y=new f.LineSequence(C,A),R=new f.LineSequence(N,p),D=y.length+R.length<1700?this.dynamicProgrammingDiffing.compute(y,R,l,(V,z)=>A[V]===p[z]?p[z].length===0?.1:1+Math.log(1+p[z].length):.99):this.myersDiffingAlgorithm.compute(y,R);let T=D.diffs,k=D.hitTimeout;T=(0,e.optimizeSequenceDiffs)(y,R,T),T=(0,e.removeVeryShortMatchingLinesBetweenDiffs)(y,R,T);const q=[],H=V=>{if(c)for(let z=0;z<V;z++){const U=Q+z,se=F+z;if(A[U]!==p[se]){const he=this.refineDiff(A,p,new v.SequenceDiff(new g.OffsetRange(U,U+1),new g.OffsetRange(se,se+1)),l,c);for(const de of he.mappings)q.push(de);he.hitTimeout&&(k=!0)}}};let Q=0,F=0;for(const V of T){(0,x.assertFn)(()=>V.seq1Range.start-Q===V.seq2Range.start-F);const z=V.seq1Range.start-Q;H(z),Q=V.seq1Range.endExclusive,F=V.seq2Range.endExclusive;const U=this.refineDiff(A,p,V,l,c);U.hitTimeout&&(k=!0);for(const se of U.mappings)q.push(se)}H(A.length-Q);const I=S(q,A,p);let W=[];return i.computeMoves&&(W=this.computeMoves(I,A,p,C,N,l,c)),(0,x.assertFn)(()=>{function V(U,se){if(U.lineNumber<1||U.lineNumber>se.length)return!1;const he=se[U.lineNumber-1];return!(U.column<1||U.column>he.length+1)}function z(U,se){return!(U.startLineNumber<1||U.startLineNumber>se.length+1||U.endLineNumberExclusive<1||U.endLineNumberExclusive>se.length+1)}for(const U of I){if(!U.innerChanges)return!1;for(const se of U.innerChanges)if(!(V(se.modifiedRange.getStartPosition(),p)&&V(se.modifiedRange.getEndPosition(),p)&&V(se.originalRange.getStartPosition(),A)&&V(se.originalRange.getEndPosition(),A)))return!1;if(!z(U.modified,p)||!z(U.original,A))return!1}return!0}),new u.LinesDiff(I,W,k)}computeMoves(A,p,i,l,c,L,w){return(0,b.computeMovedLines)(A,p,i,l,c,L).map(y=>{const R=this.refineDiff(p,i,new v.SequenceDiff(y.original.toOffsetRange(),y.modified.toOffsetRange()),L,w),D=S(R.mappings,p,i,!0);return new u.MovedText(y,D)})}refineDiff(A,p,i,l,c){const L=new s.LinesSliceCharSequence(A,i.seq1Range,c),w=new s.LinesSliceCharSequence(p,i.seq2Range,c),C=L.length+w.length<500?this.dynamicProgrammingDiffing.compute(L,w,l):this.myersDiffingAlgorithm.compute(L,w,l);let N=C.diffs;return N=(0,e.optimizeSequenceDiffs)(L,w,N),N=(0,e.extendDiffsToEntireWordIfAppropriate)(L,w,N),N=(0,e.removeShortMatches)(L,w,N),N=(0,e.removeVeryShortMatchingTextBetweenLongDiffs)(L,w,N),{mappings:N.map(R=>new d.RangeMapping(L.translateRange(R.seq1Range),w.translateRange(R.seq2Range))),hitTimeout:C.hitTimeout}}}n.DefaultLinesDiffComputer=h;function S(E,A,p,i=!1){const l=[];for(const c of(0,r.groupAdjacentBy)(E.map(L=>_(L,A,p)),(L,w)=>L.original.overlapOrTouch(w.original)||L.modified.overlapOrTouch(w.modified))){const L=c[0],w=c[c.length-1];l.push(new d.DetailedLineRangeMapping(L.original.join(w.original),L.modified.join(w.modified),c.map(C=>C.innerChanges[0])))}return(0,x.assertFn)(()=>!i&&l.length>0&&(l[0].modified.startLineNumber!==l[0].original.startLineNumber||p.length-l[l.length-1].modified.endLineNumberExclusive!==A.length-l[l.length-1].original.endLineNumberExclusive)?!1:(0,x.checkAdjacentItems)(l,(c,L)=>L.original.startLineNumber-c.original.endLineNumberExclusive===L.modified.startLineNumber-c.modified.endLineNumberExclusive&&c.original.endLineNumberExclusive<L.original.startLineNumber&&c.modified.endLineNumberExclusive<L.modified.startLineNumber)),l}function _(E,A,p){let i=0,l=0;E.modifiedRange.endColumn===1&&E.originalRange.endColumn===1&&E.originalRange.startLineNumber+i<=E.originalRange.endLineNumber&&E.modifiedRange.startLineNumber+i<=E.modifiedRange.endLineNumber&&(l=-1),E.modifiedRange.startColumn-1>=p[E.modifiedRange.startLineNumber-1].length&&E.originalRange.startColumn-1>=A[E.originalRange.startLineNumber-1].length&&E.originalRange.startLineNumber<=E.originalRange.endLineNumber+l&&E.modifiedRange.startLineNumber<=E.modifiedRange.endLineNumber+l&&(i=1);const c=new M.LineRange(E.originalRange.startLineNumber+i,E.originalRange.endLineNumber+1+l),L=new M.LineRange(E.modifiedRange.startLineNumber+i,E.modifiedRange.endLineNumber+1+l);return new d.DetailedLineRangeMapping(c,L,[E])}}),Y(X[50],Z([0,1,25,33,16,6,2,12,10]),function(O,n,r,x,M,g,m,v,o){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=n.LegacyLinesDiffComputer=void 0;const a=3;class b{computeDiff(i,l,c){var L;const C=new S(i,l,{maxComputationTime:c.maxComputationTimeMs,shouldIgnoreTrimWhitespace:c.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),N=[];let y=null;for(const R of C.changes){let D;R.originalEndLineNumber===0?D=new o.LineRange(R.originalStartLineNumber+1,R.originalStartLineNumber+1):D=new o.LineRange(R.originalStartLineNumber,R.originalEndLineNumber+1);let T;R.modifiedEndLineNumber===0?T=new o.LineRange(R.modifiedStartLineNumber+1,R.modifiedStartLineNumber+1):T=new o.LineRange(R.modifiedStartLineNumber,R.modifiedEndLineNumber+1);let k=new M.DetailedLineRangeMapping(D,T,(L=R.charChanges)===null||L===void 0?void 0:L.map(q=>new M.RangeMapping(new m.Range(q.originalStartLineNumber,q.originalStartColumn,q.originalEndLineNumber,q.originalEndColumn),new m.Range(q.modifiedStartLineNumber,q.modifiedStartColumn,q.modifiedEndLineNumber,q.modifiedEndColumn))));y&&(y.modified.endLineNumberExclusive===k.modified.startLineNumber||y.original.endLineNumberExclusive===k.original.startLineNumber)&&(k=new M.DetailedLineRangeMapping(y.original.join(k.original),y.modified.join(k.modified),y.innerChanges&&k.innerChanges?y.innerChanges.concat(k.innerChanges):void 0),N.pop()),N.push(k),y=k}return(0,v.assertFn)(()=>(0,v.checkAdjacentItems)(N,(R,D)=>D.original.startLineNumber-R.original.endLineNumberExclusive===D.modified.startLineNumber-R.modified.endLineNumberExclusive&&R.original.endLineNumberExclusive<D.original.startLineNumber&&R.modified.endLineNumberExclusive<D.modified.startLineNumber)),new x.LinesDiff(N,[],C.quitEarly)}}n.LegacyLinesDiffComputer=b;function e(p,i,l,c){return new r.LcsDiff(p,i,l).ComputeDiff(c)}class f{constructor(i){const l=[],c=[];for(let L=0,w=i.length;L<w;L++)l[L]=_(i[L],1),c[L]=E(i[L],1);this.lines=i,this._startColumns=l,this._endColumns=c}getElements(){const i=[];for(let l=0,c=this.lines.length;l<c;l++)i[l]=this.lines[l].substring(this._startColumns[l]-1,this._endColumns[l]-1);return i}getStrictElement(i){return this.lines[i]}getStartLineNumber(i){return i+1}getEndLineNumber(i){return i+1}createCharSequence(i,l,c){const L=[],w=[],C=[];let N=0;for(let y=l;y<=c;y++){const R=this.lines[y],D=i?this._startColumns[y]:1,T=i?this._endColumns[y]:R.length+1;for(let k=D;k<T;k++)L[N]=R.charCodeAt(k-1),w[N]=y+1,C[N]=k,N++;!i&&y<c&&(L[N]=10,w[N]=y+1,C[N]=R.length+1,N++)}return new s(L,w,C)}}class s{constructor(i,l,c){this._charCodes=i,this._lineNumbers=l,this._columns=c}toString(){return"["+this._charCodes.map((i,l)=>(i===10?"\\n":String.fromCharCode(i))+`-(${this._lineNumbers[l]},${this._columns[l]})`).join(", ")+"]"}_assertIndex(i,l){if(i<0||i>=l.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(i){return i>0&&i===this._lineNumbers.length?this.getEndLineNumber(i-1):(this._assertIndex(i,this._lineNumbers),this._lineNumbers[i])}getEndLineNumber(i){return i===-1?this.getStartLineNumber(i+1):(this._assertIndex(i,this._lineNumbers),this._charCodes[i]===10?this._lineNumbers[i]+1:this._lineNumbers[i])}getStartColumn(i){return i>0&&i===this._columns.length?this.getEndColumn(i-1):(this._assertIndex(i,this._columns),this._columns[i])}getEndColumn(i){return i===-1?this.getStartColumn(i+1):(this._assertIndex(i,this._columns),this._charCodes[i]===10?1:this._columns[i]+1)}}class u{constructor(i,l,c,L,w,C,N,y){this.originalStartLineNumber=i,this.originalStartColumn=l,this.originalEndLineNumber=c,this.originalEndColumn=L,this.modifiedStartLineNumber=w,this.modifiedStartColumn=C,this.modifiedEndLineNumber=N,this.modifiedEndColumn=y}static createFromDiffChange(i,l,c){const L=l.getStartLineNumber(i.originalStart),w=l.getStartColumn(i.originalStart),C=l.getEndLineNumber(i.originalStart+i.originalLength-1),N=l.getEndColumn(i.originalStart+i.originalLength-1),y=c.getStartLineNumber(i.modifiedStart),R=c.getStartColumn(i.modifiedStart),D=c.getEndLineNumber(i.modifiedStart+i.modifiedLength-1),T=c.getEndColumn(i.modifiedStart+i.modifiedLength-1);return new u(L,w,C,N,y,R,D,T)}}function d(p){if(p.length<=1)return p;const i=[p[0]];let l=i[0];for(let c=1,L=p.length;c<L;c++){const w=p[c],C=w.originalStart-(l.originalStart+l.originalLength),N=w.modifiedStart-(l.modifiedStart+l.modifiedLength);Math.min(C,N)<a?(l.originalLength=w.originalStart+w.originalLength-l.originalStart,l.modifiedLength=w.modifiedStart+w.modifiedLength-l.modifiedStart):(i.push(w),l=w)}return i}class h{constructor(i,l,c,L,w){this.originalStartLineNumber=i,this.originalEndLineNumber=l,this.modifiedStartLineNumber=c,this.modifiedEndLineNumber=L,this.charChanges=w}static createFromDiffResult(i,l,c,L,w,C,N){let y,R,D,T,k;if(l.originalLength===0?(y=c.getStartLineNumber(l.originalStart)-1,R=0):(y=c.getStartLineNumber(l.originalStart),R=c.getEndLineNumber(l.originalStart+l.originalLength-1)),l.modifiedLength===0?(D=L.getStartLineNumber(l.modifiedStart)-1,T=0):(D=L.getStartLineNumber(l.modifiedStart),T=L.getEndLineNumber(l.modifiedStart+l.modifiedLength-1)),C&&l.originalLength>0&&l.originalLength<20&&l.modifiedLength>0&&l.modifiedLength<20&&w()){const q=c.createCharSequence(i,l.originalStart,l.originalStart+l.originalLength-1),H=L.createCharSequence(i,l.modifiedStart,l.modifiedStart+l.modifiedLength-1);if(q.getElements().length>0&&H.getElements().length>0){let Q=e(q,H,w,!0).changes;N&&(Q=d(Q)),k=[];for(let F=0,I=Q.length;F<I;F++)k.push(u.createFromDiffChange(Q[F],q,H))}}return new h(y,R,D,T,k)}}class S{constructor(i,l,c){this.shouldComputeCharChanges=c.shouldComputeCharChanges,this.shouldPostProcessCharChanges=c.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=c.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=c.shouldMakePrettyDiff,this.originalLines=i,this.modifiedLines=l,this.original=new f(i),this.modified=new f(l),this.continueLineDiff=A(c.maxComputationTime),this.continueCharDiff=A(c.maxComputationTime===0?0:Math.min(c.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const i=e(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),l=i.changes,c=i.quitEarly;if(this.shouldIgnoreTrimWhitespace){const N=[];for(let y=0,R=l.length;y<R;y++)N.push(h.createFromDiffResult(this.shouldIgnoreTrimWhitespace,l[y],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:c,changes:N}}const L=[];let w=0,C=0;for(let N=-1,y=l.length;N<y;N++){const R=N+1<y?l[N+1]:null,D=R?R.originalStart:this.originalLines.length,T=R?R.modifiedStart:this.modifiedLines.length;for(;w<D&&C<T;){const k=this.originalLines[w],q=this.modifiedLines[C];if(k!==q){{let H=_(k,1),Q=_(q,1);for(;H>1&&Q>1;){const F=k.charCodeAt(H-2),I=q.charCodeAt(Q-2);if(F!==I)break;H--,Q--}(H>1||Q>1)&&this._pushTrimWhitespaceCharChange(L,w+1,1,H,C+1,1,Q)}{let H=E(k,1),Q=E(q,1);const F=k.length+1,I=q.length+1;for(;H<F&&Q<I;){const W=k.charCodeAt(H-1),V=k.charCodeAt(Q-1);if(W!==V)break;H++,Q++}(H<F||Q<I)&&this._pushTrimWhitespaceCharChange(L,w+1,H,F,C+1,Q,I)}}w++,C++}R&&(L.push(h.createFromDiffResult(this.shouldIgnoreTrimWhitespace,R,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),w+=R.originalLength,C+=R.modifiedLength)}return{quitEarly:c,changes:L}}_pushTrimWhitespaceCharChange(i,l,c,L,w,C,N){if(this._mergeTrimWhitespaceCharChange(i,l,c,L,w,C,N))return;let y;this.shouldComputeCharChanges&&(y=[new u(l,c,l,L,w,C,w,N)]),i.push(new h(l,l,w,w,y))}_mergeTrimWhitespaceCharChange(i,l,c,L,w,C,N){const y=i.length;if(y===0)return!1;const R=i[y-1];return R.originalEndLineNumber===0||R.modifiedEndLineNumber===0?!1:R.originalEndLineNumber===l&&R.modifiedEndLineNumber===w?(this.shouldComputeCharChanges&&R.charChanges&&R.charChanges.push(new u(l,c,l,L,w,C,w,N)),!0):R.originalEndLineNumber+1===l&&R.modifiedEndLineNumber+1===w?(R.originalEndLineNumber=l,R.modifiedEndLineNumber=w,this.shouldComputeCharChanges&&R.charChanges&&R.charChanges.push(new u(l,c,l,L,w,C,w,N)),!0):!1}}n.DiffComputer=S;function _(p,i){const l=g.firstNonWhitespaceIndex(p);return l===-1?i:l+1}function E(p,i){const l=g.lastNonWhitespaceIndex(p);return l===-1?i:l+2}function A(p){if(p===0)return()=>!0;const i=Date.now();return()=>Date.now()-i<p}}),Y(X[51],Z([0,1,50,49]),function(O,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.linesDiffComputers=void 0,n.linesDiffComputers={getLegacy:()=>new r.LegacyLinesDiffComputer,getDefault:()=>new x.DefaultLinesDiffComputer}}),Y(X[52],Z([0,1,35]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeDefaultDocumentColors=e;function x(f){const s=[];for(const u of f){const d=Number(u);(d||d===0&&u.replace(/\s/g,"")!=="")&&s.push(d)}return s}function M(f,s,u,d){return{red:f/255,blue:u/255,green:s/255,alpha:d}}function g(f,s){const u=s.index,d=s[0].length;if(!u)return;const h=f.positionAt(u);return{startLineNumber:h.lineNumber,startColumn:h.column,endLineNumber:h.lineNumber,endColumn:h.column+d}}function m(f,s){if(!f)return;const u=r.Color.Format.CSS.parseHex(s);if(u)return{range:f,color:M(u.rgba.r,u.rgba.g,u.rgba.b,u.rgba.a)}}function v(f,s,u){if(!f||s.length!==1)return;const h=s[0].values(),S=x(h);return{range:f,color:M(S[0],S[1],S[2],u?S[3]:1)}}function o(f,s,u){if(!f||s.length!==1)return;const h=s[0].values(),S=x(h),_=new r.Color(new r.HSLA(S[0],S[1]/100,S[2]/100,u?S[3]:1));return{range:f,color:M(_.rgba.r,_.rgba.g,_.rgba.b,_.rgba.a)}}function a(f,s){return typeof f=="string"?[...f.matchAll(s)]:f.findMatches(s)}function b(f){const s=[],d=a(f,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(d.length>0)for(const h of d){const S=h.filter(p=>p!==void 0),_=S[1],E=S[2];if(!E)continue;let A;if(_==="rgb"){const p=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;A=v(g(f,h),a(E,p),!1)}else if(_==="rgba"){const p=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;A=v(g(f,h),a(E,p),!0)}else if(_==="hsl"){const p=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;A=o(g(f,h),a(E,p),!1)}else if(_==="hsla"){const p=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;A=o(g(f,h),a(E,p),!0)}else _==="#"&&(A=m(g(f,h),_+E));A&&s.push(A)}return s}function e(f){return!f||typeof f.getValue!="function"||typeof f.positionAt!="function"?[]:b(f)}}),Y(X[53],Z([0,1,29]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkComputer=n.StateMachine=void 0,n.computeLinks=b;class x{constructor(f,s,u){const d=new Uint8Array(f*s);for(let h=0,S=f*s;h<S;h++)d[h]=u;this._data=d,this.rows=f,this.cols=s}get(f,s){return this._data[f*this.cols+s]}set(f,s,u){this._data[f*this.cols+s]=u}}class M{constructor(f){let s=0,u=0;for(let h=0,S=f.length;h<S;h++){const[_,E,A]=f[h];E>s&&(s=E),_>u&&(u=_),A>u&&(u=A)}s++,u++;const d=new x(u,s,0);for(let h=0,S=f.length;h<S;h++){const[_,E,A]=f[h];d.set(_,E,A)}this._states=d,this._maxCharCode=s}nextState(f,s){return s<0||s>=this._maxCharCode?0:this._states.get(f,s)}}n.StateMachine=M;let g=null;function m(){return g===null&&(g=new M([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),g}let v=null;function o(){if(v===null){v=new r.CharacterClassifier(0);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let s=0;s<e.length;s++)v.set(e.charCodeAt(s),1);const f=".,;:";for(let s=0;s<f.length;s++)v.set(f.charCodeAt(s),2)}return v}class a{static _createLink(f,s,u,d,h){let S=h-1;do{const _=s.charCodeAt(S);if(f.get(_)!==2)break;S--}while(S>d);if(d>0){const _=s.charCodeAt(d-1),E=s.charCodeAt(S);(_===40&&E===41||_===91&&E===93||_===123&&E===125)&&S--}return{range:{startLineNumber:u,startColumn:d+1,endLineNumber:u,endColumn:S+2},url:s.substring(d,S+1)}}static computeLinks(f,s=m()){const u=o(),d=[];for(let h=1,S=f.getLineCount();h<=S;h++){const _=f.getLineContent(h),E=_.length;let A=0,p=0,i=0,l=1,c=!1,L=!1,w=!1,C=!1;for(;A<E;){let N=!1;const y=_.charCodeAt(A);if(l===13){let R;switch(y){case 40:c=!0,R=0;break;case 41:R=c?0:1;break;case 91:w=!0,L=!0,R=0;break;case 93:w=!1,R=L?0:1;break;case 123:C=!0,R=0;break;case 125:R=C?0:1;break;case 39:case 34:case 96:i===y?R=1:i===39||i===34||i===96?R=0:R=1;break;case 42:R=i===42?1:0;break;case 124:R=i===124?1:0;break;case 32:R=w?0:1;break;default:R=u.get(y)}R===1&&(d.push(a._createLink(u,_,h,p,A)),N=!0)}else if(l===12){let R;y===91?(L=!0,R=0):R=u.get(y),R===1?N=!0:l=13}else l=s.nextState(l,y),l===0&&(N=!0);N&&(l=1,c=!1,L=!1,C=!1,p=A+1,i=y),A++}l===13&&d.push(a._createLink(u,_,h,p,E))}return d}}n.LinkComputer=a;function b(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:a.computeLinks(e)}}),Y(X[54],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class r{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(M,g,m,v,o){if(M&&g){const a=this.doNavigateValueSet(g,o);if(a)return{range:M,value:a}}if(m&&v){const a=this.doNavigateValueSet(v,o);if(a)return{range:m,value:a}}return null}doNavigateValueSet(M,g){const m=this.numberReplace(M,g);return m!==null?m:this.textReplace(M,g)}numberReplace(M,g){const m=Math.pow(10,M.length-(M.lastIndexOf(".")+1));let v=Number(M);const o=parseFloat(M);return!isNaN(v)&&!isNaN(o)&&v===o?v===0&&!g?null:(v=Math.floor(v*m),v+=g?m:-m,String(v/m)):null}textReplace(M,g){return this.valueSetsReplace(this._defaultValueSet,M,g)}valueSetsReplace(M,g,m){let v=null;for(let o=0,a=M.length;v===null&&o<a;o++)v=this.valueSetReplace(M[o],g,m);return v}valueSetReplace(M,g,m){let v=M.indexOf(g);return v>=0?(v+=m?1:-1,v<0?v=M.length-1:v%=M.length,M[v]):null}}n.BasicInplaceReplace=r,r.INSTANCE=new r}),Y(X[55],Z([0,1,14]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.FindMatch=n.TextModelResolvedOptions=n.InjectedTextCursorStops=n.GlyphMarginLane=n.OverviewRulerLane=void 0,n.isITextSnapshot=o,n.shouldSynchronizeModel=f;var x;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(x||(n.OverviewRulerLane=x={}));var M;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=3]="Right"})(M||(n.GlyphMarginLane=M={}));var g;(function(s){s[s.Both=0]="Both",s[s.Right=1]="Right",s[s.Left=2]="Left",s[s.None=3]="None"})(g||(n.InjectedTextCursorStops=g={}));class m{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(u){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,u.tabSize|0),u.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,u.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!u.insertSpaces,this.defaultEOL=u.defaultEOL|0,this.trimAutoWhitespace=!!u.trimAutoWhitespace,this.bracketPairColorizationOptions=u.bracketPairColorizationOptions}equals(u){return this.tabSize===u.tabSize&&this._indentSizeIsTabSize===u._indentSizeIsTabSize&&this.indentSize===u.indentSize&&this.insertSpaces===u.insertSpaces&&this.defaultEOL===u.defaultEOL&&this.trimAutoWhitespace===u.trimAutoWhitespace&&(0,r.equals)(this.bracketPairColorizationOptions,u.bracketPairColorizationOptions)}createChangeEvent(u){return{tabSize:this.tabSize!==u.tabSize,indentSize:this.indentSize!==u.indentSize,insertSpaces:this.insertSpaces!==u.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==u.trimAutoWhitespace}}}n.TextModelResolvedOptions=m;class v{constructor(u,d){this._findMatchBrand=void 0,this.range=u,this.matches=d}}n.FindMatch=v;function o(s){return s&&typeof s.read=="function"}class a{constructor(u,d,h,S,_,E){this.identifier=u,this.range=d,this.text=h,this.forceMoveMarkers=S,this.isAutoWhitespaceEdit=_,this._isTracked=E}}n.ValidAnnotatedEditOperation=a;class b{constructor(u,d,h){this.regex=u,this.wordSeparators=d,this.simpleSearch=h}}n.SearchData=b;class e{constructor(u,d,h){this.reverseEdits=u,this.changes=d,this.trimAutoWhitespaceLineNumbers=h}}n.ApplyEditsResult=e;function f(s){return!s.isTooLargeForSyncing()&&!s.isForSimpleWidget}}),Y(X[56],Z([0,1,7,28]),function(O,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class M{constructor(o){this.values=o,this.prefixSum=new Uint32Array(o.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(o,a){o=(0,x.toUint32)(o);const b=this.values,e=this.prefixSum,f=a.length;return f===0?!1:(this.values=new Uint32Array(b.length+f),this.values.set(b.subarray(0,o),0),this.values.set(b.subarray(o),o+f),this.values.set(a,o),o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(o,a){return o=(0,x.toUint32)(o),a=(0,x.toUint32)(a),this.values[o]===a?!1:(this.values[o]=a,o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),!0)}removeValues(o,a){o=(0,x.toUint32)(o),a=(0,x.toUint32)(a);const b=this.values,e=this.prefixSum;if(o>=b.length)return!1;const f=b.length-o;return a>=f&&(a=f),a===0?!1:(this.values=new Uint32Array(b.length-a),this.values.set(b.subarray(0,o),0),this.values.set(b.subarray(o+a),o),this.prefixSum=new Uint32Array(this.values.length),o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(o){return o<0?0:(o=(0,x.toUint32)(o),this._getPrefixSum(o))}_getPrefixSum(o){if(o<=this.prefixSumValidIndex[0])return this.prefixSum[o];let a=this.prefixSumValidIndex[0]+1;a===0&&(this.prefixSum[0]=this.values[0],a++),o>=this.values.length&&(o=this.values.length-1);for(let b=a;b<=o;b++)this.prefixSum[b]=this.prefixSum[b-1]+this.values[b];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],o),this.prefixSum[o]}getIndexOf(o){o=Math.floor(o),this.getTotalSum();let a=0,b=this.values.length-1,e=0,f=0,s=0;for(;a<=b;)if(e=a+(b-a)/2|0,f=this.prefixSum[e],s=f-this.values[e],o<s)b=e-1;else if(o>=f)a=e+1;else break;return new m(e,o-s)}}n.PrefixSumComputer=M;class g{constructor(o){this._values=o,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(o){return this._ensureValid(),o===0?0:this._prefixSum[o-1]}getIndexOf(o){this._ensureValid();const a=this._indexBySum[o],b=a>0?this._prefixSum[a-1]:0;return new m(a,o-b)}removeValues(o,a){this._values.splice(o,a),this._invalidate(o)}insertValues(o,a){this._values=(0,r.arrayInsert)(this._values,o,a),this._invalidate(o)}_invalidate(o){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,o-1)}_ensureValid(){if(!this._isValid){for(let o=this._validEndIndex+1,a=this._values.length;o<a;o++){const b=this._values[o],e=o>0?this._prefixSum[o-1]:0;this._prefixSum[o]=e+b;for(let f=0;f<b;f++)this._indexBySum[e+f]=o}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(o,a){this._values[o]!==a&&(this._values[o]=a,this._invalidate(o))}}n.ConstantTimePrefixSumComputer=g;class m{constructor(o,a){this.index=o,this.remainder=a,this._prefixSumIndexOfResultBrand=void 0,this.index=o,this.remainder=a}}n.PrefixSumIndexOfResult=m}),Y(X[57],Z([0,1,6,4,56]),function(O,n,r,x,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class g{constructor(v,o,a,b){this._uri=v,this._lines=o,this._eol=a,this._versionId=b,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(v){v.eol&&v.eol!==this._eol&&(this._eol=v.eol,this._lineStarts=null);const o=v.changes;for(const a of o)this._acceptDeleteRange(a.range),this._acceptInsertText(new x.Position(a.range.startLineNumber,a.range.startColumn),a.text);this._versionId=v.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const v=this._eol.length,o=this._lines.length,a=new Uint32Array(o);for(let b=0;b<o;b++)a[b]=this._lines[b].length+v;this._lineStarts=new M.PrefixSumComputer(a)}}_setLineText(v,o){this._lines[v]=o,this._lineStarts&&this._lineStarts.setValue(v,this._lines[v].length+this._eol.length)}_acceptDeleteRange(v){if(v.startLineNumber===v.endLineNumber){if(v.startColumn===v.endColumn)return;this._setLineText(v.startLineNumber-1,this._lines[v.startLineNumber-1].substring(0,v.startColumn-1)+this._lines[v.startLineNumber-1].substring(v.endColumn-1));return}this._setLineText(v.startLineNumber-1,this._lines[v.startLineNumber-1].substring(0,v.startColumn-1)+this._lines[v.endLineNumber-1].substring(v.endColumn-1)),this._lines.splice(v.startLineNumber,v.endLineNumber-v.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(v.startLineNumber,v.endLineNumber-v.startLineNumber)}_acceptInsertText(v,o){if(o.length===0)return;const a=(0,r.splitLines)(o);if(a.length===1){this._setLineText(v.lineNumber-1,this._lines[v.lineNumber-1].substring(0,v.column-1)+a[0]+this._lines[v.lineNumber-1].substring(v.column-1));return}a[a.length-1]+=this._lines[v.lineNumber-1].substring(v.column-1),this._setLineText(v.lineNumber-1,this._lines[v.lineNumber-1].substring(0,v.column-1)+a[0]);const b=new Uint32Array(a.length-1);for(let e=1;e<a.length;e++)this._lines.splice(v.lineNumber+e-1,0,a[e]),b[e-1]=a[e].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(v.lineNumber,b)}}n.MirrorTextModel=g}),Y(X[58],Z([0,1,6,44,4,2,55]),function(O,n,r,x,M,g,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.TextModelSearch=n.SearchParams=void 0,n.isMultilineRegexSource=a,n.createFindMatch=b,n.isValidMatch=d;const v=999;class o{constructor(_,E,A,p){this.searchString=_,this.isRegex=E,this.matchCase=A,this.wordSeparators=p}parseSearchRequest(){if(this.searchString==="")return null;let _;this.isRegex?_=a(this.searchString):_=this.searchString.indexOf(`
`)>=0;let E=null;try{E=r.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:_,global:!0,unicode:!0})}catch{return null}if(!E)return null;let A=!this.isRegex&&!_;return A&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(A=this.matchCase),new m.SearchData(E,this.wordSeparators?(0,x.getMapForWordSeparators)(this.wordSeparators,[]):null,A?this.searchString:null)}}n.SearchParams=o;function a(S){if(!S||S.length===0)return!1;for(let _=0,E=S.length;_<E;_++){const A=S.charCodeAt(_);if(A===10)return!0;if(A===92){if(_++,_>=E)break;const p=S.charCodeAt(_);if(p===110||p===114||p===87)return!0}}return!1}function b(S,_,E){if(!E)return new m.FindMatch(S,null);const A=[];for(let p=0,i=_.length;p<i;p++)A[p]=_[p];return new m.FindMatch(S,A)}class e{constructor(_){const E=[];let A=0;for(let p=0,i=_.length;p<i;p++)_.charCodeAt(p)===10&&(E[A++]=p);this._lineFeedsOffsets=E}findLineFeedCountBeforeOffset(_){const E=this._lineFeedsOffsets;let A=0,p=E.length-1;if(p===-1||_<=E[0])return 0;for(;A<p;){const i=A+((p-A)/2>>0);E[i]>=_?p=i-1:E[i+1]>=_?(A=i,p=i):A=i+1}return A+1}}class f{static findMatches(_,E,A,p,i){const l=E.parseSearchRequest();return l?l.regex.multiline?this._doFindMatchesMultiline(_,A,new h(l.wordSeparators,l.regex),p,i):this._doFindMatchesLineByLine(_,A,l,p,i):[]}static _getMultilineMatchRange(_,E,A,p,i,l){let c,L=0;p?(L=p.findLineFeedCountBeforeOffset(i),c=E+i+L):c=E+i;let w;if(p){const R=p.findLineFeedCountBeforeOffset(i+l.length)-L;w=c+l.length+R}else w=c+l.length;const C=_.getPositionAt(c),N=_.getPositionAt(w);return new g.Range(C.lineNumber,C.column,N.lineNumber,N.column)}static _doFindMatchesMultiline(_,E,A,p,i){const l=_.getOffsetAt(E.getStartPosition()),c=_.getValueInRange(E,1),L=_.getEOL()===`\r
`?new e(c):null,w=[];let C=0,N;for(A.reset(0);N=A.next(c);)if(w[C++]=b(this._getMultilineMatchRange(_,l,c,L,N.index,N[0]),N,p),C>=i)return w;return w}static _doFindMatchesLineByLine(_,E,A,p,i){const l=[];let c=0;if(E.startLineNumber===E.endLineNumber){const w=_.getLineContent(E.startLineNumber).substring(E.startColumn-1,E.endColumn-1);return c=this._findMatchesInLine(A,w,E.startLineNumber,E.startColumn-1,c,l,p,i),l}const L=_.getLineContent(E.startLineNumber).substring(E.startColumn-1);c=this._findMatchesInLine(A,L,E.startLineNumber,E.startColumn-1,c,l,p,i);for(let w=E.startLineNumber+1;w<E.endLineNumber&&c<i;w++)c=this._findMatchesInLine(A,_.getLineContent(w),w,0,c,l,p,i);if(c<i){const w=_.getLineContent(E.endLineNumber).substring(0,E.endColumn-1);c=this._findMatchesInLine(A,w,E.endLineNumber,0,c,l,p,i)}return l}static _findMatchesInLine(_,E,A,p,i,l,c,L){const w=_.wordSeparators;if(!c&&_.simpleSearch){const y=_.simpleSearch,R=y.length,D=E.length;let T=-R;for(;(T=E.indexOf(y,T+R))!==-1;)if((!w||d(w,E,D,T,R))&&(l[i++]=new m.FindMatch(new g.Range(A,T+1+p,A,T+1+R+p),null),i>=L))return i;return i}const C=new h(_.wordSeparators,_.regex);let N;C.reset(0);do if(N=C.next(E),N&&(l[i++]=b(new g.Range(A,N.index+1+p,A,N.index+1+N[0].length+p),N,c),i>=L))return i;while(N);return i}static findNextMatch(_,E,A,p){const i=E.parseSearchRequest();if(!i)return null;const l=new h(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(_,A,l,p):this._doFindNextMatchLineByLine(_,A,l,p)}static _doFindNextMatchMultiline(_,E,A,p){const i=new M.Position(E.lineNumber,1),l=_.getOffsetAt(i),c=_.getLineCount(),L=_.getValueInRange(new g.Range(i.lineNumber,i.column,c,_.getLineMaxColumn(c)),1),w=_.getEOL()===`\r
`?new e(L):null;A.reset(E.column-1);const C=A.next(L);return C?b(this._getMultilineMatchRange(_,l,L,w,C.index,C[0]),C,p):E.lineNumber!==1||E.column!==1?this._doFindNextMatchMultiline(_,new M.Position(1,1),A,p):null}static _doFindNextMatchLineByLine(_,E,A,p){const i=_.getLineCount(),l=E.lineNumber,c=_.getLineContent(l),L=this._findFirstMatchInLine(A,c,l,E.column,p);if(L)return L;for(let w=1;w<=i;w++){const C=(l+w-1)%i,N=_.getLineContent(C+1),y=this._findFirstMatchInLine(A,N,C+1,1,p);if(y)return y}return null}static _findFirstMatchInLine(_,E,A,p,i){_.reset(p-1);const l=_.next(E);return l?b(new g.Range(A,l.index+1,A,l.index+1+l[0].length),l,i):null}static findPreviousMatch(_,E,A,p){const i=E.parseSearchRequest();if(!i)return null;const l=new h(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(_,A,l,p):this._doFindPreviousMatchLineByLine(_,A,l,p)}static _doFindPreviousMatchMultiline(_,E,A,p){const i=this._doFindMatchesMultiline(_,new g.Range(1,1,E.lineNumber,E.column),A,p,10*v);if(i.length>0)return i[i.length-1];const l=_.getLineCount();return E.lineNumber!==l||E.column!==_.getLineMaxColumn(l)?this._doFindPreviousMatchMultiline(_,new M.Position(l,_.getLineMaxColumn(l)),A,p):null}static _doFindPreviousMatchLineByLine(_,E,A,p){const i=_.getLineCount(),l=E.lineNumber,c=_.getLineContent(l).substring(0,E.column-1),L=this._findLastMatchInLine(A,c,l,p);if(L)return L;for(let w=1;w<=i;w++){const C=(i+l-w-1)%i,N=_.getLineContent(C+1),y=this._findLastMatchInLine(A,N,C+1,p);if(y)return y}return null}static _findLastMatchInLine(_,E,A,p){let i=null,l;for(_.reset(0);l=_.next(E);)i=b(new g.Range(A,l.index+1,A,l.index+1+l[0].length),l,p);return i}}n.TextModelSearch=f;function s(S,_,E,A,p){if(A===0)return!0;const i=_.charCodeAt(A-1);if(S.get(i)!==0||i===13||i===10)return!0;if(p>0){const l=_.charCodeAt(A);if(S.get(l)!==0)return!0}return!1}function u(S,_,E,A,p){if(A+p===E)return!0;const i=_.charCodeAt(A+p);if(S.get(i)!==0||i===13||i===10)return!0;if(p>0){const l=_.charCodeAt(A+p-1);if(S.get(l)!==0)return!0}return!1}function d(S,_,E,A,p){return s(S,_,E,A,p)&&u(S,_,E,A,p)}class h{constructor(_,E){this._wordSeparators=_,this._searchRegex=E,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(_){this._searchRegex.lastIndex=_,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(_){const E=_.length;let A;do{if(this._prevMatchStartIndex+this._prevMatchLength===E||(A=this._searchRegex.exec(_),!A))return null;const p=A.index,i=A[0].length;if(p===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){r.getNextCodePoint(_,E,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=p,this._prevMatchLength=i,!this._wordSeparators||d(this._wordSeparators,_,E,p,i))return A}while(A);return null}}n.Searcher=h}),Y(X[59],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.findSectionHeaders=M;const r=/\bMARK:\s*(.*)$/d,x=/^-+|-+$/g;function M(a,b){var e;let f=[];if(b.findRegionSectionHeaders&&(!((e=b.foldingRules)===null||e===void 0)&&e.markers)){const s=g(a,b);f=f.concat(s)}if(b.findMarkSectionHeaders){const s=m(a);f=f.concat(s)}return f}function g(a,b){const e=[],f=a.getLineCount();for(let s=1;s<=f;s++){const u=a.getLineContent(s),d=u.match(b.foldingRules.markers.start);if(d){const h={startLineNumber:s,startColumn:d[0].length+1,endLineNumber:s,endColumn:u.length+1};if(h.endColumn>h.startColumn){const S={range:h,...o(u.substring(d[0].length)),shouldBeInComments:!1};(S.text||S.hasSeparatorLine)&&e.push(S)}}}return e}function m(a){const b=[],e=a.getLineCount();for(let f=1;f<=e;f++){const s=a.getLineContent(f);v(s,f,b)}return b}function v(a,b,e){r.lastIndex=0;const f=r.exec(a);if(f){const s=f.indices[1][0]+1,u=f.indices[1][1]+1,d={startLineNumber:b,startColumn:s,endLineNumber:b,endColumn:u};if(d.endColumn>d.startColumn){const h={range:d,...o(f[1]),shouldBeInComments:!0};(h.text||h.hasSeparatorLine)&&e.push(h)}}}function o(a){a=a.trim();const b=a.startsWith("-");return a=a.replace(x,""),{text:a,hasSeparatorLine:b}}}),Y(X[60],Z([0,1,2,58,6,12,30]),function(O,n,r,x,M,g,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeTextModelHighlighter=void 0;class v{static computeUnicodeHighlights(f,s,u){const d=u?u.startLineNumber:1,h=u?u.endLineNumber:f.getLineCount(),S=new a(s),_=S.getCandidateCodePoints();let E;_==="allNonBasicAscii"?E=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):E=new RegExp(`${o(Array.from(_))}`,"g");const A=new x.Searcher(null,E),p=[];let i=!1,l,c=0,L=0,w=0;e:for(let C=d,N=h;C<=N;C++){const y=f.getLineContent(C),R=y.length;A.reset(0);do if(l=A.next(y),l){let D=l.index,T=l.index+l[0].length;if(D>0){const Q=y.charCodeAt(D-1);M.isHighSurrogate(Q)&&D--}if(T+1<R){const Q=y.charCodeAt(T-1);M.isHighSurrogate(Q)&&T++}const k=y.substring(D,T);let q=(0,m.getWordAtText)(D+1,m.DEFAULT_WORD_REGEXP,y,0);q&&q.endColumn<=D+1&&(q=null);const H=S.shouldHighlightNonBasicASCII(k,q?q.word:null);if(H!==0){if(H===3?c++:H===2?L++:H===1?w++:(0,g.assertNever)(H),p.length>=1e3){i=!0;break e}p.push(new r.Range(C,D+1,C,T+1))}}while(l)}return{ranges:p,hasMore:i,ambiguousCharacterCount:c,invisibleCharacterCount:L,nonBasicAsciiCharacterCount:w}}static computeUnicodeHighlightReason(f,s){const u=new a(s);switch(u.shouldHighlightNonBasicASCII(f,null)){case 0:return null;case 2:return{kind:1};case 3:{const h=f.codePointAt(0),S=u.ambiguousCharacters.getPrimaryConfusable(h),_=M.AmbiguousCharacters.getLocales().filter(E=>!M.AmbiguousCharacters.getInstance(new Set([...s.allowedLocales,E])).isAmbiguous(h));return{kind:0,confusableWith:String.fromCodePoint(S),notAmbiguousInLocales:_}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=v;function o(e,f){return`[${M.escapeRegExpCharacters(e.map(u=>String.fromCodePoint(u)).join(""))}]`}class a{constructor(f){this.options=f,this.allowedCodePoints=new Set(f.allowedCodePoints),this.ambiguousCharacters=M.AmbiguousCharacters.getInstance(new Set(f.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const f=new Set;if(this.options.invisibleCharacters)for(const s of M.InvisibleCharacters.codePoints)b(String.fromCodePoint(s))||f.add(s);if(this.options.ambiguousCharacters)for(const s of this.ambiguousCharacters.getConfusableCodePoints())f.add(s);for(const s of this.allowedCodePoints)f.delete(s);return f}shouldHighlightNonBasicASCII(f,s){const u=f.codePointAt(0);if(this.allowedCodePoints.has(u))return 0;if(this.options.nonBasicASCII)return 1;let d=!1,h=!1;if(s)for(const S of s){const _=S.codePointAt(0),E=M.isBasicASCII(S);d=d||E,!E&&!this.ambiguousCharacters.isAmbiguous(_)&&!M.InvisibleCharacters.isInvisibleCharacter(_)&&(h=!0)}return!d&&h?0:this.options.invisibleCharacters&&!b(f)&&M.InvisibleCharacters.isInvisibleCharacter(u)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(u)?3:0}}function b(e){return e===" "||e===`
`||e==="	"}}),Y(X[61],Z([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.ShowLightbulbIconMode=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.PartialAcceptTriggerKind=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.NewSymbolNameTag=n.MouseTargetType=n.MinimapSectionHeaderStyle=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineEditTriggerKind=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.HoverVerbosityAction=n.GlyphMarginLane=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.CodeActionTriggerType=n.AccessibilitySupport=void 0;var r;(function(t){t[t.Unknown=0]="Unknown",t[t.Disabled=1]="Disabled",t[t.Enabled=2]="Enabled"})(r||(n.AccessibilitySupport=r={}));var x;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(x||(n.CodeActionTriggerType=x={}));var M;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(M||(n.CompletionItemInsertTextRule=M={}));var g;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(g||(n.CompletionItemKind=g={}));var m;(function(t){t[t.Deprecated=1]="Deprecated"})(m||(n.CompletionItemTag=m={}));var v;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v||(n.CompletionTriggerKind=v={}));var o;(function(t){t[t.EXACT=0]="EXACT",t[t.ABOVE=1]="ABOVE",t[t.BELOW=2]="BELOW"})(o||(n.ContentWidgetPositionPreference=o={}));var a;(function(t){t[t.NotSet=0]="NotSet",t[t.ContentFlush=1]="ContentFlush",t[t.RecoverFromMarkers=2]="RecoverFromMarkers",t[t.Explicit=3]="Explicit",t[t.Paste=4]="Paste",t[t.Undo=5]="Undo",t[t.Redo=6]="Redo"})(a||(n.CursorChangeReason=a={}));var b;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(b||(n.DefaultEndOfLine=b={}));var e;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(e||(n.DocumentHighlightKind=e={}));var f;(function(t){t[t.None=0]="None",t[t.Keep=1]="Keep",t[t.Brackets=2]="Brackets",t[t.Advanced=3]="Advanced",t[t.Full=4]="Full"})(f||(n.EditorAutoIndentStrategy=f={}));var s;(function(t){t[t.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",t[t.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",t[t.accessibilitySupport=2]="accessibilitySupport",t[t.accessibilityPageSize=3]="accessibilityPageSize",t[t.ariaLabel=4]="ariaLabel",t[t.ariaRequired=5]="ariaRequired",t[t.autoClosingBrackets=6]="autoClosingBrackets",t[t.autoClosingComments=7]="autoClosingComments",t[t.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",t[t.autoClosingDelete=9]="autoClosingDelete",t[t.autoClosingOvertype=10]="autoClosingOvertype",t[t.autoClosingQuotes=11]="autoClosingQuotes",t[t.autoIndent=12]="autoIndent",t[t.automaticLayout=13]="automaticLayout",t[t.autoSurround=14]="autoSurround",t[t.bracketPairColorization=15]="bracketPairColorization",t[t.guides=16]="guides",t[t.codeLens=17]="codeLens",t[t.codeLensFontFamily=18]="codeLensFontFamily",t[t.codeLensFontSize=19]="codeLensFontSize",t[t.colorDecorators=20]="colorDecorators",t[t.colorDecoratorsLimit=21]="colorDecoratorsLimit",t[t.columnSelection=22]="columnSelection",t[t.comments=23]="comments",t[t.contextmenu=24]="contextmenu",t[t.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",t[t.cursorBlinking=26]="cursorBlinking",t[t.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",t[t.cursorStyle=28]="cursorStyle",t[t.cursorSurroundingLines=29]="cursorSurroundingLines",t[t.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",t[t.cursorWidth=31]="cursorWidth",t[t.disableLayerHinting=32]="disableLayerHinting",t[t.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",t[t.domReadOnly=34]="domReadOnly",t[t.dragAndDrop=35]="dragAndDrop",t[t.dropIntoEditor=36]="dropIntoEditor",t[t.emptySelectionClipboard=37]="emptySelectionClipboard",t[t.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",t[t.extraEditorClassName=39]="extraEditorClassName",t[t.fastScrollSensitivity=40]="fastScrollSensitivity",t[t.find=41]="find",t[t.fixedOverflowWidgets=42]="fixedOverflowWidgets",t[t.folding=43]="folding",t[t.foldingStrategy=44]="foldingStrategy",t[t.foldingHighlight=45]="foldingHighlight",t[t.foldingImportsByDefault=46]="foldingImportsByDefault",t[t.foldingMaximumRegions=47]="foldingMaximumRegions",t[t.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",t[t.fontFamily=49]="fontFamily",t[t.fontInfo=50]="fontInfo",t[t.fontLigatures=51]="fontLigatures",t[t.fontSize=52]="fontSize",t[t.fontWeight=53]="fontWeight",t[t.fontVariations=54]="fontVariations",t[t.formatOnPaste=55]="formatOnPaste",t[t.formatOnType=56]="formatOnType",t[t.glyphMargin=57]="glyphMargin",t[t.gotoLocation=58]="gotoLocation",t[t.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",t[t.hover=60]="hover",t[t.inDiffEditor=61]="inDiffEditor",t[t.inlineSuggest=62]="inlineSuggest",t[t.inlineEdit=63]="inlineEdit",t[t.letterSpacing=64]="letterSpacing",t[t.lightbulb=65]="lightbulb",t[t.lineDecorationsWidth=66]="lineDecorationsWidth",t[t.lineHeight=67]="lineHeight",t[t.lineNumbers=68]="lineNumbers",t[t.lineNumbersMinChars=69]="lineNumbersMinChars",t[t.linkedEditing=70]="linkedEditing",t[t.links=71]="links",t[t.matchBrackets=72]="matchBrackets",t[t.minimap=73]="minimap",t[t.mouseStyle=74]="mouseStyle",t[t.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",t[t.mouseWheelZoom=76]="mouseWheelZoom",t[t.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",t[t.multiCursorModifier=78]="multiCursorModifier",t[t.multiCursorPaste=79]="multiCursorPaste",t[t.multiCursorLimit=80]="multiCursorLimit",t[t.occurrencesHighlight=81]="occurrencesHighlight",t[t.overviewRulerBorder=82]="overviewRulerBorder",t[t.overviewRulerLanes=83]="overviewRulerLanes",t[t.padding=84]="padding",t[t.pasteAs=85]="pasteAs",t[t.parameterHints=86]="parameterHints",t[t.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",t[t.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",t[t.quickSuggestions=89]="quickSuggestions",t[t.quickSuggestionsDelay=90]="quickSuggestionsDelay",t[t.readOnly=91]="readOnly",t[t.readOnlyMessage=92]="readOnlyMessage",t[t.renameOnType=93]="renameOnType",t[t.renderControlCharacters=94]="renderControlCharacters",t[t.renderFinalNewline=95]="renderFinalNewline",t[t.renderLineHighlight=96]="renderLineHighlight",t[t.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",t[t.renderValidationDecorations=98]="renderValidationDecorations",t[t.renderWhitespace=99]="renderWhitespace",t[t.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",t[t.roundedSelection=101]="roundedSelection",t[t.rulers=102]="rulers",t[t.scrollbar=103]="scrollbar",t[t.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",t[t.scrollBeyondLastLine=105]="scrollBeyondLastLine",t[t.scrollPredominantAxis=106]="scrollPredominantAxis",t[t.selectionClipboard=107]="selectionClipboard",t[t.selectionHighlight=108]="selectionHighlight",t[t.selectOnLineNumbers=109]="selectOnLineNumbers",t[t.showFoldingControls=110]="showFoldingControls",t[t.showUnused=111]="showUnused",t[t.snippetSuggestions=112]="snippetSuggestions",t[t.smartSelect=113]="smartSelect",t[t.smoothScrolling=114]="smoothScrolling",t[t.stickyScroll=115]="stickyScroll",t[t.stickyTabStops=116]="stickyTabStops",t[t.stopRenderingLineAfter=117]="stopRenderingLineAfter",t[t.suggest=118]="suggest",t[t.suggestFontSize=119]="suggestFontSize",t[t.suggestLineHeight=120]="suggestLineHeight",t[t.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",t[t.suggestSelection=122]="suggestSelection",t[t.tabCompletion=123]="tabCompletion",t[t.tabIndex=124]="tabIndex",t[t.unicodeHighlighting=125]="unicodeHighlighting",t[t.unusualLineTerminators=126]="unusualLineTerminators",t[t.useShadowDOM=127]="useShadowDOM",t[t.useTabStops=128]="useTabStops",t[t.wordBreak=129]="wordBreak",t[t.wordSegmenterLocales=130]="wordSegmenterLocales",t[t.wordSeparators=131]="wordSeparators",t[t.wordWrap=132]="wordWrap",t[t.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",t[t.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",t[t.wordWrapColumn=135]="wordWrapColumn",t[t.wordWrapOverride1=136]="wordWrapOverride1",t[t.wordWrapOverride2=137]="wordWrapOverride2",t[t.wrappingIndent=138]="wrappingIndent",t[t.wrappingStrategy=139]="wrappingStrategy",t[t.showDeprecated=140]="showDeprecated",t[t.inlayHints=141]="inlayHints",t[t.editorClassName=142]="editorClassName",t[t.pixelRatio=143]="pixelRatio",t[t.tabFocusMode=144]="tabFocusMode",t[t.layoutInfo=145]="layoutInfo",t[t.wrappingInfo=146]="wrappingInfo",t[t.defaultColorDecorators=147]="defaultColorDecorators",t[t.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",t[t.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(s||(n.EditorOption=s={}));var u;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(u||(n.EndOfLinePreference=u={}));var d;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(d||(n.EndOfLineSequence=d={}));var h;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=3]="Right"})(h||(n.GlyphMarginLane=h={}));var S;(function(t){t[t.Increase=0]="Increase",t[t.Decrease=1]="Decrease"})(S||(n.HoverVerbosityAction=S={}));var _;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(_||(n.IndentAction=_={}));var E;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(E||(n.InjectedTextCursorStops=E={}));var A;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(A||(n.InlayHintKind=A={}));var p;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(p||(n.InlineCompletionTriggerKind=p={}));var i;(function(t){t[t.Invoke=0]="Invoke",t[t.Automatic=1]="Automatic"})(i||(n.InlineEditTriggerKind=i={}));var l;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.F20=78]="F20",t[t.F21=79]="F21",t[t.F22=80]="F22",t[t.F23=81]="F23",t[t.F24=82]="F24",t[t.NumLock=83]="NumLock",t[t.ScrollLock=84]="ScrollLock",t[t.Semicolon=85]="Semicolon",t[t.Equal=86]="Equal",t[t.Comma=87]="Comma",t[t.Minus=88]="Minus",t[t.Period=89]="Period",t[t.Slash=90]="Slash",t[t.Backquote=91]="Backquote",t[t.BracketLeft=92]="BracketLeft",t[t.Backslash=93]="Backslash",t[t.BracketRight=94]="BracketRight",t[t.Quote=95]="Quote",t[t.OEM_8=96]="OEM_8",t[t.IntlBackslash=97]="IntlBackslash",t[t.Numpad0=98]="Numpad0",t[t.Numpad1=99]="Numpad1",t[t.Numpad2=100]="Numpad2",t[t.Numpad3=101]="Numpad3",t[t.Numpad4=102]="Numpad4",t[t.Numpad5=103]="Numpad5",t[t.Numpad6=104]="Numpad6",t[t.Numpad7=105]="Numpad7",t[t.Numpad8=106]="Numpad8",t[t.Numpad9=107]="Numpad9",t[t.NumpadMultiply=108]="NumpadMultiply",t[t.NumpadAdd=109]="NumpadAdd",t[t.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=111]="NumpadSubtract",t[t.NumpadDecimal=112]="NumpadDecimal",t[t.NumpadDivide=113]="NumpadDivide",t[t.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",t[t.ABNT_C1=115]="ABNT_C1",t[t.ABNT_C2=116]="ABNT_C2",t[t.AudioVolumeMute=117]="AudioVolumeMute",t[t.AudioVolumeUp=118]="AudioVolumeUp",t[t.AudioVolumeDown=119]="AudioVolumeDown",t[t.BrowserSearch=120]="BrowserSearch",t[t.BrowserHome=121]="BrowserHome",t[t.BrowserBack=122]="BrowserBack",t[t.BrowserForward=123]="BrowserForward",t[t.MediaTrackNext=124]="MediaTrackNext",t[t.MediaTrackPrevious=125]="MediaTrackPrevious",t[t.MediaStop=126]="MediaStop",t[t.MediaPlayPause=127]="MediaPlayPause",t[t.LaunchMediaPlayer=128]="LaunchMediaPlayer",t[t.LaunchMail=129]="LaunchMail",t[t.LaunchApp2=130]="LaunchApp2",t[t.Clear=131]="Clear",t[t.MAX_VALUE=132]="MAX_VALUE"})(l||(n.KeyCode=l={}));var c;(function(t){t[t.Hint=1]="Hint",t[t.Info=2]="Info",t[t.Warning=4]="Warning",t[t.Error=8]="Error"})(c||(n.MarkerSeverity=c={}));var L;(function(t){t[t.Unnecessary=1]="Unnecessary",t[t.Deprecated=2]="Deprecated"})(L||(n.MarkerTag=L={}));var w;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(w||(n.MinimapPosition=w={}));var C;(function(t){t[t.Normal=1]="Normal",t[t.Underlined=2]="Underlined"})(C||(n.MinimapSectionHeaderStyle=C={}));var N;(function(t){t[t.UNKNOWN=0]="UNKNOWN",t[t.TEXTAREA=1]="TEXTAREA",t[t.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",t[t.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",t[t.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",t[t.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",t[t.CONTENT_TEXT=6]="CONTENT_TEXT",t[t.CONTENT_EMPTY=7]="CONTENT_EMPTY",t[t.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",t[t.CONTENT_WIDGET=9]="CONTENT_WIDGET",t[t.OVERVIEW_RULER=10]="OVERVIEW_RULER",t[t.SCROLLBAR=11]="SCROLLBAR",t[t.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",t[t.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(N||(n.MouseTargetType=N={}));var y;(function(t){t[t.AIGenerated=1]="AIGenerated"})(y||(n.NewSymbolNameTag=y={}));var R;(function(t){t[t.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",t[t.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",t[t.TOP_CENTER=2]="TOP_CENTER"})(R||(n.OverlayWidgetPositionPreference=R={}));var D;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(D||(n.OverviewRulerLane=D={}));var T;(function(t){t[t.Word=0]="Word",t[t.Line=1]="Line",t[t.Suggest=2]="Suggest"})(T||(n.PartialAcceptTriggerKind=T={}));var k;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(k||(n.PositionAffinity=k={}));var q;(function(t){t[t.Off=0]="Off",t[t.On=1]="On",t[t.Relative=2]="Relative",t[t.Interval=3]="Interval",t[t.Custom=4]="Custom"})(q||(n.RenderLineNumbersType=q={}));var H;(function(t){t[t.None=0]="None",t[t.Text=1]="Text",t[t.Blocks=2]="Blocks"})(H||(n.RenderMinimap=H={}));var Q;(function(t){t[t.Smooth=0]="Smooth",t[t.Immediate=1]="Immediate"})(Q||(n.ScrollType=Q={}));var F;(function(t){t[t.Auto=1]="Auto",t[t.Hidden=2]="Hidden",t[t.Visible=3]="Visible"})(F||(n.ScrollbarVisibility=F={}));var I;(function(t){t[t.LTR=0]="LTR",t[t.RTL=1]="RTL"})(I||(n.SelectionDirection=I={}));var W;(function(t){t.Off="off",t.OnCode="onCode",t.On="on"})(W||(n.ShowLightbulbIconMode=W={}));var V;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(V||(n.SignatureHelpTriggerKind=V={}));var z;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(z||(n.SymbolKind=z={}));var U;(function(t){t[t.Deprecated=1]="Deprecated"})(U||(n.SymbolTag=U={}));var se;(function(t){t[t.Hidden=0]="Hidden",t[t.Blink=1]="Blink",t[t.Smooth=2]="Smooth",t[t.Phase=3]="Phase",t[t.Expand=4]="Expand",t[t.Solid=5]="Solid"})(se||(n.TextEditorCursorBlinkingStyle=se={}));var he;(function(t){t[t.Line=1]="Line",t[t.Block=2]="Block",t[t.Underline=3]="Underline",t[t.LineThin=4]="LineThin",t[t.BlockOutline=5]="BlockOutline",t[t.UnderlineThin=6]="UnderlineThin"})(he||(n.TextEditorCursorStyle=he={}));var de;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(de||(n.TrackedRangeStickiness=de={}));var me;(function(t){t[t.None=0]="None",t[t.Same=1]="Same",t[t.Indent=2]="Indent",t[t.DeepIndent=3]="DeepIndent"})(me||(n.WrappingIndent=me={}))}),Y(X[62],Z([0,1,9,13]),function(O,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class M{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new r.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(v){this._onDidChange.fire({changedLanguages:v,changedColorMap:!1})}register(v,o){return this._tokenizationSupports.set(v,o),this.handleChange([v]),(0,x.toDisposable)(()=>{this._tokenizationSupports.get(v)===o&&(this._tokenizationSupports.delete(v),this.handleChange([v]))})}get(v){return this._tokenizationSupports.get(v)||null}registerFactory(v,o){var a;(a=this._factories.get(v))===null||a===void 0||a.dispose();const b=new g(this,v,o);return this._factories.set(v,b),(0,x.toDisposable)(()=>{const e=this._factories.get(v);!e||e!==b||(this._factories.delete(v),e.dispose())})}async getOrCreate(v){const o=this.get(v);if(o)return o;const a=this._factories.get(v);return!a||a.isResolved?null:(await a.resolve(),this.get(v))}isResolved(v){if(this.get(v))return!0;const a=this._factories.get(v);return!!(!a||a.isResolved)}setColorMap(v){this._colorMap=v,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}n.TokenizationRegistry=M;class g extends x.Disposable{get isResolved(){return this._isResolved}constructor(v,o,a){super(),this._registry=v,this._languageId=o,this._factory=a,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const v=await this._factory.tokenizationSupport;this._isResolved=!0,v&&!this._isDisposed&&this._register(this._registry.register(this._languageId,v))}}}),Y(X[63],Z([19,64]),function(O,n){return O.create("vs/base/common/platform",n)}),Y(X[17],Z([0,1,63]),function(O,n,r){"use strict";var x,M;Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.OS=n.setTimeout0=n.setTimeout0IsFaster=n.language=n.userAgent=n.isMobile=n.isIOS=n.webWorkerOrigin=n.isWebWorker=n.isWeb=n.isNative=n.isLinux=n.isMacintosh=n.isWindows=n.LANGUAGE_DEFAULT=void 0,n.isLittleEndian=C,n.LANGUAGE_DEFAULT="en";let g=!1,m=!1,v=!1,o=!1,a=!1,b=!1,e=!1,f=!1,s=!1,u=!1,d,h=n.LANGUAGE_DEFAULT,S=n.LANGUAGE_DEFAULT,_,E;const A=globalThis;let p;typeof A.vscode<"u"&&typeof A.vscode.process<"u"?p=A.vscode.process:typeof process<"u"&&typeof((x=process==null?void 0:process.versions)===null||x===void 0?void 0:x.node)=="string"&&(p=process);const i=typeof((M=p?.versions)===null||M===void 0?void 0:M.electron)=="string",l=i&&p?.type==="renderer";if(typeof p=="object"){g=p.platform==="win32",m=p.platform==="darwin",v=p.platform==="linux",o=v&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,e=i,s=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=n.LANGUAGE_DEFAULT,h=n.LANGUAGE_DEFAULT;const N=p.env.VSCODE_NLS_CONFIG;if(N)try{const y=JSON.parse(N),R=y.availableLanguages["*"];d=y.locale,S=y.osLocale,h=R||n.LANGUAGE_DEFAULT,_=y._translationsConfigFile}catch{}a=!0}else typeof navigator=="object"&&!l?(E=navigator.userAgent,g=E.indexOf("Windows")>=0,m=E.indexOf("Macintosh")>=0,f=(E.indexOf("Macintosh")>=0||E.indexOf("iPad")>=0||E.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,v=E.indexOf("Linux")>=0,u=E?.indexOf("Mobi")>=0,b=!0,d=r.getConfiguredDefaultLocale(r.localize(0,null))||n.LANGUAGE_DEFAULT,h=d,S=navigator.language):console.error("Unable to resolve platform.");let c=0;m?c=1:g?c=3:v&&(c=2),n.isWindows=g,n.isMacintosh=m,n.isLinux=v,n.isNative=a,n.isWeb=b,n.isWebWorker=b&&typeof A.importScripts=="function",n.webWorkerOrigin=n.isWebWorker?A.origin:void 0,n.isIOS=f,n.isMobile=u,n.userAgent=E,n.language=h,n.setTimeout0IsFaster=typeof A.postMessage=="function"&&!A.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){const N=[];A.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let D=0,T=N.length;D<T;D++){const k=N[D];if(k.id===R.data.vscodeScheduleAsyncWork){N.splice(D,1),k.callback();return}}});let y=0;return R=>{const D=++y;N.push({id:D,callback:R}),A.postMessage({vscodeScheduleAsyncWork:D},"*")}}return N=>setTimeout(N)})(),n.OS=m||f?2:g?1:3;let L=!0,w=!1;function C(){if(!w){w=!0;const N=new Uint8Array(2);N[0]=1,N[1]=2,L=new Uint16Array(N.buffer)[0]===513}return L}n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),Y(X[65],Z([0,1,17]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.platform=n.env=n.cwd=void 0;let x;const M=globalThis.vscode;if(typeof M<"u"&&typeof M.process<"u"){const g=M.process;x={get platform(){return g.platform},get arch(){return g.arch},get env(){return g.env},cwd(){return g.cwd()}}}else typeof process<"u"?x={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:x={get platform(){return r.isWindows?"win32":r.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=x.cwd,n.env=x.env,n.platform=x.platform}),Y(X[66],Z([0,1,65]),function(O,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sep=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.normalize=n.posix=n.win32=void 0;const x=65,M=97,g=90,m=122,v=46,o=47,a=92,b=58,e=63;class f extends Error{constructor(l,c,L){let w;typeof c=="string"&&c.indexOf("not ")===0?(w="must not be",c=c.replace(/^not /,"")):w="must be";const C=l.indexOf(".")!==-1?"property":"argument";let N=`The "${l}" ${C} ${w} of type ${c}`;N+=`. Received type ${typeof L}`,super(N),this.code="ERR_INVALID_ARG_TYPE"}}function s(i,l){if(i===null||typeof i!="object")throw new f(l,"Object",i)}function u(i,l){if(typeof i!="string")throw new f(l,"string",i)}const d=r.platform==="win32";function h(i){return i===o||i===a}function S(i){return i===o}function _(i){return i>=x&&i<=g||i>=M&&i<=m}function E(i,l,c,L){let w="",C=0,N=-1,y=0,R=0;for(let D=0;D<=i.length;++D){if(D<i.length)R=i.charCodeAt(D);else{if(L(R))break;R=o}if(L(R)){if(!(N===D-1||y===1))if(y===2){if(w.length<2||C!==2||w.charCodeAt(w.length-1)!==v||w.charCodeAt(w.length-2)!==v){if(w.length>2){const T=w.lastIndexOf(c);T===-1?(w="",C=0):(w=w.slice(0,T),C=w.length-1-w.lastIndexOf(c)),N=D,y=0;continue}else if(w.length!==0){w="",C=0,N=D,y=0;continue}}l&&(w+=w.length>0?`${c}..`:"..",C=2)}else w.length>0?w+=`${c}${i.slice(N+1,D)}`:w=i.slice(N+1,D),C=D-N-1;N=D,y=0}else R===v&&y!==-1?++y:y=-1}return w}function A(i,l){s(l,"pathObject");const c=l.dir||l.root,L=l.base||`${l.name||""}${l.ext||""}`;return c?c===l.root?`${c}${L}`:`${c}${i}${L}`:L}n.win32={resolve(...i){let l="",c="",L=!1;for(let w=i.length-1;w>=-1;w--){let C;if(w>=0){if(C=i[w],u(C,"path"),C.length===0)continue}else l.length===0?C=r.cwd():(C=r.env[`=${l}`]||r.cwd(),(C===void 0||C.slice(0,2).toLowerCase()!==l.toLowerCase()&&C.charCodeAt(2)===a)&&(C=`${l}\\`));const N=C.length;let y=0,R="",D=!1;const T=C.charCodeAt(0);if(N===1)h(T)&&(y=1,D=!0);else if(h(T))if(D=!0,h(C.charCodeAt(1))){let k=2,q=k;for(;k<N&&!h(C.charCodeAt(k));)k++;if(k<N&&k!==q){const H=C.slice(q,k);for(q=k;k<N&&h(C.charCodeAt(k));)k++;if(k<N&&k!==q){for(q=k;k<N&&!h(C.charCodeAt(k));)k++;(k===N||k!==q)&&(R=`\\\\${H}\\${C.slice(q,k)}`,y=k)}}}else y=1;else _(T)&&C.charCodeAt(1)===b&&(R=C.slice(0,2),y=2,N>2&&h(C.charCodeAt(2))&&(D=!0,y=3));if(R.length>0)if(l.length>0){if(R.toLowerCase()!==l.toLowerCase())continue}else l=R;if(L){if(l.length>0)break}else if(c=`${C.slice(y)}\\${c}`,L=D,D&&l.length>0)break}return c=E(c,!L,"\\",h),L?`${l}\\${c}`:`${l}${c}`||"."},normalize(i){u(i,"path");const l=i.length;if(l===0)return".";let c=0,L,w=!1;const C=i.charCodeAt(0);if(l===1)return S(C)?"\\":i;if(h(C))if(w=!0,h(i.charCodeAt(1))){let y=2,R=y;for(;y<l&&!h(i.charCodeAt(y));)y++;if(y<l&&y!==R){const D=i.slice(R,y);for(R=y;y<l&&h(i.charCodeAt(y));)y++;if(y<l&&y!==R){for(R=y;y<l&&!h(i.charCodeAt(y));)y++;if(y===l)return`\\\\${D}\\${i.slice(R)}\\`;y!==R&&(L=`\\\\${D}\\${i.slice(R,y)}`,c=y)}}}else c=1;else _(C)&&i.charCodeAt(1)===b&&(L=i.slice(0,2),c=2,l>2&&h(i.charCodeAt(2))&&(w=!0,c=3));let N=c<l?E(i.slice(c),!w,"\\",h):"";return N.length===0&&!w&&(N="."),N.length>0&&h(i.charCodeAt(l-1))&&(N+="\\"),L===void 0?w?`\\${N}`:N:w?`${L}\\${N}`:`${L}${N}`},isAbsolute(i){u(i,"path");const l=i.length;if(l===0)return!1;const c=i.charCodeAt(0);return h(c)||l>2&&_(c)&&i.charCodeAt(1)===b&&h(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let l,c;for(let C=0;C<i.length;++C){const N=i[C];u(N,"path"),N.length>0&&(l===void 0?l=c=N:l+=`\\${N}`)}if(l===void 0)return".";let L=!0,w=0;if(typeof c=="string"&&h(c.charCodeAt(0))){++w;const C=c.length;C>1&&h(c.charCodeAt(1))&&(++w,C>2&&(h(c.charCodeAt(2))?++w:L=!1))}if(L){for(;w<l.length&&h(l.charCodeAt(w));)w++;w>=2&&(l=`\\${l.slice(w)}`)}return n.win32.normalize(l)},relative(i,l){if(u(i,"from"),u(l,"to"),i===l)return"";const c=n.win32.resolve(i),L=n.win32.resolve(l);if(c===L||(i=c.toLowerCase(),l=L.toLowerCase(),i===l))return"";let w=0;for(;w<i.length&&i.charCodeAt(w)===a;)w++;let C=i.length;for(;C-1>w&&i.charCodeAt(C-1)===a;)C--;const N=C-w;let y=0;for(;y<l.length&&l.charCodeAt(y)===a;)y++;let R=l.length;for(;R-1>y&&l.charCodeAt(R-1)===a;)R--;const D=R-y,T=N<D?N:D;let k=-1,q=0;for(;q<T;q++){const Q=i.charCodeAt(w+q);if(Q!==l.charCodeAt(y+q))break;Q===a&&(k=q)}if(q!==T){if(k===-1)return L}else{if(D>T){if(l.charCodeAt(y+q)===a)return L.slice(y+q+1);if(q===2)return L.slice(y+q)}N>T&&(i.charCodeAt(w+q)===a?k=q:q===2&&(k=3)),k===-1&&(k=0)}let H="";for(q=w+k+1;q<=C;++q)(q===C||i.charCodeAt(q)===a)&&(H+=H.length===0?"..":"\\..");return y+=k,H.length>0?`${H}${L.slice(y,R)}`:(L.charCodeAt(y)===a&&++y,L.slice(y,R))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const l=n.win32.resolve(i);if(l.length<=2)return i;if(l.charCodeAt(0)===a){if(l.charCodeAt(1)===a){const c=l.charCodeAt(2);if(c!==e&&c!==v)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(_(l.charCodeAt(0))&&l.charCodeAt(1)===b&&l.charCodeAt(2)===a)return`\\\\?\\${l}`;return i},dirname(i){u(i,"path");const l=i.length;if(l===0)return".";let c=-1,L=0;const w=i.charCodeAt(0);if(l===1)return h(w)?i:".";if(h(w)){if(c=L=1,h(i.charCodeAt(1))){let y=2,R=y;for(;y<l&&!h(i.charCodeAt(y));)y++;if(y<l&&y!==R){for(R=y;y<l&&h(i.charCodeAt(y));)y++;if(y<l&&y!==R){for(R=y;y<l&&!h(i.charCodeAt(y));)y++;if(y===l)return i;y!==R&&(c=L=y+1)}}}}else _(w)&&i.charCodeAt(1)===b&&(c=l>2&&h(i.charCodeAt(2))?3:2,L=c);let C=-1,N=!0;for(let y=l-1;y>=L;--y)if(h(i.charCodeAt(y))){if(!N){C=y;break}}else N=!1;if(C===-1){if(c===-1)return".";C=c}return i.slice(0,C)},basename(i,l){l!==void 0&&u(l,"ext"),u(i,"path");let c=0,L=-1,w=!0,C;if(i.length>=2&&_(i.charCodeAt(0))&&i.charCodeAt(1)===b&&(c=2),l!==void 0&&l.length>0&&l.length<=i.length){if(l===i)return"";let N=l.length-1,y=-1;for(C=i.length-1;C>=c;--C){const R=i.charCodeAt(C);if(h(R)){if(!w){c=C+1;break}}else y===-1&&(w=!1,y=C+1),N>=0&&(R===l.charCodeAt(N)?--N===-1&&(L=C):(N=-1,L=y))}return c===L?L=y:L===-1&&(L=i.length),i.slice(c,L)}for(C=i.length-1;C>=c;--C)if(h(i.charCodeAt(C))){if(!w){c=C+1;break}}else L===-1&&(w=!1,L=C+1);return L===-1?"":i.slice(c,L)},extname(i){u(i,"path");let l=0,c=-1,L=0,w=-1,C=!0,N=0;i.length>=2&&i.charCodeAt(1)===b&&_(i.charCodeAt(0))&&(l=L=2);for(let y=i.length-1;y>=l;--y){const R=i.charCodeAt(y);if(h(R)){if(!C){L=y+1;break}continue}w===-1&&(C=!1,w=y+1),R===v?c===-1?c=y:N!==1&&(N=1):c!==-1&&(N=-1)}return c===-1||w===-1||N===0||N===1&&c===w-1&&c===L+1?"":i.slice(c,w)},format:A.bind(null,"\\"),parse(i){u(i,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return l;const c=i.length;let L=0,w=i.charCodeAt(0);if(c===1)return h(w)?(l.root=l.dir=i,l):(l.base=l.name=i,l);if(h(w)){if(L=1,h(i.charCodeAt(1))){let k=2,q=k;for(;k<c&&!h(i.charCodeAt(k));)k++;if(k<c&&k!==q){for(q=k;k<c&&h(i.charCodeAt(k));)k++;if(k<c&&k!==q){for(q=k;k<c&&!h(i.charCodeAt(k));)k++;k===c?L=k:k!==q&&(L=k+1)}}}}else if(_(w)&&i.charCodeAt(1)===b){if(c<=2)return l.root=l.dir=i,l;if(L=2,h(i.charCodeAt(2))){if(c===3)return l.root=l.dir=i,l;L=3}}L>0&&(l.root=i.slice(0,L));let C=-1,N=L,y=-1,R=!0,D=i.length-1,T=0;for(;D>=L;--D){if(w=i.charCodeAt(D),h(w)){if(!R){N=D+1;break}continue}y===-1&&(R=!1,y=D+1),w===v?C===-1?C=D:T!==1&&(T=1):C!==-1&&(T=-1)}return y!==-1&&(C===-1||T===0||T===1&&C===y-1&&C===N+1?l.base=l.name=i.slice(N,y):(l.name=i.slice(N,C),l.base=i.slice(N,y),l.ext=i.slice(C,y))),N>0&&N!==L?l.dir=i.slice(0,N-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const p=(()=>{if(d){const i=/\\/g;return()=>{const l=r.cwd().replace(i,"/");return l.slice(l.indexOf("/"))}}return()=>r.cwd()})();n.posix={resolve(...i){let l="",c=!1;for(let L=i.length-1;L>=-1&&!c;L--){const w=L>=0?i[L]:p();u(w,"path"),w.length!==0&&(l=`${w}/${l}`,c=w.charCodeAt(0)===o)}return l=E(l,!c,"/",S),c?`/${l}`:l.length>0?l:"."},normalize(i){if(u(i,"path"),i.length===0)return".";const l=i.charCodeAt(0)===o,c=i.charCodeAt(i.length-1)===o;return i=E(i,!l,"/",S),i.length===0?l?"/":c?"./":".":(c&&(i+="/"),l?`/${i}`:i)},isAbsolute(i){return u(i,"path"),i.length>0&&i.charCodeAt(0)===o},join(...i){if(i.length===0)return".";let l;for(let c=0;c<i.length;++c){const L=i[c];u(L,"path"),L.length>0&&(l===void 0?l=L:l+=`/${L}`)}return l===void 0?".":n.posix.normalize(l)},relative(i,l){if(u(i,"from"),u(l,"to"),i===l||(i=n.posix.resolve(i),l=n.posix.resolve(l),i===l))return"";const c=1,L=i.length,w=L-c,C=1,N=l.length-C,y=w<N?w:N;let R=-1,D=0;for(;D<y;D++){const k=i.charCodeAt(c+D);if(k!==l.charCodeAt(C+D))break;k===o&&(R=D)}if(D===y)if(N>y){if(l.charCodeAt(C+D)===o)return l.slice(C+D+1);if(D===0)return l.slice(C+D)}else w>y&&(i.charCodeAt(c+D)===o?R=D:D===0&&(R=0));let T="";for(D=c+R+1;D<=L;++D)(D===L||i.charCodeAt(D)===o)&&(T+=T.length===0?"..":"/..");return`${T}${l.slice(C+R)}`},toNamespacedPath(i){return i},dirname(i){if(u(i,"path"),i.length===0)return".";const l=i.charCodeAt(0)===o;let c=-1,L=!0;for(let w=i.length-1;w>=1;--w)if(i.charCodeAt(w)===o){if(!L){c=w;break}}else L=!1;return c===-1?l?"/":".":l&&c===1?"//":i.slice(0,c)},basename(i,l){l!==void 0&&u(l,"ext"),u(i,"path");let c=0,L=-1,w=!0,C;if(l!==void 0&&l.length>0&&l.length<=i.length){if(l===i)return"";let N=l.length-1,y=-1;for(C=i.length-1;C>=0;--C){const R=i.charCodeAt(C);if(R===o){if(!w){c=C+1;break}}else y===-1&&(w=!1,y=C+1),N>=0&&(R===l.charCodeAt(N)?--N===-1&&(L=C):(N=-1,L=y))}return c===L?L=y:L===-1&&(L=i.length),i.slice(c,L)}for(C=i.length-1;C>=0;--C)if(i.charCodeAt(C)===o){if(!w){c=C+1;break}}else L===-1&&(w=!1,L=C+1);return L===-1?"":i.slice(c,L)},extname(i){u(i,"path");let l=-1,c=0,L=-1,w=!0,C=0;for(let N=i.length-1;N>=0;--N){const y=i.charCodeAt(N);if(y===o){if(!w){c=N+1;break}continue}L===-1&&(w=!1,L=N+1),y===v?l===-1?l=N:C!==1&&(C=1):l!==-1&&(C=-1)}return l===-1||L===-1||C===0||C===1&&l===L-1&&l===c+1?"":i.slice(l,L)},format:A.bind(null,"/"),parse(i){u(i,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return l;const c=i.charCodeAt(0)===o;let L;c?(l.root="/",L=1):L=0;let w=-1,C=0,N=-1,y=!0,R=i.length-1,D=0;for(;R>=L;--R){const T=i.charCodeAt(R);if(T===o){if(!y){C=R+1;break}continue}N===-1&&(y=!1,N=R+1),T===v?w===-1?w=R:D!==1&&(D=1):w!==-1&&(D=-1)}if(N!==-1){const T=C===0&&c?1:C;w===-1||D===0||D===1&&w===N-1&&w===C+1?l.base=l.name=i.slice(T,N):(l.name=i.slice(T,w),l.base=i.slice(T,N),l.ext=i.slice(w,N))}return C>0?l.dir=i.slice(0,C-1):c&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=d?n.win32.normalize:n.posix.normalize,n.resolve=d?n.win32.resolve:n.posix.resolve,n.relative=d?n.win32.relative:n.posix.relative,n.dirname=d?n.win32.dirname:n.posix.dirname,n.basename=d?n.win32.basename:n.posix.basename,n.extname=d?n.win32.extname:n.posix.extname,n.sep=d?n.win32.sep:n.posix.sep}),Y(X[18],Z([0,1,66,17]),function(O,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.URI=void 0,n.uriToFsPath=E;const M=/^\w[\w\d+.-]*$/,g=/^\//,m=/^\/\//;function v(c,L){if(!c.scheme&&L)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${c.authority}", path: "${c.path}", query: "${c.query}", fragment: "${c.fragment}"}`);if(c.scheme&&!M.test(c.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(c.path){if(c.authority){if(!g.test(c.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(m.test(c.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function o(c,L){return!c&&!L?"file":c}function a(c,L){switch(c){case"https":case"http":case"file":L?L[0]!==e&&(L=e+L):L=e;break}return L}const b="",e="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class s{static isUri(L){return L instanceof s?!0:L?typeof L.authority=="string"&&typeof L.fragment=="string"&&typeof L.path=="string"&&typeof L.query=="string"&&typeof L.scheme=="string"&&typeof L.fsPath=="string"&&typeof L.with=="function"&&typeof L.toString=="function":!1}constructor(L,w,C,N,y,R=!1){typeof L=="object"?(this.scheme=L.scheme||b,this.authority=L.authority||b,this.path=L.path||b,this.query=L.query||b,this.fragment=L.fragment||b):(this.scheme=o(L,R),this.authority=w||b,this.path=a(this.scheme,C||b),this.query=N||b,this.fragment=y||b,v(this,R))}get fsPath(){return E(this,!1)}with(L){if(!L)return this;let{scheme:w,authority:C,path:N,query:y,fragment:R}=L;return w===void 0?w=this.scheme:w===null&&(w=b),C===void 0?C=this.authority:C===null&&(C=b),N===void 0?N=this.path:N===null&&(N=b),y===void 0?y=this.query:y===null&&(y=b),R===void 0?R=this.fragment:R===null&&(R=b),w===this.scheme&&C===this.authority&&N===this.path&&y===this.query&&R===this.fragment?this:new d(w,C,N,y,R)}static parse(L,w=!1){const C=f.exec(L);return C?new d(C[2]||b,l(C[4]||b),l(C[5]||b),l(C[7]||b),l(C[9]||b),w):new d(b,b,b,b,b)}static file(L){let w=b;if(x.isWindows&&(L=L.replace(/\\/g,e)),L[0]===e&&L[1]===e){const C=L.indexOf(e,2);C===-1?(w=L.substring(2),L=e):(w=L.substring(2,C),L=L.substring(C)||e)}return new d("file",w,L,b,b)}static from(L,w){return new d(L.scheme,L.authority,L.path,L.query,L.fragment,w)}static joinPath(L,...w){if(!L.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let C;return x.isWindows&&L.scheme==="file"?C=s.file(r.win32.join(E(L,!0),...w)).path:C=r.posix.join(L.path,...w),L.with({path:C})}toString(L=!1){return A(this,L)}toJSON(){return this}static revive(L){var w,C;if(L){if(L instanceof s)return L;{const N=new d(L);return N._formatted=(w=L.external)!==null&&w!==void 0?w:null,N._fsPath=L._sep===u&&(C=L.fsPath)!==null&&C!==void 0?C:null,N}}else return L}}n.URI=s;const u=x.isWindows?1:void 0;class d extends s{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(L=!1){return L?A(this,!0):(this._formatted||(this._formatted=A(this,!1)),this._formatted)}toJSON(){const L={$mid:1};return this._fsPath&&(L.fsPath=this._fsPath,L._sep=u),this._formatted&&(L.external=this._formatted),this.path&&(L.path=this.path),this.scheme&&(L.scheme=this.scheme),this.authority&&(L.authority=this.authority),this.query&&(L.query=this.query),this.fragment&&(L.fragment=this.fragment),L}}const h={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function S(c,L,w){let C,N=-1;for(let y=0;y<c.length;y++){const R=c.charCodeAt(y);if(R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57||R===45||R===46||R===95||R===126||L&&R===47||w&&R===91||w&&R===93||w&&R===58)N!==-1&&(C+=encodeURIComponent(c.substring(N,y)),N=-1),C!==void 0&&(C+=c.charAt(y));else{C===void 0&&(C=c.substr(0,y));const D=h[R];D!==void 0?(N!==-1&&(C+=encodeURIComponent(c.substring(N,y)),N=-1),C+=D):N===-1&&(N=y)}}return N!==-1&&(C+=encodeURIComponent(c.substring(N))),C!==void 0?C:c}function _(c){let L;for(let w=0;w<c.length;w++){const C=c.charCodeAt(w);C===35||C===63?(L===void 0&&(L=c.substr(0,w)),L+=h[C]):L!==void 0&&(L+=c[w])}return L!==void 0?L:c}function E(c,L){let w;return c.authority&&c.path.length>1&&c.scheme==="file"?w=`//${c.authority}${c.path}`:c.path.charCodeAt(0)===47&&(c.path.charCodeAt(1)>=65&&c.path.charCodeAt(1)<=90||c.path.charCodeAt(1)>=97&&c.path.charCodeAt(1)<=122)&&c.path.charCodeAt(2)===58?L?w=c.path.substr(1):w=c.path[1].toLowerCase()+c.path.substr(2):w=c.path,x.isWindows&&(w=w.replace(/\//g,"\\")),w}function A(c,L){const w=L?_:S;let C="",{scheme:N,authority:y,path:R,query:D,fragment:T}=c;if(N&&(C+=N,C+=":"),(y||N==="file")&&(C+=e,C+=e),y){let k=y.indexOf("@");if(k!==-1){const q=y.substr(0,k);y=y.substr(k+1),k=q.lastIndexOf(":"),k===-1?C+=w(q,!1,!1):(C+=w(q.substr(0,k),!1,!1),C+=":",C+=w(q.substr(k+1),!1,!0)),C+="@"}y=y.toLowerCase(),k=y.lastIndexOf(":"),k===-1?C+=w(y,!1,!0):(C+=w(y.substr(0,k),!1,!0),C+=y.substr(k))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const k=R.charCodeAt(1);k>=65&&k<=90&&(R=`/${String.fromCharCode(k+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const k=R.charCodeAt(0);k>=65&&k<=90&&(R=`${String.fromCharCode(k+32)}:${R.substr(2)}`)}C+=w(R,!0,!1)}return D&&(C+="?",C+=w(D,!1,!1)),T&&(C+="#",C+=L?T:S(T,!1,!1)),C}function p(c){try{return decodeURIComponent(c)}catch{return c.length>3?c.substr(0,3)+p(c.substr(3)):c}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(c){return c.match(i)?c.replace(i,L=>p(L)):c}}),Y(X[70],Z([0,1,5,9,13,14,17,6]),function(O,n,r,x,M,g,m,v){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.SimpleWorkerServer=n.SimpleWorkerClient=void 0,n.logOnceWebWorkerWarning=b,n.create=i;const o="$initialize";let a=!1;function b(l){m.isWeb&&(a||(a=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(l.message))}class e{constructor(c,L,w,C){this.vsWorker=c,this.req=L,this.method=w,this.args=C,this.type=0}}class f{constructor(c,L,w,C){this.vsWorker=c,this.seq=L,this.res=w,this.err=C,this.type=1}}class s{constructor(c,L,w,C){this.vsWorker=c,this.req=L,this.eventName=w,this.arg=C,this.type=2}}class u{constructor(c,L,w){this.vsWorker=c,this.req=L,this.event=w,this.type=3}}class d{constructor(c,L){this.vsWorker=c,this.req=L,this.type=4}}class h{constructor(c){this._workerId=-1,this._handler=c,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(c){this._workerId=c}sendMessage(c,L){const w=String(++this._lastSentReq);return new Promise((C,N)=>{this._pendingReplies[w]={resolve:C,reject:N},this._send(new e(this._workerId,w,c,L))})}listen(c,L){let w=null;const C=new x.Emitter({onWillAddFirstListener:()=>{w=String(++this._lastSentReq),this._pendingEmitters.set(w,C),this._send(new s(this._workerId,w,c,L))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(w),this._send(new d(this._workerId,w)),w=null}});return C.event}handleMessage(c){!c||!c.vsWorker||this._workerId!==-1&&c.vsWorker!==this._workerId||this._handleMessage(c)}_handleMessage(c){switch(c.type){case 1:return this._handleReplyMessage(c);case 0:return this._handleRequestMessage(c);case 2:return this._handleSubscribeEventMessage(c);case 3:return this._handleEventMessage(c);case 4:return this._handleUnsubscribeEventMessage(c)}}_handleReplyMessage(c){if(!this._pendingReplies[c.seq]){console.warn("Got reply to unknown seq");return}const L=this._pendingReplies[c.seq];if(delete this._pendingReplies[c.seq],c.err){let w=c.err;c.err.$isError&&(w=new Error,w.name=c.err.name,w.message=c.err.message,w.stack=c.err.stack),L.reject(w);return}L.resolve(c.res)}_handleRequestMessage(c){const L=c.req;this._handler.handleMessage(c.method,c.args).then(C=>{this._send(new f(this._workerId,L,C,void 0))},C=>{C.detail instanceof Error&&(C.detail=(0,r.transformErrorForSerialization)(C.detail)),this._send(new f(this._workerId,L,void 0,(0,r.transformErrorForSerialization)(C)))})}_handleSubscribeEventMessage(c){const L=c.req,w=this._handler.handleEvent(c.eventName,c.arg)(C=>{this._send(new u(this._workerId,L,C))});this._pendingEvents.set(L,w)}_handleEventMessage(c){if(!this._pendingEmitters.has(c.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(c.req).fire(c.event)}_handleUnsubscribeEventMessage(c){if(!this._pendingEvents.has(c.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(c.req).dispose(),this._pendingEvents.delete(c.req)}_send(c){const L=[];if(c.type===0)for(let w=0;w<c.args.length;w++)c.args[w]instanceof ArrayBuffer&&L.push(c.args[w]);else c.type===1&&c.res instanceof ArrayBuffer&&L.push(c.res);this._handler.sendMessage(c,L)}}class S extends M.Disposable{constructor(c,L,w){super();let C=null;this._worker=this._register(c.create("vs/base/common/worker/simpleWorker",k=>{this._protocol.handleMessage(k)},k=>{C?.(k)})),this._protocol=new h({sendMessage:(k,q)=>{this._worker.postMessage(k,q)},handleMessage:(k,q)=>{if(typeof w[k]!="function")return Promise.reject(new Error("Missing method "+k+" on main thread host."));try{return Promise.resolve(w[k].apply(w,q))}catch(H){return Promise.reject(H)}},handleEvent:(k,q)=>{if(E(k)){const H=w[k].call(w,q);if(typeof H!="function")throw new Error(`Missing dynamic event ${k} on main thread host.`);return H}if(_(k)){const H=w[k];if(typeof H!="function")throw new Error(`Missing event ${k} on main thread host.`);return H}throw new Error(`Malformed event name ${k}`)}}),this._protocol.setWorkerId(this._worker.getId());let N=null;const y=globalThis.require;typeof y<"u"&&typeof y.getConfig=="function"?N=y.getConfig():typeof globalThis.requirejs<"u"&&(N=globalThis.requirejs.s.contexts._.config);const R=(0,g.getAllMethodNames)(w);this._onModuleLoaded=this._protocol.sendMessage(o,[this._worker.getId(),JSON.parse(JSON.stringify(N)),L,R]);const D=(k,q)=>this._request(k,q),T=(k,q)=>this._protocol.listen(k,q);this._lazyProxy=new Promise((k,q)=>{C=q,this._onModuleLoaded.then(H=>{k(A(H,D,T))},H=>{q(H),this._onError("Worker failed to load "+L,H)})})}getProxyObject(){return this._lazyProxy}_request(c,L){return new Promise((w,C)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(c,L).then(w,C)},C)})}_onError(c,L){console.error(c),console.info(L)}}n.SimpleWorkerClient=S;function _(l){return l[0]==="o"&&l[1]==="n"&&v.isUpperAsciiLetter(l.charCodeAt(2))}function E(l){return/^onDynamic/.test(l)&&v.isUpperAsciiLetter(l.charCodeAt(9))}function A(l,c,L){const w=y=>function(){const R=Array.prototype.slice.call(arguments,0);return c(y,R)},C=y=>function(R){return L(y,R)},N={};for(const y of l){if(E(y)){N[y]=C(y);continue}if(_(y)){N[y]=L(y,void 0);continue}N[y]=w(y)}return N}class p{constructor(c,L){this._requestHandlerFactory=L,this._requestHandler=null,this._protocol=new h({sendMessage:(w,C)=>{c(w,C)},handleMessage:(w,C)=>this._handleMessage(w,C),handleEvent:(w,C)=>this._handleEvent(w,C)})}onmessage(c){this._protocol.handleMessage(c)}_handleMessage(c,L){if(c===o)return this.initialize(L[0],L[1],L[2],L[3]);if(!this._requestHandler||typeof this._requestHandler[c]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+c));try{return Promise.resolve(this._requestHandler[c].apply(this._requestHandler,L))}catch(w){return Promise.reject(w)}}_handleEvent(c,L){if(!this._requestHandler)throw new Error("Missing requestHandler");if(E(c)){const w=this._requestHandler[c].call(this._requestHandler,L);if(typeof w!="function")throw new Error(`Missing dynamic event ${c} on request handler.`);return w}if(_(c)){const w=this._requestHandler[c];if(typeof w!="function")throw new Error(`Missing event ${c} on request handler.`);return w}throw new Error(`Malformed event name ${c}`)}initialize(c,L,w,C){this._protocol.setWorkerId(c);const R=A(C,(D,T)=>this._protocol.sendMessage(D,T),(D,T)=>this._protocol.listen(D,T));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(R),Promise.resolve((0,g.getAllMethodNames)(this._requestHandler))):(L&&(typeof L.baseUrl<"u"&&delete L.baseUrl,typeof L.paths<"u"&&typeof L.paths.vs<"u"&&delete L.paths.vs,typeof L.trustedTypesPolicy<"u"&&delete L.trustedTypesPolicy,L.catchError=!0,globalThis.require.config(L)),new Promise((D,T)=>{(globalThis.require||O)([w],q=>{if(this._requestHandler=q.create(R),!this._requestHandler){T(new Error("No RequestHandler!"));return}D((0,g.getAllMethodNames)(this._requestHandler))},T)}))}}n.SimpleWorkerServer=p;function i(l){return new p(l,null)}}),Y(X[67],Z([19,64]),function(O,n){return O.create("vs/editor/common/languages",n)}),Y(X[68],Z([0,1,42,18,2,62,67]),function(O,n,r,x,M,g,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.InlineEditTriggerKind=n.TokenizationRegistry=n.LazyTokenizationSupport=n.InlayHintKind=n.Command=n.NewSymbolNameTag=n.FoldingRangeKind=n.TextEdit=n.SymbolKinds=n.symbolKindNames=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.DocumentPasteTriggerKind=n.SelectedSuggestionInfo=n.InlineCompletionTriggerKind=n.CompletionItemKinds=n.HoverVerbosityAction=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0,n.isLocationLink=S,n.getAriaLabelForSymbol=_;class v{constructor(N,y,R){this.offset=N,this.type=y,this.language=R,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=v;class o{constructor(N,y){this.tokens=N,this.endState=y,this._tokenizationResultBrand=void 0}}n.TokenizationResult=o;class a{constructor(N,y){this.tokens=N,this.endState=y,this._encodedTokenizationResultBrand=void 0}}n.EncodedTokenizationResult=a;var b;(function(C){C[C.Increase=0]="Increase",C[C.Decrease=1]="Decrease"})(b||(n.HoverVerbosityAction=b={}));var e;(function(C){const N=new Map;N.set(0,r.Codicon.symbolMethod),N.set(1,r.Codicon.symbolFunction),N.set(2,r.Codicon.symbolConstructor),N.set(3,r.Codicon.symbolField),N.set(4,r.Codicon.symbolVariable),N.set(5,r.Codicon.symbolClass),N.set(6,r.Codicon.symbolStruct),N.set(7,r.Codicon.symbolInterface),N.set(8,r.Codicon.symbolModule),N.set(9,r.Codicon.symbolProperty),N.set(10,r.Codicon.symbolEvent),N.set(11,r.Codicon.symbolOperator),N.set(12,r.Codicon.symbolUnit),N.set(13,r.Codicon.symbolValue),N.set(15,r.Codicon.symbolEnum),N.set(14,r.Codicon.symbolConstant),N.set(15,r.Codicon.symbolEnum),N.set(16,r.Codicon.symbolEnumMember),N.set(17,r.Codicon.symbolKeyword),N.set(27,r.Codicon.symbolSnippet),N.set(18,r.Codicon.symbolText),N.set(19,r.Codicon.symbolColor),N.set(20,r.Codicon.symbolFile),N.set(21,r.Codicon.symbolReference),N.set(22,r.Codicon.symbolCustomColor),N.set(23,r.Codicon.symbolFolder),N.set(24,r.Codicon.symbolTypeParameter),N.set(25,r.Codicon.account),N.set(26,r.Codicon.issues);function y(T){let k=N.get(T);return k||(console.info("No codicon found for CompletionItemKind "+T),k=r.Codicon.symbolProperty),k}C.toIcon=y;const R=new Map;R.set("method",0),R.set("function",1),R.set("constructor",2),R.set("field",3),R.set("variable",4),R.set("class",5),R.set("struct",6),R.set("interface",7),R.set("module",8),R.set("property",9),R.set("event",10),R.set("operator",11),R.set("unit",12),R.set("value",13),R.set("constant",14),R.set("enum",15),R.set("enum-member",16),R.set("enumMember",16),R.set("keyword",17),R.set("snippet",27),R.set("text",18),R.set("color",19),R.set("file",20),R.set("reference",21),R.set("customcolor",22),R.set("folder",23),R.set("type-parameter",24),R.set("typeParameter",24),R.set("account",25),R.set("issue",26);function D(T,k){let q=R.get(T);return typeof q>"u"&&!k&&(q=9),q}C.fromString=D})(e||(n.CompletionItemKinds=e={}));var f;(function(C){C[C.Automatic=0]="Automatic",C[C.Explicit=1]="Explicit"})(f||(n.InlineCompletionTriggerKind=f={}));class s{constructor(N,y,R,D){this.range=N,this.text=y,this.completionKind=R,this.isSnippetText=D}equals(N){return M.Range.lift(this.range).equalsRange(N.range)&&this.text===N.text&&this.completionKind===N.completionKind&&this.isSnippetText===N.isSnippetText}}n.SelectedSuggestionInfo=s;var u;(function(C){C[C.Automatic=0]="Automatic",C[C.PasteAs=1]="PasteAs"})(u||(n.DocumentPasteTriggerKind=u={}));var d;(function(C){C[C.Invoke=1]="Invoke",C[C.TriggerCharacter=2]="TriggerCharacter",C[C.ContentChange=3]="ContentChange"})(d||(n.SignatureHelpTriggerKind=d={}));var h;(function(C){C[C.Text=0]="Text",C[C.Read=1]="Read",C[C.Write=2]="Write"})(h||(n.DocumentHighlightKind=h={}));function S(C){return C&&x.URI.isUri(C.uri)&&M.Range.isIRange(C.range)&&(M.Range.isIRange(C.originSelectionRange)||M.Range.isIRange(C.targetSelectionRange))}n.symbolKindNames={17:(0,m.localize)(0,null),16:(0,m.localize)(1,null),4:(0,m.localize)(2,null),13:(0,m.localize)(3,null),8:(0,m.localize)(4,null),9:(0,m.localize)(5,null),21:(0,m.localize)(6,null),23:(0,m.localize)(7,null),7:(0,m.localize)(8,null),0:(0,m.localize)(9,null),11:(0,m.localize)(10,null),10:(0,m.localize)(11,null),19:(0,m.localize)(12,null),5:(0,m.localize)(13,null),1:(0,m.localize)(14,null),2:(0,m.localize)(15,null),20:(0,m.localize)(16,null),15:(0,m.localize)(17,null),18:(0,m.localize)(18,null),24:(0,m.localize)(19,null),3:(0,m.localize)(20,null),6:(0,m.localize)(21,null),14:(0,m.localize)(22,null),22:(0,m.localize)(23,null),25:(0,m.localize)(24,null),12:(0,m.localize)(25,null)};function _(C,N){return(0,m.localize)(26,null,C,n.symbolKindNames[N])}var E;(function(C){const N=new Map;N.set(0,r.Codicon.symbolFile),N.set(1,r.Codicon.symbolModule),N.set(2,r.Codicon.symbolNamespace),N.set(3,r.Codicon.symbolPackage),N.set(4,r.Codicon.symbolClass),N.set(5,r.Codicon.symbolMethod),N.set(6,r.Codicon.symbolProperty),N.set(7,r.Codicon.symbolField),N.set(8,r.Codicon.symbolConstructor),N.set(9,r.Codicon.symbolEnum),N.set(10,r.Codicon.symbolInterface),N.set(11,r.Codicon.symbolFunction),N.set(12,r.Codicon.symbolVariable),N.set(13,r.Codicon.symbolConstant),N.set(14,r.Codicon.symbolString),N.set(15,r.Codicon.symbolNumber),N.set(16,r.Codicon.symbolBoolean),N.set(17,r.Codicon.symbolArray),N.set(18,r.Codicon.symbolObject),N.set(19,r.Codicon.symbolKey),N.set(20,r.Codicon.symbolNull),N.set(21,r.Codicon.symbolEnumMember),N.set(22,r.Codicon.symbolStruct),N.set(23,r.Codicon.symbolEvent),N.set(24,r.Codicon.symbolOperator),N.set(25,r.Codicon.symbolTypeParameter);function y(R){let D=N.get(R);return D||(console.info("No codicon found for SymbolKind "+R),D=r.Codicon.symbolProperty),D}C.toIcon=y})(E||(n.SymbolKinds=E={}));class A{}n.TextEdit=A;class p{static fromValue(N){switch(N){case"comment":return p.Comment;case"imports":return p.Imports;case"region":return p.Region}return new p(N)}constructor(N){this.value=N}}n.FoldingRangeKind=p,p.Comment=new p("comment"),p.Imports=new p("imports"),p.Region=new p("region");var i;(function(C){C[C.AIGenerated=1]="AIGenerated"})(i||(n.NewSymbolNameTag=i={}));var l;(function(C){function N(y){return!y||typeof y!="object"?!1:typeof y.id=="string"&&typeof y.title=="string"}C.is=N})(l||(n.Command=l={}));var c;(function(C){C[C.Type=1]="Type",C[C.Parameter=2]="Parameter"})(c||(n.InlayHintKind=c={}));class L{constructor(N){this.createSupport=N,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(N=>{N&&N.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}n.LazyTokenizationSupport=L,n.TokenizationRegistry=new g.TokenizationRegistry;var w;(function(C){C[C.Invoke=0]="Invoke",C[C.Automatic=1]="Automatic"})(w||(n.InlineEditTriggerKind=w={}))}),Y(X[69],Z([0,1,39,9,37,18,4,2,43,68,61]),function(O,n,r,x,M,g,m,v,o,a,b){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyMod=void 0,n.createMonacoBaseAPI=f;class e{static chord(u,d){return(0,M.KeyChord)(u,d)}}n.KeyMod=e,e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256;function f(){return{editor:void 0,languages:void 0,CancellationTokenSource:r.CancellationTokenSource,Emitter:x.Emitter,KeyCode:b.KeyCode,KeyMod:e,Position:m.Position,Range:v.Range,Selection:o.Selection,SelectionDirection:b.SelectionDirection,MarkerSeverity:b.MarkerSeverity,MarkerTag:b.MarkerTag,Uri:g.URI,Token:a.Token}}}),Y(X[71],Z([0,1,25,18,4,2,57,30,53,54,69,24,60,51,14,52,59]),function(O,n,r,x,M,g,m,v,o,a,b,e,f,s,u,d,h){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.EditorSimpleWorker=void 0,n.create=E;class S extends m.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(p){const i=[];for(let l=0;l<this._lines.length;l++){const c=this._lines[l],L=this.offsetAt(new M.Position(l+1,1)),w=c.matchAll(p);for(const C of w)(C.index||C.index===0)&&(C.index=C.index+L),i.push(C)}return i}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(p){return this._lines[p-1]}getWordAtPosition(p,i){const l=(0,v.getWordAtText)(p.column,(0,v.ensureValidWordDefinition)(i),this._lines[p.lineNumber-1],0);return l?new g.Range(p.lineNumber,l.startColumn,p.lineNumber,l.endColumn):null}words(p){const i=this._lines,l=this._wordenize.bind(this);let c=0,L="",w=0,C=[];return{*[Symbol.iterator](){for(;;)if(w<C.length){const N=L.substring(C[w].start,C[w].end);w+=1,yield N}else if(c<i.length)L=i[c],C=l(L,p),w=0,c+=1;else break}}}getLineWords(p,i){const l=this._lines[p-1],c=this._wordenize(l,i),L=[];for(const w of c)L.push({word:l.substring(w.start,w.end),startColumn:w.start+1,endColumn:w.end+1});return L}_wordenize(p,i){const l=[];let c;for(i.lastIndex=0;(c=i.exec(p))&&c[0].length!==0;)l.push({start:c.index,end:c.index+c[0].length});return l}getValueInRange(p){if(p=this._validateRange(p),p.startLineNumber===p.endLineNumber)return this._lines[p.startLineNumber-1].substring(p.startColumn-1,p.endColumn-1);const i=this._eol,l=p.startLineNumber-1,c=p.endLineNumber-1,L=[];L.push(this._lines[l].substring(p.startColumn-1));for(let w=l+1;w<c;w++)L.push(this._lines[w]);return L.push(this._lines[c].substring(0,p.endColumn-1)),L.join(i)}offsetAt(p){return p=this._validatePosition(p),this._ensureLineStarts(),this._lineStarts.getPrefixSum(p.lineNumber-2)+(p.column-1)}positionAt(p){p=Math.floor(p),p=Math.max(0,p),this._ensureLineStarts();const i=this._lineStarts.getIndexOf(p),l=this._lines[i.index].length;return{lineNumber:1+i.index,column:1+Math.min(i.remainder,l)}}_validateRange(p){const i=this._validatePosition({lineNumber:p.startLineNumber,column:p.startColumn}),l=this._validatePosition({lineNumber:p.endLineNumber,column:p.endColumn});return i.lineNumber!==p.startLineNumber||i.column!==p.startColumn||l.lineNumber!==p.endLineNumber||l.column!==p.endColumn?{startLineNumber:i.lineNumber,startColumn:i.column,endLineNumber:l.lineNumber,endColumn:l.column}:p}_validatePosition(p){if(!M.Position.isIPosition(p))throw new Error("bad position");let{lineNumber:i,column:l}=p,c=!1;if(i<1)i=1,l=1,c=!0;else if(i>this._lines.length)i=this._lines.length,l=this._lines[i-1].length+1,c=!0;else{const L=this._lines[i-1].length+1;l<1?(l=1,c=!0):l>L&&(l=L,c=!0)}return c?{lineNumber:i,column:l}:p}}class _{constructor(p,i){this._host=p,this._models=Object.create(null),this._foreignModuleFactory=i,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(p){return this._models[p]}_getModels(){const p=[];return Object.keys(this._models).forEach(i=>p.push(this._models[i])),p}acceptNewModel(p){this._models[p.url]=new S(x.URI.parse(p.url),p.lines,p.EOL,p.versionId)}acceptModelChanged(p,i){if(!this._models[p])return;this._models[p].onEvents(i)}acceptRemovedModel(p){this._models[p]&&delete this._models[p]}async computeUnicodeHighlights(p,i,l){const c=this._getModel(p);return c?f.UnicodeTextModelHighlighter.computeUnicodeHighlights(c,i,l):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async findSectionHeaders(p,i){const l=this._getModel(p);return l?(0,h.findSectionHeaders)(l,i):[]}async computeDiff(p,i,l,c){const L=this._getModel(p),w=this._getModel(i);return!L||!w?null:_.computeDiff(L,w,l,c)}static computeDiff(p,i,l,c){const L=c==="advanced"?s.linesDiffComputers.getDefault():s.linesDiffComputers.getLegacy(),w=p.getLinesContent(),C=i.getLinesContent(),N=L.computeDiff(w,C,l),y=N.changes.length>0?!1:this._modelsAreIdentical(p,i);function R(D){return D.map(T=>{var k;return[T.original.startLineNumber,T.original.endLineNumberExclusive,T.modified.startLineNumber,T.modified.endLineNumberExclusive,(k=T.innerChanges)===null||k===void 0?void 0:k.map(q=>[q.originalRange.startLineNumber,q.originalRange.startColumn,q.originalRange.endLineNumber,q.originalRange.endColumn,q.modifiedRange.startLineNumber,q.modifiedRange.startColumn,q.modifiedRange.endLineNumber,q.modifiedRange.endColumn])]})}return{identical:y,quitEarly:N.hitTimeout,changes:R(N.changes),moves:N.moves.map(D=>[D.lineRangeMapping.original.startLineNumber,D.lineRangeMapping.original.endLineNumberExclusive,D.lineRangeMapping.modified.startLineNumber,D.lineRangeMapping.modified.endLineNumberExclusive,R(D.changes)])}}static _modelsAreIdentical(p,i){const l=p.getLineCount(),c=i.getLineCount();if(l!==c)return!1;for(let L=1;L<=l;L++){const w=p.getLineContent(L),C=i.getLineContent(L);if(w!==C)return!1}return!0}async computeMoreMinimalEdits(p,i,l){const c=this._getModel(p);if(!c)return i;const L=[];let w;i=i.slice(0).sort((N,y)=>{if(N.range&&y.range)return g.Range.compareRangesUsingStarts(N.range,y.range);const R=N.range?0:1,D=y.range?0:1;return R-D});let C=0;for(let N=1;N<i.length;N++)g.Range.getEndPosition(i[C].range).equals(g.Range.getStartPosition(i[N].range))?(i[C].range=g.Range.fromPositions(g.Range.getStartPosition(i[C].range),g.Range.getEndPosition(i[N].range)),i[C].text+=i[N].text):(C++,i[C]=i[N]);i.length=C+1;for(let{range:N,text:y,eol:R}of i){if(typeof R=="number"&&(w=R),g.Range.isEmpty(N)&&!y)continue;const D=c.getValueInRange(N);if(y=y.replace(/\r\n|\n|\r/g,c.eol),D===y)continue;if(Math.max(y.length,D.length)>_._diffLimit){L.push({range:N,text:y});continue}const T=(0,r.stringDiff)(D,y,l),k=c.offsetAt(g.Range.lift(N).getStartPosition());for(const q of T){const H=c.positionAt(k+q.originalStart),Q=c.positionAt(k+q.originalStart+q.originalLength),F={text:y.substr(q.modifiedStart,q.modifiedLength),range:{startLineNumber:H.lineNumber,startColumn:H.column,endLineNumber:Q.lineNumber,endColumn:Q.column}};c.getValueInRange(F.range)!==F.text&&L.push(F)}}return typeof w=="number"&&L.push({eol:w,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),L}async computeLinks(p){const i=this._getModel(p);return i?(0,o.computeLinks)(i):null}async computeDefaultDocumentColors(p){const i=this._getModel(p);return i?(0,d.computeDefaultDocumentColors)(i):null}async textualSuggest(p,i,l,c){const L=new e.StopWatch,w=new RegExp(l,c),C=new Set;e:for(const N of p){const y=this._getModel(N);if(y){for(const R of y.words(w))if(!(R===i||!isNaN(Number(R)))&&(C.add(R),C.size>_._suggestionsLimit))break e}}return{words:Array.from(C),duration:L.elapsed()}}async computeWordRanges(p,i,l,c){const L=this._getModel(p);if(!L)return Object.create(null);const w=new RegExp(l,c),C=Object.create(null);for(let N=i.startLineNumber;N<i.endLineNumber;N++){const y=L.getLineWords(N,w);for(const R of y){if(!isNaN(Number(R.word)))continue;let D=C[R.word];D||(D=[],C[R.word]=D),D.push({startLineNumber:N,startColumn:R.startColumn,endLineNumber:N,endColumn:R.endColumn})}}return C}async navigateValueSet(p,i,l,c,L){const w=this._getModel(p);if(!w)return null;const C=new RegExp(c,L);i.startColumn===i.endColumn&&(i={startLineNumber:i.startLineNumber,startColumn:i.startColumn,endLineNumber:i.endLineNumber,endColumn:i.endColumn+1});const N=w.getValueInRange(i),y=w.getWordAtPosition({lineNumber:i.startLineNumber,column:i.startColumn},C);if(!y)return null;const R=w.getValueInRange(y);return a.BasicInplaceReplace.INSTANCE.navigateValueSet(i,N,y,R,l)}loadForeignModule(p,i,l){const c=(C,N)=>this._host.fhr(C,N),w={host:(0,u.createProxyObject)(l,c),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(w,i),Promise.resolve((0,u.getAllMethodNames)(this._foreignModule))):new Promise((C,N)=>{O([p],y=>{this._foreignModule=y.create(w,i),C((0,u.getAllMethodNames)(this._foreignModule))},N)})}fmr(p,i){if(!this._foreignModule||typeof this._foreignModule[p]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+p));try{return Promise.resolve(this._foreignModule[p].apply(this._foreignModule,i))}catch(l){return Promise.reject(l)}}}n.EditorSimpleWorker=_,_._diffLimit=1e5,_._suggestionsLimit=1e4;function E(A){return new _(A,null)}typeof importScripts=="function"&&(globalThis.monaco=(0,b.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map